<?php
/**
 * 歪歪框架模型类文件
 * @author mqq
 * 
 */
class Model extends SampleModel{
	/**数据库真实表名*/
	public $DOXCXSYS_real_tablename;
	/**
	 * DB类的引用
	 * @var DB
	 */
	public $DOXCXSYS_db = null;
	/**排序方式*/
	public $DOXCXSYS_order = null;
	/**查询范围*/
	public $DOXCXSYS_limit = null;
	/**要查询的字段 默认为‘*’*/
	public $DOXCXSYS_select = '*';
	/**要查询的条件可以为数组和字符串‘*’*/
	public $DOXCXSYS_condition = null;
	/**要查询的条件参数‘*’*/
	public $DOXCXSYS_pam = null;
	/**
	 * 设置这个Model的标识id<br/>
	 * 只是设置主键字段,不执行实际的DB查询操作<br/>
	 * 一般在更新或删除之前调用
	 * @param string $id 主键
	 * @return Model 模型本身
	 */
	public function id($id){
		$this->id = $id;
		return $this;
	}
	/**
	 * 根据id或者数组条件填充这个model<br/>
	 * 示例: find(5) 或 find(array('name'=>'mqq','sex'=>'man'))
	 * @param mixed $id 主键或条件数组
	 * @param array $pam 参数值的数组
	 * @return Model 模型本身
	 */
	public function find($id=null,$pam=null){
		$fillok = false;
		DBDes::init_by_model($this,'R');
		if($id === null){
			$fillok = $this->DOXCXSYS_db->fill_one_model($this,$this->DOXCXSYS_condition,null,$this->DOXCXSYS_order,'1');
		}elseif(is_array($id)||$pam!==null){
			$fillok = $this->DOXCXSYS_db->fill_one_model($this,$id,$pam);
		}else{
			$fillok = $this->DOXCXSYS_db->fill_one_model($this,"id='$id'");	
		}
		if($fillok&&!$this->DOXCXSYS_isorgin){
			$this->fill_virtual_field();
		}
		return $this;	
	}
	
	/**
	 * 判断该模型是否含有ID<br/>
	 * 查看数据库中是否有独立的一条数据与model对应
	 * @return boolean 
	 */
	public function has_id(){
		return trim($this->id) != '';
	}

	/**
	 * 查询并返回模型结果集<br/>
	 * 如果$condition为数组则根据数组条件返回符合结果的列表<br/>
	 * 如果$condition是字串则必须是 where语句之后的字串，亦可通过?和$pam数组组合成SQL语句<br/>
	 * 如果不传入条件则根据where方法 的预设参数查询,如果where未被调用过则列出所有<br/>
	 * @param mixed $condition 条件字符串或条件数组
	 * @param array $pam 参数数组
	 * @return array Model实体的集合
	 */
	public function list_all($condition=null,$pam=null){
		DBDes::init_by_model($this,'R');
		if(is_array($condition)){
			return $this->DOXCXSYS_db->fill_models($this,$condition,$this->DOXCXSYS_order,$this->DOXCXSYS_limit,$this->DOXCXSYS_select);	
		}else if (is_string($condition)){
			return $this->DOXCXSYS_db->fill_models($this,$condition,$this->DOXCXSYS_order,$this->DOXCXSYS_limit,$this->DOXCXSYS_select,$pam);	
		}else {
			return $this->DOXCXSYS_db->fill_models($this,$this->DOXCXSYS_condition,$this->DOXCXSYS_order,$this->DOXCXSYS_limit,$this->DOXCXSYS_select,$this->DOXCXSYS_pam);
		}
	}
	
	/**
	 * 查询并返回数组结果集<br/>
	 * 如果$condition为数组则根据数组条件返回符合结果的列表<br/>
	 * 如果$condition是字串则必须是 where语句之后的字串，亦可通过?和$pam数组组合成SQL语句<br/>
	 * 如果不传入条件则根据where方法 的预设参数查询,如果where未被调用过则列出所有<br/>
	 * @param mixed $condition 条件字符串或条件数组
	 * @param array $pam 参数数组
	 * @return array 字符下标的数组集合
	 */
	public function list_all_array($condition=null,$pam=null){
		DBDes::init_by_model($this,'R');
		if(is_array($condition)){
			return $this->DOXCXSYS_db->fill_models_array($this,$condition,$this->DOXCXSYS_order,$this->DOXCXSYS_limit,$this->DOXCXSYS_select);	
		}else if (is_string($condition)){
			return $this->DOXCXSYS_db->fill_models_array($this,$condition,$this->DOXCXSYS_order,$this->DOXCXSYS_limit,$this->DOXCXSYS_select,$pam);	
		}else {
			return $this->DOXCXSYS_db->fill_models_array($this,$this->DOXCXSYS_condition,$this->DOXCXSYS_order,$this->DOXCXSYS_limit,$this->DOXCXSYS_select,$this->DOXCXSYS_pam);
		}
	}
	
	/**
	 * 传入要查询的条件
	 * @param mixed $condition 条件字符串或条件数组
	 * @param array $pam 参数值的数组
	 * @return Model 模型本身
	 */
	public function where($condition,$pam=null){
		if(!empty($condition)){
			$this->DOXCXSYS_condition = $condition;
			$this->DOXCXSYS_pam = $pam;
		}		
		return $this;	
	}
	
	/**
	 * 对于指定ID的数据进行插入操作
	 * @param $data
	 */
	public function insert($data = null){
		$this->save($data,true);
	}
	
	/**
	 * 保存或更新此条信息<br/>
	 * @return mixed <br/>验证失败返回false<br/>存储失败返回null<br/>存储成功返回本身
	 */
	public function save($data = null,$forceinsert = false){
		if($data === null ){
			$data = get_object_vars($this);
		}
		foreach($data as $k=>$v){
			if($v === '' && (strpos($this->type($k), 'date')===0 || strpos($this->type($k), 'int') >= 0)){
				$data[$k] = null;
			}
			$this->$k = $v;
		}
		if(!$this->DOXCXSYS_isorgin){
			//虚拟字段填入实体字段
			$this->fill_entity_field();
			$this->validate();
			if($this->DOXCXSYS_val_fail){//如果验证失败
				return false;
			}
		}
		if(trim($data['id'])=='' || $forceinsert){
			DBDes::init_by_model($this,'C');
			$id = $this->DOXCXSYS_db->insert_one_entity($this->DOXCXSYS_real_tablename,$data,$forceinsert);
			if($id!==null){
				$this->id = $id;
				return $this;
			}else{
				return null;
			}
		}else{
			DBDes::init_by_model($this,'U');
			unset($data['id']);
			$res = $this->DOXCXSYS_db->update_entity($this->DOXCXSYS_real_tablename,"id='".$this->id."'",$data);
			if($res!==null){
				return $this;
			}else{
				return null;
			}
		}

	}
	/**
	 * 删除本条信息
	 * @return mixed 删除成功返回 1 失败返回null
	 */
	public function remove(){
		DBDes::init_by_model($this,'D');
		return $this->DOXCXSYS_db->del_entity($this->DOXCXSYS_real_tablename,"id='".$this->id."'");
	}
	/**
	 * 批量更新信息
	 * 如果不传入数据$data且存在id则$condition相当于$data并依据ID进行$condition数据更新<br/>
	 * 如果不传入数据$data且不存在id自动将这个Model的除id之外的其他字段属性作为更新数据<br/>
	 * @param array $condition 条件数组
	 * @param array $data 更新的数据数组
	 * @return boolean 是否更新成功
	 */
	public function update($condition,$data=null){
		DBDes::init_by_model($this,'U');
		if($data===null){
			if($this->has_id()){
				return $this->DOXCXSYS_db->update_entity($this->DOXCXSYS_real_tablename,array('id'=>$this->id),$condition);
			}else{
				return $this->DOXCXSYS_db->update_entity($this->DOXCXSYS_real_tablename,$condition,$this->get_model_array());
			}			
		}else{
			return $this->DOXCXSYS_db->update_entity($this->DOXCXSYS_real_tablename,$condition,$data);
		}		
	}
	/**
	 * 批量删除数据<br/>
	 * 如果不传入条件则自动将这个Model的除id之外的其他字段属性作为条件<br/>
	 * @param mixed $condition 条件数组或字串
	 * @param mixed $pam 参数数组
	 * @return  mixed 删除成功返回删除的条数 失败返回null
	 */
	public function delete($condition=null,$pam=null){
		DBDes::init_by_model($this,'D');
		if($condition===null){
			return $this->DOXCXSYS_db->del_entity($this->DOXCXSYS_real_tablename,$this->get_model_array());
		}else{
			return $this->DOXCXSYS_db->del_entity($this->DOXCXSYS_real_tablename,$condition,$pam);
		}		
	}
	/**
	 * 获得模型属性信息的数组形式<br/>
	 * 只包含数据库中已有的字段 不包含ID信息(特殊指定$fields除外)
	 * 
	 * @param string|array $fields 需要特定指定的字段 
	 * @return array 模型的信息数组
	 */
	public function get_model_array($fields = null){
		$cons = array();
		if($fields === null){
			$cons = get_object_vars($this);
			unset($cons->id);
		}elseif (is_string($fields)){
			$cons = array($fields => $this->$fields);
		}else{
			foreach ($fields as $field){
				$cons[$field] = $this->$field;
			}
		}
		
		$cols =  $this->DOXCXSYS_db->list_fields($this->DOXCXSYS_real_tablename);
		$data = array();
		foreach ($cons as $k=>$v){
			if($v!==null && in_array($k, $cols)){
				$data[$k]=$v;
			}
		}
		return $data;
	}
	/**
	 * 获得模型属性信息的数组形式<br/>
	 * 只包含数据库中已有的字段 包含ID信息
	 * @return array 模型的信息数组
	 */
	public function get_model_array_with_id(){
		$cons = get_object_vars($this);
		$cols =  $this->DOXCXSYS_db->list_fields($this->DOXCXSYS_real_tablename);
		$data = array();
		foreach ($cons as $k=>$v){
			if($v!==null&&in_array($k, $cols)){
				$data[$k]=$v;
			}
		}
		return $data;
	}
	
	/**
	 * 获得一个和此模型一模一样的克隆 <br/>
	 * 不克隆ID信息
	 * @return Model 新的模型
	 */
	public function get_a_clone(){
		$newmodel =  clone $this;
		$newmodel->id = null;
		return $newmodel;
	}
	
	/**
	 * 构造函数
	 * @param string $tablename 表名
	 * @param string $postid 表单提交的区分ID
	 */
	function __construct($tablename,$postid=''){
		if(get_class($this) == 'Model'){
			$this->DOXCXSYS_isorgin = true;
		}else{
			$this->DOXCXSYS_isorgin = false;
		}
		$this->DOXCXSYS_postid = $postid;
		$this->DOXCXSYS_post_id = strlen($postid)===32 ? $postid : md5('DOXCX_'.$postid);
		$this->DOXCXSYS_db = DB::get_db();
		$this->DOXCXSYS_tablename = $tablename;
		$this->DOXCXSYS_real_tablename = Conf::$db_tablePrefix.$tablename;
		//填充一些有默认值的字段和字段描述
		if(!isset(self::$DOXCXSYS_FIELD_LABLE[$this->DOXCXSYS_tablename])){
			self::$DOXCXSYS_FIELD_LABLE[$this->DOXCXSYS_tablename] = array();
			self::$DOXCXSYS_FIELD_DATA[$this->DOXCXSYS_tablename] = array();
			self::$DOXCXSYS_FIELD_TYPE[$this->DOXCXSYS_tablename] = array();
			self::$DOXCXSYS_FIELD_DEFAULT[$this->DOXCXSYS_tablename] = array();
			self::$DOXCXSYS_FIELD_CANNULL[$this->DOXCXSYS_tablename] = array();
			$defaults = $this->DOXCXSYS_db->get_fields_array($this->DOXCXSYS_real_tablename);
			foreach ($defaults as $default){
				if(trim($default['Default'])!=''){
					//存储默认值
					self::$DOXCXSYS_FIELD_DEFAULT[$this->DOXCXSYS_tablename][$default['Field']] = str_replace("')",'', str_replace("('",'', $default['Default']));
				}
				if(trim($default['Null'])=='NO'){
					//是否允许非空
					self::$DOXCXSYS_FIELD_CANNULL[$this->DOXCXSYS_tablename][$default['Field']] = false;
				}else{
					self::$DOXCXSYS_FIELD_CANNULL[$this->DOXCXSYS_tablename][$default['Field']] = true;
				}
				if(strpos($default['Type'], 'enum')===0){
					self::$DOXCXSYS_FIELD_TYPE[$this->DOXCXSYS_tablename][$default['Field']] = 'enum';
					//存储枚举类型的数据
					$dataarray = array();					
					$tempstr = substr($default['Type'], 6,strlen($default['Type'])-8);
					$arr1 = explode("','", $tempstr);
					$arr2 = explode(",", $default['Comment']);
					if(count($arr1)===count($arr2)){
						$temparr2 = explode(':', $arr2[0]);
						if(count($temparr2)>1){
							//存储该字段的lable
							self::$DOXCXSYS_FIELD_LABLE[$this->DOXCXSYS_tablename][$default['Field']] = $temparr2[0];
						}
						$arr2[0] = $temparr2[count($temparr2)-1];
						foreach ($arr1 as $k=>$v){
							$dataarray[$v] = $arr2[$k];
						}
					}else{
						foreach ($arr1 as $v){
							$dataarray[$v] = $v;
						}
						//存储该字段的lable
						self::$DOXCXSYS_FIELD_LABLE[$this->DOXCXSYS_tablename][$default['Field']] = $default['Comment'];
					}
					//存储该字段的候选数据
					self::$DOXCXSYS_FIELD_DATA[$this->DOXCXSYS_tablename][$default['Field']] = $dataarray;
				}else{
					//存储该字段的lable
					self::$DOXCXSYS_FIELD_TYPE[$this->DOXCXSYS_tablename][$default['Field']] = $default['Type'];
					self::$DOXCXSYS_FIELD_LABLE[$this->DOXCXSYS_tablename][$default['Field']] = $default['Comment'];
				}
			}
		}		
		//该表Model数据已经初始化过 给各个字段赋初始值
		$defaults = &self::$DOXCXSYS_FIELD_DEFAULT[$this->DOXCXSYS_tablename];
		foreach ($defaults as $field=>$default){
			$this->$field = $default;
		}
		//如果不是原始模型 增加各个字段的验证信息供页面form标签使用
		if(!$this->DOXCXSYS_isorgin&&!isset(self::$DOXCXSYS_FIELD_FORMVAL[$this->DOXCXSYS_tablename])){
			self::$DOXCXSYS_FIELD_FORMVAL[$this->DOXCXSYS_tablename] = array();
			self::$DOXCXSYS_first_valset[$this->DOXCXSYS_tablename] = true;
			$this->validate();
			self::$DOXCXSYS_first_valset[$this->DOXCXSYS_tablename] = false;
		}
		//默认的field字段写入
		$fields = $this->DOXCXSYS_db->list_fields($this->DOXCXSYS_real_tablename);
		$this->DOXCXSYS_select = '['.implode('],[', $fields).']';
	}
	/**
	 * 获得某一字段的Lable<br/>
	 * 默认为数据库中定义的字段注释
	 * @param string $field 字段名称
	 * @return string 字段描述
	 */
	public function lable($field){
		$lable = self::$DOXCXSYS_FIELD_LABLE[$this->DOXCXSYS_tablename][$field];
		if(trim($lable)==''){
			return $field;
		}
		return $lable;
	}
	/**
	 * 获得某一字段的数据类型
	 * @param string $field 字段名称
	 * @return string 字段描述
	 */
	public function type($field){
		return self::$DOXCXSYS_FIELD_TYPE[$this->DOXCXSYS_tablename][$field];
	}
	/**
	 * 设置或者读取某一字段的初始化数据数组 <br/>
	 * $data为数组则设置字段的信息初始化数组<br/>
	 * $data为空则返回字段的信息初始化数组
	 * @param string $field 字段名称
	 * @param array $data 信息数组
	 * @return array 信息数组
	 */
	public function field_data($field,$data=null){
		if($data===null){
			return self::$DOXCXSYS_FIELD_DATA[$this->DOXCXSYS_tablename][$field];
		}else if(is_array($data)){
			self::$DOXCXSYS_FIELD_DATA[$this->DOXCXSYS_tablename][$field] = $data;
			return $data;
		}
	}
	/**
	 * 获得某一字段值对应的文本<br/>
	 * 返回针对enum类型字段的值对应的文本或者配置文件中配置的值所对应的文本
	 * @param string $field 字段名称
	 * @return string 字段值描述
	 */
	public function field_text($field){
		if(empty($field)){
			return null;
		}
		$data=$this->field_data($field);
		if(isset($data)){
			return $data[$this->$field];
		}else{
			return Page::$i18n['common'][$this->$field];
		}
	}
	/**
	 * 设置查询排序
	 * @param string $order 排序
	 * @return Model 模型本身
	 */
	public function order($order){
		$this->DOXCXSYS_order = $order;
		return $this;
	}
	/**
	 * 设置查询区间
	 * @param string $limit 区间
	 * @return Model 模型本身
	 */
	public function limit($limit,$limit2=null){
		if($limit2 !== null){
			$this->DOXCXSYS_limit = $limit.','.$limit2;
		}else{
			$this->DOXCXSYS_limit = $limit;
		}
		
		return $this;
	}
	/**
	 * 设置查询字段 如:"id,name"
	 * @param string $select 要检索的字段
	 * @return Model 模型本身
	 */
	public function field($select){
		$this->DOXCXSYS_select = $select;
		return $this;
	}
	/**
	 * 字段的 唯一性验证
	 * @param string $field 字段名称
	 * @param string $errmsg 错误信息
	 */
	public function val_unique($field,$errmsg=null){
		if(!$this->set_field_required_string($field,'DOXCXUNIQUE@'.$this->DOXCXSYS_tablename.'@'.$field.'@DOXCXSYSID', $errmsg===null?DOXCX::i18n('validate.unique'):$errmsg)){
			$query_arr = array($field=>$this->$field);
			if(trim($this->id)!=''){
				$query_arr['id@<>'] = $this->id;
			}
			if($this->$field!=''&&$this->DOXCXSYS_db->has($this->DOXCXSYS_real_tablename,$query_arr)){
				$this->set_err_msg($field,$errmsg?$errmsg:DOXCX::i18n('validate.unique'));
			}
		}
	}

	/**
	 * 将数据表的的两个字段的对应数据转换为键值数组形式
	 * @param string $field1 key
	 * @param string $field2 value
	 * @param array $res_arr 默认预置数组
	 * @return array 键值数组
	 */
	function map_array($field1,$field2,$res_arr = array()){
		DBDes::init_by_model($this,'R');
		$field1 = strpos($field1, ' ')>0? $field1 : '['.$field1.']';
		$field2 = strpos($field2, ' ')>0? $field2 : '['.$field2.']';
		$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$this->DOXCXSYS_condition,$this->DOXCXSYS_order,$this->DOXCXSYS_limit,"distinct $field1 as k,$field2 as v",$this->DOXCXSYS_pam);
		$res = $this->DOXCXSYS_db->query($sql);
		foreach ($res as $arr){
			$res_arr[$arr['k']] = $arr['v'];
		}
		return $res_arr;
	}
	/**
	 * 将数据表的的一个字段的值和多个字段的键值对对应的数据转换为键值数组-Map的形式
	 * @param string $field1 key
	 * @param array $farray 要填充到Map的Array(二级键值)
	 * @return array 一键多值数组
	 */
	function map_array_kmap($field1,$farray){
		DBDes::init_by_model($this,'R');
		$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$this->DOXCXSYS_condition,$this->DOXCXSYS_order,$this->DOXCXSYS_limit,"[$field1] as k,[".implode("],[", $farray)."]",$this->DOXCXSYS_pam);
		$res = $this->DOXCXSYS_db->query($sql);
		$res_arr = array();
		foreach ($res as $arr){
			$temarr = array();
			foreach ($farray as $av){
				$temarr[$av] = $arr[$av];
			}
			$res_arr[$arr['k']] = $temarr;
		}
		return $res_arr;
	}
	/**
	 * 计算某一字段的和
	 * @param string $field 参数数组
	 * @return integer 计数
	 */
	function sum($field=null){
		DBDes::init_by_model($this,'R');
		$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$this->DOXCXSYS_condition,null,null,"sum($field) c",$this->DOXCXSYS_pam);
		$res = $this->DOXCXSYS_db->query($sql);
		return intval($res[0]['c']);
	}
	/**
	 * 计算行数
	 * @param string $field 统计的参数（*）
	 * @return integer 计数
	 */
	function count($field=null){
		if($field===null){
			$field = '*';
		}
		$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$this->DOXCXSYS_condition,null,null,"count($field) c",$this->DOXCXSYS_pam);
		DBDes::init_by_model($this,'R');
		$res = $this->DOXCXSYS_db->query($sql);
		return intval($res[0]['c']);
	}
	/**
	 * 查询并返回某字段的最大值<br/>
	 * 如果$condition为数组则根据数组条件返回符合结果的列表<br/>
	 * 如果$condition是字串则必须是 where语句之后的字串，亦可通过?和$pam数组组合成SQL语句<br/>
	 * 如果不传入条件则根据where方法 的预设参数查询,如果where未被调用过则列出所有<br/>
	 * @param string $field 要查询 的字段
	 * @param miexd $condition 条件字符串或条件数组
	 * @param miexd $pam 参数数组
	 * @return integer 最大值
	 */
	function max($field,$condition=null,$pam=null){
		DBDes::init_by_model($this,'R');
		if($condition===null){
			$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$this->DOXCXSYS_condition,null,null,"max([$field]) c",$this->DOXCXSYS_pam);
		}else{
			$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$condition,null,null,"max([$field]) c",$pam);
		}
		$res = $this->DOXCXSYS_db->query($sql);
		return $res[0]['c'];
	}
	
	/**
	 * 查询并返回某字段的最小值<br/>
	 * 如果$condition为数组则根据数组条件返回符合结果的列表<br/>
	 * 如果$condition是字串则必须是 where语句之后的字串，亦可通过?和$pam数组组合成SQL语句<br/>
	 * 如果不传入条件则根据where方法 的预设参数查询,如果where未被调用过则列出所有<br/>
	 * @param string $field 要查询 的字段
	 * @param miexd $condition 条件字符串或条件数组
	 * @param miexd $pam 参数数组
	 * @return integer 最小值
	 */
	function min($field,$condition=null,$pam=null){
		DBDes::init_by_model($this,'R');
		if($condition===null){
			$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$this->DOXCXSYS_condition,null,null,"min([$field]) c",$this->DOXCXSYS_pam);
		}else{
			$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$condition,null,null,"min([$field]) c",$pam);
		}
		$res = $this->DOXCXSYS_db->query($sql);
		if(count($res)>0){
			return intval($res[0]['c']);
		}
		return 0;
	}
	
	/**
	 * 查询并返回某字段的平均值<br/>
	 * 如果$condition为数组则根据数组条件返回符合结果的列表<br/>
	 * 如果$condition是字串则必须是 where语句之后的字串，亦可通过?和$pam数组组合成SQL语句<br/>
	 * 如果不传入条件则根据where方法 的预设参数查询,如果where未被调用过则列出所有<br/>
	 * @param string $field 要查询 的字段
	 * @param miexd $condition 条件字符串或条件数组
	 * @param miexd $pam 参数数组
	 * @return integer 平均值
	 */
	function avg($field,$condition=null,$pam=null){
		if($condition===null){
			$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$this->DOXCXSYS_condition,null,null,"avg([$field]) c",$this->DOXCXSYS_pam);
		}else{
			$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$condition,null,null,"avg([$field]) c",$pam);
		}
		DBDes::init_by_model($this,'R');
		$res = $this->DOXCXSYS_db->query($sql);
		if(count($res)>0){
			return intval($res[0]['c']);
		}
		return 0;
	}
	
	/**
	 * 查询是否含有符合条件的数据<br/>
	 * 如果$condition为数组则根据数组条件返回符合结果的列表<br/>
	 * 如果$condition是字串则必须是 where语句之后的字串，亦可通过?和$pam数组组合成SQL语句<br/>
	 * 如果不传入条件则根据where方法 的预设参数查询,如果where未被调用过则列出所有<br/>
	 * @param miexd $condition 条件字符串或条件数组
	 * @param miexd $pam 参数数组
	 * @return boolean
	 */
	public function has($condition=null,$pam=null){
		if($condition===null){
			$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$this->DOXCXSYS_condition,null,null,"id",$this->DOXCXSYS_pam);
		}else{
			$sql = $this->DOXCXSYS_db->com_sql($this->DOXCXSYS_real_tablename,$condition,null,null,"id",$pam);
		}
		DBDes::init_by_model($this,'R');
		$res = $this->DOXCXSYS_db->query($sql);
		return count($res)>0;	
	}
	
	/**
	 * 判断当前model是否在数据库中存在真实的对应
	 * 
	 * @param string|array $fields 需要特定指定的字段
	 * @param boolean $fillme 是否填充当前model 默认:true
	 * @return boolean
	 */
	public function is_real($fields = null, $fillme = true){
		$conditions = null;
		if($fields === null){
			$conditions = $this->get_model_array_with_id();
		}else{
			$conditions = $this->get_model_array($fields);
			if(count($fields) != count($conditions)){
				return false;
			}
		}
		//注意还原DOXCXSYS_select
		$oldfield = $this->DOXCXSYS_select;
		$ms = $this->field('*')->list_all($conditions);
		$this->field($oldfield);
		if(count($ms) > 0){
			if($fillme){
				$this->find($ms[0]->id);
			}
			return true;
		}
		return false;
	}
}
?>