<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/18
 * Time: 16:24
 */

namespace Addons\AliSupport;


require_once  app_path("fun/alipay/aop/request/AlipayTradeAppPayRequest.php");
require_once  app_path("fun/alipay/aop/request/AlipayOpenAppQrcodeCreateRequest.php");

use AlipayTradeCreateRequest;
use AlipayOpenAppQrcodeCreateRequest;
use AlipayTradeRefundRequest;
use AopClient;
use Services\Service;
use Models\BaseModel as Model;
class Helper extends Service
{
    /**
     * 微信小程序获取支付参数
     * @param $wid
     * @param $openid
     * @param $money
     * @param $notifyUrl
     * @param $OrderNo
     * @param $remark
     * @param string $attach
     * @return array|bool
     */
    function prepay($wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = '') {
        //获取小程序配置信息
        $zfbInfo = new Model('zfb_vshop_weixin_pay');
        $zfbInfo->find(array('wid' => $wid));

        $aop = new AopClient ();
        $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
        $aop->appId =$zfbInfo->AppId;
        $aop->rsaPrivateKey = $zfbInfo->privateKey;
        $aop->alipayrsaPublicKey= $zfbInfo->publicKey;
        $aop->apiVersion = '1.0';
        $aop->signType = 'RSA2';
        $aop->postCharset='UTF-8';
        $aop->format='json';
        $requestTradeCreate = new AlipayTradeCreateRequest ();
        $requestTradeCreate->setNotifyUrl($notifyUrl);
        $requestTradeCreate->setBizContent("{" .
            "\"out_trade_no\":\"$OrderNo\"," .           //商户订单号
            "\"seller_id\":\"$zfbInfo->sellerId\"," .    //卖家支付宝用户ID。 如果该值为空，则默认为商户签约账号对应的支付宝用户ID
            "\"total_amount\":\"$money\"," .             //订单总金额，单位为元，精确到小数点后两位
            "\"subject\":\"$remark\"," .                   //订单标题
            "\"body\":\"$remark\"," .                      //对交易或商品的描述
            "\"buyer_id\":\"$openid\"" .                 //买家的支付宝唯一用户号（openid）
            "}");
        $resultTradeCreate = $aop->execute ($requestTradeCreate);
        $result=is_string($resultTradeCreate)?$resultTradeCreate:json_decode(json_encode($resultTradeCreate),true);
        $responseNode = str_replace(".", "_", $requestTradeCreate->getApiMethodName()) . "_response";
        if(!empty($result[$responseNode])){
            $re=$result[$responseNode];
            if($re['code']!='10000'){
                return error($re['sub_msg'],$result);
            }
            return success('获取支付信息成功',$re);
        }else{
            return error('获取支付信息失败',$result);
        }
    }
    //支付宝验签
    function ali_check_sign($wid,$posts){
        //获取小程序配置信息
        $zfbInfo = new Model('zfb_vshop_weixin_pay');
        $zfbInfo->find(array('wid' => $wid));
        $aop = new \AopClient();
        $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
        $aop->appId =$zfbInfo->AppId;
        $aop->rsaPrivateKey = $zfbInfo->privateKey;
        $aop->alipayrsaPublicKey= $zfbInfo->publicKey;
        $aop->apiVersion = '1.0';
        $aop->signType = 'RSA2';
        $aop->postCharset='UTF-8';
        $aop->format='json';
        $checkSign=$aop->rsaCheckV1($posts, NULL,$aop->signType);
        return $checkSign;
    }

    /**
     * 生成小程序二维码
     * @param $wid
     * @param $platPath
     * @param $params
     * @param null $filePath
     * @param string $describe
     * @return array
     * @throws \Exception
     */
    function create_qr($wid,$platPath,$params,$filePath=null,$describe=""){
        $zfbInfo=(new Model("zfb_vshop_weixin_pay"))->find(['wid'=>$wid]);
        if(!$zfbInfo->id)return error("出现错误错误:没有找到商家对应的配置信息");
        $aop = new \AopClient ();
        $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
        $aop->appId =$zfbInfo->AppId;
        $aop->rsaPrivateKey = $zfbInfo->privateKey;
        $aop->alipayrsaPublicKey=$zfbInfo->publicKey;
        $aop->apiVersion = '1.0';
        $aop->signType = 'RSA2';
        $aop->postCharset='UTF-8';
        $aop->format='json';
        $request = new AlipayOpenAppQrcodeCreateRequest();
        $str_query=http_build_query([
            'scene'=>$params['scene']
        ]);
        $bizContent=json_encode([
            "url_param"=>$platPath,
            "query_param"=>$str_query,
            "describe"=>$describe ? $describe :"我要代言"
        ],JSON_UNESCAPED_SLASHES);
        $request->setBizContent($bizContent);

        $result = $aop->execute ( $request);

        if($filePath==null)$filePath="UserPage/qrcode_".date('Ymd') . DS . md5(microtime(true)).".png";
        $full_Path=pub_path($filePath);
        $path=dirname($full_Path);
        is_dir($path) or mkdir($path,0751,true);

        $result=is_string($result)?$result:json_decode(json_encode($result),true);
        $responseNode = str_replace(".", "_", $request->getApiMethodName()) . "_response";
        if(!empty($result[$responseNode])){
            $re=$result[$responseNode];

            if($re['code']!='10000'){
                return error($re['sub_msg'],$result);
            }
            $url=$re['qr_code_url'];
            return success('生成成功',['url'=>$url,'path'=>'']);
        }else{
            return error('获取支付信息失败',$result);
        }


    }
    /**
     * @param $aliConfig
     * @param $order_no 商户单号
     * @param $out_trade_no 支付平台单号
     * @param $money
     * @param string $type
     * @return array
     * @throws \Exception
     */
    public function refundOrder($aliConfig,$order_no,$out_trade_no,$money){

        require_once app_path( "fun/alipay/aop/AopClient.php");
        require_once app_path("fun/alipay/aop/request/AlipayTradeRefundRequest.php");

        $aop = new AopClient ();
        $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
        $aop->appId = $aliConfig->zfbAppId;
        $aop->rsaPrivateKey = $aliConfig->privateKey;
        $aop->alipayrsaPublicKey= $aliConfig->publicKey;
        $aop->apiVersion = '1.0';
        $aop->signType = 'RSA2';
        $aop->postCharset='UTF-8';
        $aop->format='json';
        $request = new AlipayTradeRefundRequest ();
        $request->setBizContent("{" .
            "\"out_trade_no\":\"$order_no\"," .
            "\"trade_no\":\"$out_trade_no\"," .
            "\"refund_amount\":\"$money\"" .
            "}");
        $resultTradeCreate = $aop->execute ($request);
        $result=is_string($resultTradeCreate)?$resultTradeCreate:json_decode(json_encode($resultTradeCreate),true);
        $responseNode = str_replace(".", "_", $request->getApiMethodName()) . "_response";
        if($result[$responseNode]['code']==10000){
            //找到订单
            return success("退款成功",$result[$responseNode]);
        }else{
            return error("退款失败:".$result[$responseNode]['sub_msg']);
        }


    }

}