<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/16
 * Time: 16:35
 */

namespace Addons\AliSupport\Services\Plugins;


use Addons\AliSupport\Helper;

class Payment extends \BaseController
{
    /**
     * 微信支付钩子
     * @param $params
     * @param array $extra
     * @return array|bool
     */
    public function _pay_params(&$params,array $extra){
//         $wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = ''
        $pay_type=$extra['pay_type'];
        if($pay_type!='alipay')return error('非alipay类型');
        \Log::debug('alipay支付参数:'.json_encode($extra));
        $helper=Helper::getInstance();
        $pay_params=$helper->prepay($extra['wid'],$extra['openid'],
            $extra['money'],$extra['notifyUrl'],$extra['OrderNo'],$extra['remark'],$extra['attach']);
        if($pay_params['status']=='success'){
            $pay_params['pay_type']='alipay';
            $params=success('ok',$pay_params['data']);
        }else{
            $params=error('err'.$pay_params['msg'],$pay_params);
        }
        return false;#停止继续执行
    }

    /**
     * 微信支付回调钩子
     * @param $params
     * @param array $extra
     * @return bool|string
     */
    public function _pay_notify(&$params,array $extra){
        \Log::debug('alipay 支付插件回调获得参数:'.json_encode($extra));
        if($extra['pay_type']!='alipay')return true;
        ini_set('date.timezone', 'Asia/Shanghai');
        error_reporting(0);
        $wid = $extra['wid'];
        $pay_resp=$_POST;
        $pay_resp['transaction_id']=$pay_resp['trade_no'];
        $pay_resp['time_end']=date("Y-m-d H:i:s");
        $helper=Helper::getInstance();
        //验证签名
        if (!$helper->ali_check_sign($wid, $pay_resp)) {
            \Log::debug('wechat 签名失败:'.json_encode($pay_resp));
            $return= "sign error";
            $params=error('支付宝 签名失败',['pay_resp'=>null,'return'=>$return]);
            return  false;

        }

        $return = "success";
        $params=success('ok',['pay_resp'=>$pay_resp,'return'=>$return]);//返回解析数据
        return false; #停止继续执行
    }
    public function  _pay_refund(&$params,array $extra){
        diy_log('alipay 支付插件回调获得参数:'.json_encode($extra));
        if($extra['pay_type'] != 'alipay')return true;
        ini_set('date.timezone', 'Asia/Shanghai');
        error_reporting(0);
        $wid = $extra['wid'];
        $out_trade_no=$extra['out_trade_no'];
        $order_no=$extra['order_no'];
        $money=$extra['money'];
        //查询是否微信订单
        $helper=Helper::getInstance();
        $Config = new \Model('zfb_vshop_weixin_pay');
        $Config->find(array('wid' => $wid));
        if(!$Config->id){
            $params=error("获取支付宝配置错误，请检查");
            return false;
        }

        try{
            $params=$helper->refundOrder($Config,$order_no,$out_trade_no,$money);
        }catch(\Exception $e){
            $params=error("出现错误:".$e->getMessage());
        }
        return false;
    }
}