<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/18
 * Time: 5:22
 */
require(DOXCX_FRAME_PATH . 'fun/baiduOpenApi.php');//开放平台api函数集

//获取授权令牌
function getAccessToken(){
	$authorizer_access_token = get_authorizer_access_tokens();//获取当前后台登陆着的用户的授权令牌
	if($authorizer_access_token){
		return $authorizer_access_token;
	}
	return 0;
}

//web化开关
function web_switch($status,$authorizer_access_token) {
   $resp = HttpCurl::post(
    "https://openapi.baidu.com/rest/2.0/smartapp/app/modifywebstatus?access_token=" . $authorizer_access_token,
    [
	 "web_status"  => $status,
	]
  );
  $resp_arr = json_decode($resp, 1);
  return $resp_arr;
}

//获取web_status
function get_web_status($authorizer_access_token){
  $resp = HttpCurl::get("https://openapi.baidu.com/rest/2.0/smartapp/app/info?access_token=" . $authorizer_access_token, []);
  $resp_arr = json_decode($resp, 1);
  if (array_key_exists('data', $resp_arr)) {
	if($resp_arr['data']['web_status'] == 1){
		return 1;
	}
    return 0;
  } else {
    //获取失败
    return 0;
  }
}

function get_authorizer_access_tokens() {
  //先查找当前登录的用户
  $wid = Session::get('wid');//当前登录的用户id
  $pub = (new Model('pubs'))->find(['id' => $wid]);
  //参数是否存在
 
    //直接获取存储的authorizer_access_token
    if (intval(strtotime($pub->bd_token_create_time)) + 3000 < time()) {
      //当前存储的令牌已经失效
      //发起令牌刷新请求
      //获取cat令牌
      $component_access_token = get_component_access_token();
      if (!$component_access_token) {
        return false;
      }
      //发起刷新请求
	  $body = HttpCurl::get("https://openapi.baidu.com/rest/2.0/oauth/token?access_token=" .  $component_access_token . "&refresh_token=" . $pub->bd_authorizer_refresh_token . "&grant_type=app_to_tp_refresh_token", []);
      $resp_arr = json_decode($body, 1);
      if (array_key_exists('access_token', $resp_arr)) {
        //成功获取
        diy_log($resp_arr);
        $pub->bd_authorizer_access_token = $resp_arr['access_token'];
        $pub->bd_authorizer_refresh_token = $resp_arr['refresh_token'];
        $pub->bd_token_create_time = date('Y-m-d H:i:s', time());
        $pub->save();
        return $pub->bd_authorizer_access_token;
      } else {
        //获取失败
        return false;
      }
    }
    //未失效
    return $pub->bd_authorizer_access_token;
}