<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/4/23
 * Time: 16:29
 */

namespace Addons\PayCheap\Controller\Api;


use Addons\PayCheap\Models\VshopMember;
use Addons\PayCheap\Models\VSHopPayCheap;
use Addons\PayCheap\Models\VshopPaycheapOrder;
use Addons\PayCheap\Models\VshopPaycheapRecharge;
use Illuminate\Database\Query\Expression;
use Illuminate\Support\Facades\DB;
use Models\DBModel;

class PayCheap extends \BaseController
{
    /**
     * 获取优惠买单优惠设置
     * @return array
     */
    public function index()
    {
        $req = getPayloadParams();
        $wid = $req['wid'];
        //获取转账配置信息
        $pc = (new \Model('vshop_paycheap'))->find(['wid' => $wid])->get_model_array();
        $pc['charge_rule'] = json_decode($pc['charge_rule']);
        //获取商家信息
        $pc['shopOwnerInfo'] = (new \Model('vshop_set'))->find(['wid' => $wid])->get_model_array();
        return success('获取配置成功啦', $pc);
    }

    public function count()
    {
        $req = getPayloadParams();
        $wid = $req['wid'];
        $today_begin_time = mktime(0, 0, 0, date('m'), date('d'), date('Y'));
        $today_end_time = mktime(0, 0, 0, date('m'), date('d') + 1, date('Y')) - 1;
        $payCheapOrder = new VshopPaycheapOrder();
        $filter_where = ['wid' => $wid];//
        //总营业额
        $total_amount = $payCheapOrder->where($filter_where)->where(['is_pay' => 1])->sum('spend_money');
        //虚收金额
        $really_amount = $payCheapOrder->where($filter_where)->where(['is_pay' => 1])->sum('really_money');
        $virtual_amount = $total_amount - $really_amount;
        //未结算金额
        $out_amount = $payCheapOrder->where($filter_where)->where(['is_pay' => 0])->sum('really_money');
        //今日实收金额
        $today_really_money = $payCheapOrder->where($filter_where)->where('pay_time','>=',$today_begin_time)
            ->where('pay_time','<=',$today_end_time)
            ->where(['is_pay' => 1])->sum('really_money');
        //今日储蓄本金
        //今日储蓄赠送
        //今日储蓄总额
        //今日储蓄笔数
        $rechargeModel = new VshopPaycheapRecharge();
//        [
//            ['type','=','优惠买单'],
//            ['money','>',0],
//            ['created_time','>',date('Y-m-d H:i:s',$today_begin_time)],
//            ['created_time','<',date('Y-m-d H:i:s',$today_end_time)]
//
//        ]
        $count_cashflow_info = $rechargeModel->where($filter_where)->whereRaw("is_pay=1
        and ctime > {$today_begin_time}   and  ctime <  {$today_end_time}")->first(
            [
                new Expression('sum(recharge_money) as recharge'),
                new Expression(' sum(send_money) as recharge'),
                new Expression('count(*) as num')
            ]
        );
        $recharge_money = $count_cashflow_info['recharge'] ? $count_cashflow_info['recharge'] : 0;
        $send_money = $count_cashflow_info['send_money'] ? $count_cashflow_info['send_money'] : 0;
        $total_recharg_money = $recharge_money + $send_money;
        $recharge_num = $count_cashflow_info['num'] ? $count_cashflow_info['num'] : 0;
        //今日新增会员
        //会员汇总
        $today_member = VshopMember::where('reg_time', '>=', stdDate($today_begin_time))
            ->where('reg_time', '<=', stdDate($today_end_time))
            ->count();
        $total_member = (new VshopMember())->count();
        $returnData = [
            'total_income' => number_format($total_amount, 2),
            'today_really_money' => number_format($today_really_money, 2),
            'really_amount' => number_format($really_amount, 2),
            'virtual_income' => number_format($virtual_amount, 2),
            'out_income' => number_format($out_amount, 2),
            'today_recharge_capital' => number_format($recharge_money, 2),
            'today_recharge_send' => number_format($send_money, 2),
            'today_rechagre_amount' => $total_recharg_money,
            'today_recharge_times' => $recharge_num,
            'today_member' => $today_member,
            'total_member' => $total_member

        ];
        return success('ok', $returnData);
    }
}