<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/4/23
 * Time: 14:04
 */

namespace Addons\PayCheap\Controller\Payment;


use Addons\PayCheap\Services\PayCheap;
use Lib\Hook;
use mysql_xdevapi\Exception;

class Notify extends \BaseController
{
    /**
     * 商云客支付回调
     * @return string
     */
    public function sky_notify(){
        ini_set('date.timezone', 'Asia/Shanghai');
        $wid = $_GET['attach'];
        $data = json_decode($_GET['data'], true);
        $signString='attach='.$_GET['attach'].'&data='.$_GET['data'].'&key=H357SFF768D786EBB07E1B8D9A4DABC';
        $sign=strtoupper(md5($signString));
        $hmac=$_GET['hmac'];
        //验证签名
        if($sign != $hmac){
            \Log::error("错误。优惠买单回调失败：".date('H:i:s',time()).': 签名错误:');
//            file_put_contents(DOXCX_FRAME_PATH.'/log/info/'.date('Y_m_d',time()).'.log', date('H:i:s',time()).': 签名错误:',FILE_APPEND);
            exit();
        }
        //修改订单信息
        //修改订单信息
        $data['out_trade_no']=$data['mer_order_no'];
        try{
            $re=PayCheap::getInstance()->cheapOrderHandle($data);
            if($re['status']!='success'){
                \Log::error('错误。优惠买单数据'.json_encode($data));
                \Log::error("错误。优惠买单回调失败：".json_encode($re));
            }
            \Log::error('优惠买单回调结果：'.json_encode($re));
        }catch(\Exception $e){
            \Log::error('优惠买单回调错误：'.$e->getMessage());
        }
        //返回结果
        return  "SUCCESS";
    }

    /**
     * 微信支付回调
     * @return string
     */
    public function wechat_notify(){
        ini_set('date.timezone', 'Asia/Shanghai');
        error_reporting(0);
        $wid = \Request::get(1);
        $xml = file_get_contents("php://input");
        $pay_resp = xml_to_array($xml);
        //支付参数
        $payParams = db_query("SELECT * FROM vshop_weixin_pay WHERE wid=?", [$wid])[0];
        //验证签名
        if (!confirm_sign($pay_resp, $payParams['PartnerKey'])) {
            \Log::debug('签名失败:'.$xml);
           return  "<xml><return_code><![CDATA[FAIL]]></return_code><return_msg><![CDATA[签名失败]]></return_msg></xml>";

        }
        //修改订单信息
          try{
              $re=PayCheap::getInstance()->cheapOrderHandle($pay_resp);
              if($re['status']!='success'){
                  \Log::info("错误。优惠买单回调失败：".json_encode($re));
              }
              \Log::debug('优惠买单回调结果：'.json_encode($re));
          }catch(\Exception $e){
            \Log::error('优惠买单回调错误：'.$e->getMessage());
          }


        //返回结果
        return  "<xml><return_code><![CDATA[SUCCESS]]></return_code><return_msg><![CDATA[OJBK]]></return_msg></xml>";
    }
    /**
     *通用支付插件回调
     * 必须存在 out_trade_no 和 transaction_id
     */
    public function common_notify(){
        $result=null;
        $pay_type=\Request::get(1);
        $wid=\Request::get(2);
        Hook::listen('pay_notify',$result,['pay_type'=>$pay_type,'wid'=>$wid]); //所有插件的实现只能使用此参数和传的参数
        if($result===null){
            \Log::info("错误。优惠买单回调失败：".file_get_contents("php://input"));
            return 'error';

        }elseif ($result['status']=='error'){
            \Log::debug('优惠买单回调结果：'.json_encode($result));
            return $result['data']['return'];
        }

        //修改订单信息
        try{
            $re=PayCheap::getInstance()->cheapOrderHandle($result['data']['pay_resp']);
            if($re['status']!='success'){
                \Log::info("错误。优惠买单回调失败：".json_encode($re));
            }
            \Log::debug('优惠买单回调结果：'.json_encode($re));
        }catch(\Exception $e){
            \Log::error('优惠买单回调错误：'.$e->getMessage());
        }
        return $result['data']['return'];
    }
}