<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/4/23
 * Time: 12:19
 */

namespace Addons\PayCheap\Services;

use Addons\PayCheap\Models\VipCard;
use Addons\PayCheap\Models\VipRechargeLog;
use Addons\PayCheap\Models\VipRechargeRecord;
use Addons\PayCheap\Models\VshopMember;
use Addons\PayCheap\Models\VshopMycouponList;
use Addons\PayCheap\Models\VSHopPayCheap;
use Addons\PayCheap\Models\VshopPaycheapOrder;
use Addons\PayCheap\Models\VshopPaycheapRecharge;
use Addons\QqSupport\Helper;
use LDB as DB;

use \Illuminate\Database\Eloquent\Model ;
use Lib\Hook;
use Services\Service;

class PayCheap extends Service
{


    /**
     * 完成订单后进行的操作
     * @param Model $order
     * @param $data
     * @return array
     */
    protected function completeOrder(Model $order, $data)
    {
        if ($order->recharge_money > 0) {
            $user =VshopMember::where(['wxid' => $order->openid])->first();
            $vipModel=new VipCard();
            $vipInfo=$vipModel->where(['openid'=>$order->openid,'wid'=>$order->wid])->first();
            if (!$user||!$vipInfo) return $this->error('待充值会员卡不存在',['vip_info'=>$vipInfo,'user'=>$user]);
            $vipInfo->balance += $order->recharge_money;
            $vipInfo->save();
            //写入充值记录表
            $rechargeModel=VshopPaycheapRecharge::where('order_no','=',$order->OrderNo)
                ->first();
            $rechargeModel->is_pay=1;
            $rechargeModel->save();
            //写入会员卡充值表1
            $card_log=new VipRechargeLog();
            $card_log->wid=$order->wid;
            $card_log->out_trade_no=$order->OrderNo;
            $card_log->openid=$order->openid;
            $card_log->total_fee=$order->recharge_money;
            $card_log->save();
            //写入会员卡记录表
            $card_record=new VipRechargeRecord();
            $card_record->wid=$order->wid;
            $card_record->openid=$order->openid;
            $card_record->money=$order->recharge_money;
            $card_record->ctime=time();
            $card_record->save();


        }
        return $this->success('操作完成');
    }
    /**
     * 单商家优惠买单确认后进行回调操作
     * @param $data
     */
    public function cheapOrderHandle($data)
    {
        \Log::debug("传入订单数据:".json_encode($data));
        $order = VshopPaycheapOrder::where(['OrderNo' => $data['out_trade_no']])->first();
        if (!$order) return $this->error('订单不存在');
        $order->is_pay = 1;
        $order->save();
        return $this->completeOrder($order, $data);
    }

    /**
     * 生成预支付订单
     * @param Model $order
     * @param array $req
     * @param $notify_data ['wechat'=>'','sky'=>'']
     */
    public function PayCheatPreparePay(Model $order, array $req, $notify_data,$pay_type='')
    {
        $wid = $req['wid'];
        $submit_type =$req['submit_type'];
        //获取转账配置信息
        //生成预支付订单
        $time = time();
        $OrderNo = getRandomOrderNo('on');
        $money = $req['spendMoney'];
        $couponItemId = $req['couponItemId'] ? $req['couponItemId'] : 0;//优惠券id
        $recharge_money = $req['recharge_money'] ? $req['recharge_money'] : 0; //用户充值金额
        $use_card_money = $req['use_card_money'] ? true : false;
        $openid = $req['openid'];
        //存入订单信息
        //获取优惠买单设置
        $payCheap = VShopPayCheap::where(['wid' => $wid])->first();
        //写入订单数据
        $order->wid = $wid;
        $order->OrderNo = $OrderNo;
        $order->pay_time = $time;
        $order->spend_money = $money;
        $order->really_money = $money;
        $order->card_money = 0;
        $order->openid = $openid;
        //判断优惠券
        $coupon = null;
        $couponAmount = 0;
        if ($couponItemId) {
            $coupon = array();//查询优惠券金额
            $mycoupon =VshopMycouponList::find($couponItemId);
            if ($mycoupon->all > 0 && $mycoupon->id && $mycoupon->wxid == $openid && $mycoupon->wid == $wid && $mycoupon->isuse == 0 && $mycoupon->daytime >= date('Y-m-d H:i:s')) {
                if ($mycoupon->type == 1) {//现金券
                    $coupon['Label'] = "现金券";
                    $coupon['Title'] = "优惠" . $mycoupon->money . "元";
                    $coupon['Desc'] = "已减" . $mycoupon->money . "元";
                    $coupon['UseAmount'] = $mycoupon->money;
                    $coupon['DiscountAmount'] = $mycoupon->money;
                    $coupon['FromType'] = $mycoupon->type;
                    $coupon['Id'] = $mycoupon->id;
                    $coupon['hid'] = $mycoupon->hid;
                    $coupon['Name'] = $mycoupon->name;
                    $coupon['CodeId'] = 0;
                    $coupon['StrValidateStart'] = $mycoupon->ctime;
                    $coupon['StrValidateEnd'] = $mycoupon->dytime;
                    $couponAmount = $mycoupon->money;//优惠券金额
                } elseif ($mycoupon->type == 2) {//满减券
                    $coupon['Label'] = "满减券";
                    $coupon['Title'] = "满" . $mycoupon->xemoney . "元减" . $mycoupon->dmoney . "元";
                    $coupon['Desc'] = "已减" . $mycoupon->dmoney . "元";
                    $coupon['UseAmount'] = $mycoupon->xemoney;
                    $coupon['DiscountAmount'] = $mycoupon->dmoney;
                    $coupon['FromType'] = $mycoupon->type;
                    $coupon['Id'] = $mycoupon->id;
                    $coupon['hid'] = $mycoupon->hid;
                    $coupon['Name'] = $mycoupon->name;
                    $coupon['CodeId'] = 0;
                    $coupon['StrValidateStart'] = $mycoupon->ctime;
                    $coupon['StrValidateEnd'] = $mycoupon->dytime;
                    if ($mycoupon->xemoney >= $money) {
                        $couponAmount = $mycoupon->dmoney;//优惠券金额
                    } else {
                        $couponAmount = 0;//优惠券金额
                    }

                }
                if($couponAmount==0)return $this->error('当前优惠券不满足使用条件');
            }

        }
        //支付金额
        $order->coupon_amount = $order->really_money >= $couponAmount ? $couponAmount : $order->really_money;
        $order->really_money -= $order->coupon_amount;

        $order->coupon = json_encode($coupon);

        $vipModel=new VipCard();
        $re=$vipModel->where(['openid'=>$openid])->first();
        if(!$re){
            $vipModel->wid=$wid;
            $vipModel->openid=$openid;
            $vipModel->balance=0;
            $vipModel->point=0;
            $vipModel->total_point=0;
            $vipModel->passwd='';
            $vipModel->save();
            $vipModel->card_num= date('YmdHis', time()) . $vipModel->id;
            $vipModel->save();
            $user_balance=0;
        }else{
            $user_balance=$re->balance;
        }
        //使用会员卡余额
        if ($use_card_money&&$user_balance > 0) {


            $reduce_money = $user_balance <= $order->really_money ? $user_balance : $order->really_money;
            if ($reduce_money > 0) {
                $order->really_money -= $reduce_money;
                $order->card_money = $reduce_money;
            }


        }
        $order->really_money=round($order->really_money,2);
        $money = $order->really_money;//支付金额变为实际支付金额
        //使用会员充值

        $curr_charge_rule=[];
       $payCheap['charge_rule']=json_decode($payCheap['charge_rule'], true);
        $send_money = 0;
        if ($recharge_money > 0) {
            $recharge_rule = $payCheap['charge_rule'];
            if (empty($payCheap['is_advise_charge']) || empty($payCheap['charge_rule'])) return $this->error('充值活动暂未开启');

            $send_money = 0;
            foreach ($recharge_rule as $rule) {
                $rule_money=floor($rule['charge_percent'] * $order->really_money)/100;
                if ($rule_money== $recharge_money) {

                    $curr_charge_rule=$rule;
                    $send_money = floor($order->really_money * $rule['send_percent'])/100;
                }
            }
            if (!$curr_charge_rule) {
                $recharge_money=0;
//               return  $this->error("充值金额不正确:{$recharge_money},{$curr_charge_rule['send_percent']}");
            }
            //这里是赠送金额 要去掉除去订单金额
            if($recharge_money + $send_money > $order->really_money ){
                $order->recharge_money = $recharge_money + $send_money - $order->really_money;
                $money = $recharge_money;//将支付金额改成充值金额
            }else{
                $order->recharge_money =  0 ; //全部抵扣订单
                $money = $money  - $send_money ;//充值金额 少的 就抵扣 订单金额
            }


        }
        //使用会员充值
        //使用会员卡余额
        if ($money <= 0 ) {//使用优惠券 和 支付金额为0
            $order->is_pay = 1;
            //当前为支付状态
        } else {
            $order->is_pay = 0;
        }


        //判断优惠券
        if($submit_type!='submit'){
            return $this->success('ok',
                ['order'=>$order,'user_balance'=>$user_balance,'pay_cheap'=>$payCheap,'charge_rule'=>empty($curr_charge_rule)?[]:$curr_charge_rule]);
        }
        $order->save();
        //如果不需要支付直接返回支付成功


        //
        //是否使用优惠券
        if ($couponAmount && $couponItemId) {
            $mycouponlist = VshopMycouponList::find($couponItemId);
            $mycouponlist->isuse = 1;
            $mycouponlist->usetime = date('Y-m-d H:i:s');
            $mycouponlist->save();
        }
        //是否使用会员余额
        if ($order->card_money > 0) {
            $vipModel::query()->where(['openid'=>$openid,'wid'=>$wid])->decrement('balance',$order->card_money );
//            $re = DB::table('vshop_member')->where(['wxid' => $openid])->decrement('money', $order->card_money);
//            if ($re) {
//                DB::table('vshop_member_cashflow')->insert([
//                    'wid' => $wid,
//                    'openid' => $openid,
//                    'money' => - $reduce_money,
//                    'type' => '优惠买单',
//                    'pay_type' => '微信',
//                    'created_time' => date('Y-m-d H:i:s', time()),
//                    'order_no' => $OrderNo,
//                    'desc' => '通过用户余额消费'
//                ]);
//            }
        }
        //是否会员充值 写入充值记录
        if($recharge_money > 0){

            $rechargeModel=new VshopPaycheapRecharge();
            $rechargeModel->wid=$wid;
            $rechargeModel->order_no=$order->OrderNo;
            $rechargeModel->recharge_money=$recharge_money;
            $rechargeModel->send_money=$send_money;
            $rechargeModel->is_pay=0;
            $rechargeModel->ctime=time();
            $rechargeModel->save();
        }

        if ($order->is_pay === 1) {
            $order->save();
            $handle_re=$this->cheapOrderHandle(['out_trade_no'=>$order->OrderNo]);
            if($handle_re['status']!=='success'){
                return $handle_re;
            }else{
                return $this->success('支付成功', ['is_pay' => 1]);
            }

        }

        //钩子挂载支付插件 插件必须 以success方式返回数据
        $pay_request=null;
        $notifyUrl=$notify_data['common'];
        $remark=$req['body'];
        $pay_type=get_pay_type($pay_type,$wid);
        $attach='';
        $extra=compact('wid','openid','money','notifyUrl','OrderNo','remark','attach','pay_type');
            Hook::listen('pay_params',$pay_request,$extra);
        if(!$pay_request){
            return $this->error('暂不支持的支付方式:'.$pay_type);
        }
        if($pay_request['status']=='error'){
            return $pay_request;
        }
        $pay_params=$pay_request['data'];

        if($pay_params){
            return $pay_params;
        }else{
            return $this->error('获取支付信息失败',['wid'=>$wid,'openid'=> $openid,'money'=> $money,'$notify_data'=> $notify_data,
                'OrderNo'=>$OrderNo, 'body'=>$req['body'],'pay_request'=>$pay_request]);
        }
    }

}