<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/16
 * Time: 15:31
 */

namespace Addons\QqSupport;


use Services\Service;

class Helper extends Service
{
    function array_urlencode($data)
    {
        $new_data = array();
        foreach ($data as $key => $val) {
            $new_data[$key] = is_array($val) ? $this->array_urlencode($val) : urlencode($val);
        }
        return $new_data;
    }

    /*复制xCopy函数用法：
      *   xCopy("feiy","feiy2",1):拷贝feiy下的文件到   feiy2,包括子目录
      *   xCopy("feiy","feiy2",0):拷贝feiy下的文件到   feiy2,不包括子目录
      *参数说明：
      *   $source:源目录名
      *   $destination:目的目录名
      *   $child:复制时，是不是包含的子目录
      */
    function xCopy($source, $destination, $child)
    {
        if (!file_exists($destination)) {
            if (!mkdir(rtrim($destination, '/'), 0777)) {
                //$err->add($_LANG['cannt_mk_dir']);
                return false;
            }
            @chmod($destination, 0777);
        }
        if (!is_dir($source)) {
            return 0;
        }
        if (!is_dir($destination)) {
            mkdir($destination, 0777);
        }
        $handle = dir($source);
        while ($entry = $handle->read()) {
            if (($entry != ".") && ($entry != "..")) {
                if (is_dir($source . "/" . $entry)) {
                    if ($child)
                        $this->xCopy($source . "/" . $entry, $destination . "/" . $entry, $child);
                } else {
                    copy($source . "/" . $entry, $destination . "/" . $entry);
                }
            }
        }
        return 1;
    }

    /**
     * 获取支付参数
     * @param $wid
     * @param $openid
     * @param $money
     * @param $notifyUrl
     * @param $OrderNo
     * @param $remark
     * @param string $attach
     * @return array|bool
     */
    function prepay($wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = '') {
        // Conf::$http_path_api . "Payment/Wxpay/wxRechargeNotify-" . arr_get($req, 'wid') . ".html"
        if (!$attach) {
            $attach = json_encode([]);
        }
        $payParams = db_query("SELECT * FROM qq_vshop_weixin_pay WHERE wid=?", [$wid])[0];
        $time = time();
        $nonce_str = md5(time() . rand() . rand() . 'QQ支付');
        $body = $remark;

//        if($payParams['status']==1){
            $params = [
                'appid'            => $payParams['AppId'],//小程序ID
                'mch_id'           => $payParams['PartnerId'],//商户号
                'nonce_str'        => $nonce_str,//随机字符串
                'body'             => $body,//商品描述(可以拼接字符串生成)
                'out_trade_no'     => $OrderNo,//商品订单号
                'total_fee'        => $money * 100,//总金额
                'spbill_create_ip' => '192.168.1.1',//终端IP
                'notify_url'       => $notifyUrl,//通知地址
                'trade_type'       => 'JSAPI',//交易类型(小程序固定是JSAPI)
//                'openid'           => $openid,//用户的openid
                'attach'           => "{$openid}_".$attach
            ];
//        }else{
//            $params = [
//                'appid' => $payParams['sAppId'],//服务商ID
//                'mch_id' => $payParams['PartnerId'],//商户号
//                'sub_appid' => $payParams['AppId'],//小程序的APPID
//                'sub_mch_id' => $payParams['sPartnerId'],//子商户号
//                'nonce_str'        => $nonce_str,//随机字符串
//                'body'             => $body,//商品描述(可以拼接字符串生成)
//                'out_trade_no'     => $OrderNo,//商品订单号
//                'total_fee'        => $money * 100,//总金额
//                'spbill_create_ip' => '192.168.1.1',//终端IP
//                'notify_url'       => $notifyUrl,//通知地址
//                'trade_type'       => 'JSAPI',//交易类型(小程序固定是JSAPI)
//                'sub_openid'           => $openid,//用户的openid
//                'attach'           => $attach
//            ];
//        }


        $params['sign'] = make_sign($params, $payParams['PartnerKey']);
        $xml_params = array_to_cdata_xml($params);
        $resp = postXmlCurl('https://qpay.qq.com/cgi-bin/pay/qpay_unified_order.cgi', $xml_params);
        $resp_arr = xml_to_array($resp);
        diy_log(['调起支付返回参数：', $resp_arr]);
        //判断预支付订单是否已经创建成功
        if ($resp_arr['return_code'] == 'SUCCESS') {//请求下单成功
            if ($resp_arr['result_code'] == 'SUCCESS') {//生成预支付订单成功
                //签名gaode
                $paySign = make_sign([
                    'appId'     => $payParams['AppId'],
                    'timeStamp' => "" . $time,
                    'nonceStr'  => $resp_arr['nonce_str'],
                    'package'   => 'prepay_id=' . $resp_arr['prepay_id'],
                    'signType'  => 'MD5',
                    'bargainor_id'=>$payParams['bargainor_id']
                ], $payParams['PartnerKey']);
                //要返回的数据
                $respData = [
                    'timeStamp' => "" . $time,
                    'nonceStr'  => $resp_arr['nonce_str'],
                    'package'   => 'prepay_id=' . $resp_arr['prepay_id'],
                    'signType'  => 'MD5',
                    'paySign'   => $paySign,
                    'bargainor_id' =>$resp_arr['mch_id']
                ];
                return $respData;
            } else {
                diy_log($resp_arr);
                return false;
            }
        } else {
            diy_log($resp_arr);
            return false;
        }
    }
    function confirm_sign ($data,$key,$sign_key='sign') {
        $sign=arr_get($data, $sign_key,false);
        if (!$sign){
            return false;
        }
        $data2=$data;
        unset($data2['sign']);
        $sign2=$this->make_sign($data2, $key);
        return $sign==$sign2;
    }

    function make_sign($params, $key)
    {
        ksort($params);
        $string = array_to_string($params);  //参数进行拼接key=value&k=v
        //签名步骤二：在string后加入KEY
        $string = $string . "&key=" . $key;
        //签名步骤三：MD5加密
        $string = md5($string);
        //签名步骤四：所有字符转为大写
        $result = strtoupper($string);
        return $result;
    }
}