<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/31
 * Time: 12:35
 */

namespace Addons\QrImage\Controller\Admin;

use Addons\QrImage\Helper;
use Lib\Request;
use Lib\Response;

class Collect extends \BaseController
{
    public function  index(Request $request){
        $wid=\Session::get('wid');
        if($request->method()=='POST')return $this->save_qr_config($request);
        $rule_url=addonsUrl('qr_image',['wid'=>$wid]);
        $png_file=Helper::getInstance()->getQrCode($rule_url,3,1,6);
        $this->assign('wid',$wid);
        $this->assign('rule_url',$rule_url);
        $this->assign('img',remove_path($png_file));
        return $this->show();
    }
    public function save_qr_config(Request $request){
        $files=$request->file('verify_file');
        $error='';
        foreach ($files as $file){
            $file_name=$file->getInfo('name');
            $check=$file->check(['ext'=>"txt",'type'=>getMimeTypeByExt('txt')]);
            if(!$check)return error('百度微信校验文件不合法只能为.txt文件');
            $path=pub_path(parse_url(dirname(addonsUrl('index')))['path']);
            is_dir($path) or mkdir($path);
            $file->move($path,$file_name);
            if($file->getError())$error=$file->getError();
        }
        $alipay_virify=$request->file('verify_file_alipay');
        if($alipay_virify){ #支付宝单独处理传到网站访问根目录
            $file_name=$alipay_virify->getInfo('name');
            $check=$alipay_virify->check(['ext'=>'html','type'=>getMimeTypeByExt('html,txt')]);
            if(!$check)return error('支付宝文件不合法只能为.html文件',['file_type'=>$alipay_virify->getMime()]);
            $path=pub_path('');
            is_dir($path) or mkdir($path);
            $alipay_virify->move($path,$file_name);
            if($alipay_virify->getError())$error=$alipay_virify->getError();
        }
        if($error){
            return error($error);
        }else{
            return success('保存成功');
        }

    }
    public function qr_image(Request $request){
        $applet_type=$request->param('applet_type') ? $request->param(['applet_type']) : get_applet_type();
        $png_file=Helper::getInstance()->getQrCode(get_host(''),3,1,6);
        return  Response::create($png_file,'file');
    }
}