<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/27
 * Time: 15:39
 */

namespace Addons\SykSupport;


use Services\Service;

class Helper extends Service
{
    /**
     * 商云客支付
     * 获取支付参数
     * @param $wid
     * @param $openid
     * @param $money
     * @param $notifyUrl
     * @param $OrderNo
     * @param $remark
     * @param string $attach
     * @return array|bool
     */
    function prepay($wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = '')
    {
        $sykConfig = new \Model('vshop_syk_pay');
        $sykConfig->find(array('wid' => $wid));
        $data = 'p0_Cmd=PreCreate&p1_Account=' . $sykConfig->username . '&p2_Amt=' . $money . '&p3_ProductCode=QR_CODE_OFFLINE&p4_subject=' . $remark . '&p7_plat=' . $sykConfig->plat . '&p8_Channel=7&p9_Notify_Url=' . $notifyUrl . '&p10_Attach=' . $wid . '&p11_MerOrderNo=' . $OrderNo . '&p13_memo=' . $remark . '&p17_OpenID=' . $openid;
        $hmac = strtoupper(md5($data . '&key=D81243076DDAD150A1034725E56511F8'));//加密校验串
        $get = $data . '&hmac=' . $hmac;
        $url = 'https://a.xfpay.cn/Api/ApiHandler.ashx?' . $get;
        $json_data = curlGets($url);
        $resp = json_decode($json_data, true);
        $jsPrepayInfo = $resp['data']['js_prepay_info'];//预付单信息
        $result_code = $resp['result'];
        if ($result_code == 100) {//预下单成功
            //要返回的数据
            $respData = [
                'timeStamp' => trim($this->str2arr($jsPrepayInfo)["'timeStamp'"], "'"),
                'nonceStr' => trim($this->str2arr($jsPrepayInfo)["'nonceStr'"], "'"),
                'package' => trim($this->str2arr($jsPrepayInfo)["'package'"], "'"),
                'signType' => trim($this->str2arr($jsPrepayInfo)["'signType'"], "'"),
                'paySign' => trim($this->str2arr($jsPrepayInfo)["'paySign'"], "'"),
            ];
            return $this->success('获取成功',$respData);
        } else {
            \Log::debug('商云客回调错误参数:' . json_encode($resp));
            return $this->error($resp['data']['detail_error_des']?$resp['data']['detail_error_des']:"下单失败");;
        }

    }


    //商云客退款
    function syk_refund($wid, $money, $OrderNo)
    {
        $sykConfig = new \Model('vshop_syk_pay');
        $sykConfig->find(array('wid' => $wid));
        $data = 'p0_Cmd=Refund&p1_Account=' . $sykConfig->username . '&p4_refund_amount=' . $money . '&p5_mer_order_no=' . $OrderNo . '&p6_pwd=' . strtoupper(md5($sykConfig->pwd));
        $hmac = strtoupper(md5($data . '&key=9652130BAA71D1DAB5A1921A03A8A928'));//加密校验串
        $get = $data . '&hmac=' . $hmac;
        $url = 'https://a.xfpay.cn/Api/ApiHandler.ashx?' . $get;
        $json_data = curlGets($url);
        $resp = json_decode($json_data, true);
        return $resp['result'];//100退款成功 111退款提交成功
    }

    function str2arr($str, $sp = ",", $kv = ":")
    {
        $arr = str_replace(array($kv, $sp), array('"=>"', '","'), 'array("' . $str . '")');
        eval("\$arr" . " = $arr;");   // 把字符串作为PHP代码执行
        return $arr;
    }
}