<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/16
 * Time: 16:35
 */

namespace Addons\SykSupport\Services\Plugins;

use Addons\SykSupport\Helper;

class Payment extends \BaseController
{
    /**
     * syk支付钩子
     * @param $params
     * @param array $extra
     * @return array|bool
     */
    public function _pay_params(&$params,array $extra){
    //         $wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = ''
        $pay_type=$extra['pay_type'];
        if($pay_type!='syk')return error('非 syk 类型');
        \Log::debug('syk支付参数:'.json_encode($extra));
        $pay_params=Helper::getInstance()->prepay($extra['wid'],$extra['openid'],
            $extra['money'],$extra['notifyUrl'],$extra['OrderNo'],$extra['remark'],$extra['attach']);
        if($pay_params['status']=='success'){
            $pay_params['pay_type']='syk';
            $params=success('ok',$pay_params['data']);
        }else{
            $params=error('err：'.$pay_params['msg']);
        }
        return false;#停止继续执行
    }

    /**
     * syk支付回调钩子
     * @param $params
     * @param array $extra
     * @return bool|string
     */
    public function _pay_notify(&$params,array $extra){
        \Log::debug('syk 支付插件回调获得参数:'.json_encode($extra));
        if($extra['pay_type']!='syk')return true;
        ini_set('date.timezone', 'Asia/Shanghai');
        error_reporting(0);
        $wid = $extra['wid'];
        $pay_resp = json_decode($_GET['data'], true);
        $signString='attach='.$_GET['attach'].'&data='.$_GET['data'].'&key=H357SFF768D786EBB07E1B8D9A4DABC';
        $sign=strtoupper(md5($signString));
        $hmac=$_GET['hmac'];
        //支付参数
        //验证签名
        $helper=Helper::getInstance();
        $pay_resp['out_trade_no']=$pay_resp['mer_order_no'];
        $pay_resp['transaction_id']=$pay_resp['trade_no'];
        if ($sign != $hmac) {
            \Log::debug('签名失败:'.json_encode($pay_resp));
            $return= "";
            $params=error('签名失败',['pay_resp'=>null,'return'=>$return]);
            return  false;

        }
        $return = "SUCCESS";
        $params=success('ok',['pay_resp'=>$pay_resp,'return'=>$return]);//返回解析数据
        return false;
    }
}