<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/6/4
 * Time: 11:06
 */

namespace Addons\TemplateMsg\Controller\Admin;

use Addons\TemplateMsg\Helper;
use Addons\TemplateMsg\Model\VshopTplMsgConfig;
use Addons\TemplateMsg\Services\WechatApi;
use BaseController;
use Lib\Request;
use Session;

class Wechat extends BaseController
{
    public function index(Request $request)
    {
//        if($request->isPost())return $this->check_template_info($request);
//       return  $this->show('');
//        var_dump(WX_getAccessToken(\Session::get('wid')));die;
        return $this->_wechat_template_list([], []);
    }

    public function get_tpl_list()
    {
        $wid = \Session::get('wid');
        $api = WechatApi::getInstance();
        $cate = $api->getCategory($wid);
        if ($cate['status'] !== "success") {
            return $cate;
        }
        $ids = array();
        foreach ($cate['data']['data'] as $value) {
            $ids[] = $value['id'];
        }

        $curr_page = 1;
        $limit = 30;
        do {

            $start = ($curr_page-1) * $limit;
            $list_re = $api->getPubTplList($wid, $ids, $start, $limit);
            if($list_re['status']!=="success"){
                echo "出现错误:".$list_re["msg"];die;
            }
            $list=$list_re['data']["data"];
            if(count($list)<1){
                break;
            }
            $model=new \Model("vshop_tplmsg_list");
            foreach ($list as $tpl){
                $model->insert([
                   "categoryId"=>$tpl['categoryId'],
                   "tid"=>$tpl['tid'],
                   "title"=>$tpl['title'],
                   "type"=>$tpl['type'],
                    'ctime'=>date("Y-m-d H:i:s",time())
                ]);
            }
            $curr_page++;
        } while (true);
        echo "同步完成";
    }

    public function _wechat_template_list(array $params, array $extra)
    {
        $wid = \Session::get('wid');
        $config = Helper::getInstance()->template_config();
        $list = VshopTplMsgConfig::where(['wid' => $wid])->get();
        $new_arr = [];
        foreach ($config as $module_name => $module) {
            $new_arr[$module_name]=array();
            foreach ($module as $key=>$con){
                $temp_arr = [
                    'wid' => $wid,
                    'type' => $module_name,
                    'tpl_name' => $con['tpl_name'],
                    'tpl_type' => $con['tpl_type'],
                    'keywords' => implode(',', array_column($con['keyword_list'], 'name')),
                    'tpl_key' => $key,
                    'template_id' => '',
                    'is_enable' => 0,
                    'created_at' => '',
                    'updated_at' => ''
                ];
                foreach ($list as $k => $li) {
                    if ($li['tpl_key'] == $key&&$li['type']==$module_name) {

                        $temp_arr = array_merge($temp_arr, [
                            'id' => $li['id'],
                            'template_id' => $li['template_id'],
                            'is_enable' => $li['is_enable'],
                            'created_at' => $li['created_at'] ? $li['created_at'] : '',
                            'updated_at' => $li['updated_at'] ? $li['updated_at'] : ''
                        ]);
                    }
                }
                $new_arr[$module_name][$key] = $temp_arr;
            }

        }
        $this->assign('data', $new_arr);
        return $this->show('', true);
    }

    public function init_template_info(Request $request)
    {
        $wid = \Session::get('wid');
        $config_tpl_list = Helper::getInstance()->template_config();

        if (!$config_tpl_list) return error('模版消息配置不存在');
        $exit_list = VshopTplMsgConfig::where(['wid' => $wid])->get();
        foreach ($config_tpl_list as $module_name => $module){
            foreach ($module as $tpl_key => $tpl) {
                $exit_row = null;
                $keyword_id_list = array_column($tpl['keyword_list'], 'id');
                foreach ($exit_list as $row) {
                    if ($row['tpl_key'] == $tpl_key&&$row['type']==$module_name) $exit_row = $row;
                }
                if (!$exit_row) {
                    $re = WechatApi::getInstance()->add_template($wid, $tpl_key, $keyword_id_list,$tpl['tpl_name']);
                    $data = $re['data'];
                    if($re['status'] == 'error'){
                        return error($re['msg']);
                    }
                    if (!empty($data['priTmplId'])) {

                        VshopTplMsgConfig::insert([
                            "wid" => $wid,
                            "type" => $module_name,
                            'tpl_key' => $tpl_key,
                            'template_id' => $data['priTmplId'],
                            'is_enable' => 0,
                            'created_at' => date('Y-m-d H:i:s', time()),
                            'updated_at' => date('Y-m-d H:i:s', time())
                        ]);
                    }
                } elseif (empty($exit_row['template_id'])) {
                    $re = WechatApi::getInstance()->add_template($wid, $tpl_key, $keyword_id_list,$tpl['tpl_name']);
                    $data = $re['data'];
                    if (!empty($data['priTmplId'])) {
                        $exit_row->template_id = $data['priTmplId'];
                        $exit_row->updated_at = date('Y-m-d H:i:s', time());
                        $exit_row->save();
                    }
                }
            }
        }
        return success('初始化成功');

    }

    public function change_enable(Request $request)
    {
        $wid = \Session::get('wid');
        $id = $request->post('id');
        $enable = $request->post('status', 0, 'intval');
        $data = VshopTplMsgConfig::where(['id' => $id, 'wid' => $wid])->first();
        if ($data) {
            $data->is_enable = $enable;
            $data->save();
            $is_enable = $data->is_enable;
        } else {
            $is_enable = 0;
        }
        return success('修改成功', ['is_enable' => $is_enable]);
    }

    /**
     * @param Request $request
     * @return string
     */
    public function check_template_info(Request $request)
    {
        $key = $request->get('key');
        $wid = Session::get('wid');
        $info = WechatApi::getInstance()->get_tpl_info($key, $wid);
        if ($info['status'] == 'error') {
            $this->assign('errMsg', $info['msg']);
            $data = [];
        } else {
            $data = $info['data'];
        }
        $this->assign('data', $data);
        return $this->show('', true);
    }
}
