<?php
/**
 * Created by daniel@liaodongting.com.
 * User: Daniel
 * Date: 2019/6/6
 * Time: 10:53
 */

namespace Addons\TemplateMsg\Services\Plugins\Wechat;


use Addons\TemplateMsg\Helper;
use Addons\TemplateMsg\Model\VshopTplMsgConfig;
use Exception;
use HttpCurl;
use Log;

class Template
{
    /**
     * 发送模版消息
     * @param array $params
     * @param array $extra
     * @return array|bool|mixed
     */
    public function send(array $params,array $extra){
        $wid=$params['wid'];
        $openid=$params['openid'];
        $type=$params['type'];
        $form_id=$params['form_id'];
        $page=$params['page'];
        $data=$params['data'];
        if(!$wid||!$openid||!$type||!$form_id){
            return error('必须参数不能为空 wid，openid，type，form_id',null);
        }
        $msg_config=Helper::getInstance()->template_config();
        $tpl_key='';
        $words_len=0;
        foreach ($msg_config as $key=>$config){
            if($config['tpl_type']===$type){
                $tpl_key=$key;
                $words_len=count($config['keywords_list']);
                break;
            }
        }
        $template_info=VshopTplMsgConfig::where(['wid'=>$wid,'tpl_key'=>$tpl_key,'is_enable'=>1])->first();
        if(!$template_info['template_id'])return error('模版不存在');
        $format_data=[];
        if(!empty($data['keyword1'])){ #如果传入是组合数据就不进行处理
            $format_data=$data;
        }else{
            for ($i=1;$i<=$words_len;$i++){
                $format_data["keyword{$i}"]=$data[$i-1];
            }
        }
        $template_id=$template_info['template_id'];
        $send_data=[
            'touser'=>$openid,
            'wid'=>$wid,
            "template_id"=>$template_id,
            'page'=>$page,
            'data'=>$format_data
            ];
        try {
            $access_token = WX_getAccessToken($wid);
            $send_url = 'https://api.weixin.qq.com/cgi-bin/message/subscribe/send?access_token=' . $access_token;
            $send_data = json_encode($send_data);//保留消息模板发送数据
            diy_log($data);
            $json_data = HttpCurl::post($send_url, $send_data);
            $resp = json_decode($json_data, 1);
            diy_log(['发送模板消息', $data, $resp]);
            if($resp['errcode']===0){
                return success('发送成功',$resp);
            }else{
                return error('发送失败：'.$resp['errmsg'],$resp);
            }
        } catch (Exception $e) {
            Log::error('微信模版消息出现错误：'.$e->getMessage()."\n".nl2br($e->getTraceAsString()));
        }
        return error('发送失败');
    }
}
