<?php
/**
订阅消息规则
参数类别	参数说明	参数值限制	说明
thing.DATA	事物	20个以内字符	可汉字、数字、字母或符号组合
number.DATA	数字	32位以内数字	只能数字，可带小数
letter.DATA	字母	32位以内字母	只能字母
symbol.DATA	符号	5位以内符号	只能符号
character_string.DATA	字符串	32位以内数字、字母或符号	可数字、字母或符号组合
time.DATA	时间	24小时制时间格式（支持+年月日）	例如：15:01，或：2019年10月1日 15:01
date.DATA	日期	年月日格式（支持+24小时制时间）	例如：2019年10月1日，或：2019年10月1日 15:01
amount.DATA	金额	1个币种符号+10位以内纯数字，可带小数，结尾可带“元”	可带小数
phone_number.DATA	电话	17位以内，数字、符号	电话号码，例：+86-0766-66888866
car_number.DATA	车牌	8位以内，第一位与最后一位可为汉字，其余为字母或数字	车牌号码：粤A8Z888挂
name.DATA	姓名	10个以内纯汉字或20个以内纯字母或符号	中文名10个汉字内；纯英文名20个字母内；中文和字母混合按中文名算，10个字内
phrase.DATA	汉字	5个以内汉字	5个以内纯汉字，例如：配送中
符号表示除中文、英文、数字外的常见符号，不能带有换行等控制字符。
 * 时间格式支持HH:MM:SS或者HH:MM。
 * 日期包含年月日，为y年m月d日，y年m月、m月d日格式，或者用‘-’、‘/’、‘.’符号连接，
 * 如2018-01-01，2018/01/01，2018.01.01，2018-01，01-01。
 * 每个模板参数都会以类型为前缀，例如第一个数字模板参数为number01.DATA，第二个为number02.DATA
 * 客户暂时使用 休闲娱乐行业分类  categoryId 666
 **/
return [
    "商城系统模板"=>[
        '1036' => [
            'tpl_name' => '订单状态通知',
            'tpl_type' =>'order_pay_success',
            'keyword_list' => [
                ['id' => 3, 'name' => '支付金额',"key"=>"amount3"],
                ['id' => 4, 'name' => '下单时间',"key"=>"time4"],
                ['id' => 2, 'name' => '商品信息',"key"=>"thing2"],
                ['id' => 1, 'name' => '温馨提示',"key"=>"thing1"]
            ]
        ]

    ],
    "营销活动模板"=>[
        '580' => [
            'tpl_name' => '大转盘-中奖结果通知',
            'tpl_type' =>'winning_result',
            'keyword_list' => [
                ['id' => 6, 'name' => '奖品名称',"key"=>"thing6"],
                ['id' =>7 , 'name' => '中奖时间',"key"=>"time7"],

            ]
        ]
    ],
    "酒店系统模板"=>[
        '1787' => [
            'tpl_name' => '预约成功通知',
            'tpl_type' =>'appoint_success',
            'keyword_list' => [
                ['id' => 5, 'name' => '预约单号',"key"=>"character_string5"],
                ['id' => 1, 'name' => '预约服务',"key"=>"thing1"],
                ['id' => 3, 'name' => '开始时间',"key"=>"date3"],
                ['id' => 6, 'name' => '姓名',"key"=>"name6"],
                ['id' => 7, 'name' => '电话',"key"=>"phone_number7"]
            ]
        ]
    ],
    "智慧餐厅模板"=>[
        '1036' => [
            'tpl_name' => '订单状态通知',
            'tpl_type' =>'zhct_order_pay_success',
            'keyword_list' => [
                ['id' => 3, 'name' => '支付金额',"key"=>"amount3"],
                ['id' => 4, 'name' => '下单时间',"key"=>"time4"],
                ['id' => 2, 'name' => '商品信息',"key"=>"thing2"],
                ['id' => 1, 'name' => '温馨提示',"key"=>"thing1"]
            ]
        ],
    ],
    '会员管理模板'=>[
        '1003' => [
            'tpl_name' => '账户积分变动提醒',
            'tpl_type' =>'exchange_success',
            'keyword_list' => [
                ['id' => 4, 'name' => '备注',"key"=>"thing4"],
                ['id' => 8, 'name' => '当前积分',"key"=>"number8"]
            ]
        ],
        '6083' => [
            'tpl_name' => '充值成功通知',
            'tpl_type' =>'recharge_success',
            'keyword_list' => [
                ['id' => 3, 'name' => '充值时间',"key"=>"time3"],
                ['id' => 2, 'name' => '充值金额',"key"=>"amount2"],
                ['id' => 5, 'name' => '账户余额',"key"=>"amount5"],
            ]
        ],
        '3745' => [
            'tpl_name' => '支付成功通知',
            'tpl_type' =>'pay_success',
            'keyword_list' => [
                ['id' => 1, 'name' => '订单号',"key"=>"number1"],
                ['id' => 3, 'name' => '支付时间',"key"=>"date3"],
                ['id' => 4, 'name' => '支付金额',"key"=>"amount4"],
                ['id' => 5, 'name' => '备注',"key"=>"thing5"]
            ]
        ],
        '1036' => [
            'tpl_name' => '订单状态通知',
            'tpl_type' =>'order_pay_success',
            'keyword_list' => [
                ['id' => 3, 'name' => '支付金额',"key"=>"amount3"],
                ['id' => 4, 'name' => '下单时间',"key"=>"time4"],
                ['id' => 2, 'name' => '商品信息',"key"=>"thing2"],
                ['id' => 1, 'name' => '温馨提示',"key"=>"thing1"]
            ]
        ],

    ],


];
