<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/20
 * Time: 12:56
 */

namespace Addons\TtSupport;


use Addons\TtSupport\Services\Library\AliHelper;
use Lib\Request;
use Services\Service;
use Models\BaseModel as Model;
class Helper extends Service
{
    /**
     * 头条小程序获取支付参数
     * @param $wid
     * @param $openid
     * @param $money
     * @param $notifyUrl
     * @param $OrderNo
     * @param $remark
     * @param string $attach
     * @return array|bool
     */
    function prepay($wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = '') {
        $ttConfig = new \Model('vshop_tt_pay');
        $ttConfig->find(array('wid' => $wid));
        $time=time();
        $tradeNo=$OrderNo;
        //构造业务请求参数的集合(订单信息)
        $zfbbizContent = array();
        $zfbbizContent['subject'] = $remark;
        $zfbbizContent['out_trade_no'] = $OrderNo;//平台订单号
        $zfbbizContent['total_amount'] = "".$money;//单位元
        $zfbbizContent['product_code'] = "QUICK_MSECURITY_PAY";//销售产品码,固定值
        $zfbbizContentJson = json_encode($zfbbizContent,320);//$content是biz_content的值,将之转化成json字符串
        //公共参数
        $aop = new AliHelper();//实例化支付宝sdk里面的AopClient类,下单时需要的操作,都在这个类里面
        $zfbparams['app_id'] = $ttConfig->zfbAppId;
        $zfbparams['method'] = 'alipay.trade.app.pay';//接口名称，固定值
        $zfbparams['charset'] = 'utf-8';//请求使用的编码格式
        $zfbparams['sign_type'] = 'RSA2';//商户生成签名字符串所使用的签名算法类型
        $zfbparams['timestamp'] = date("Y-m-d H:i:s",$time);//发送请求的时间
        $zfbparams['version'] = '1.0';//调用的接口版本，固定为：1.0
        $zfbparams['notify_url'] = $notifyUrl;
        $zfbparams['biz_content'] = $zfbbizContentJson;//业务请求参数的集合,长度不限,json格式，即前面一步得到的
        \Log::debug('支付宝签名内容'.http_build_query($zfbparams));
        $paramsStr = $aop->getSignContent($zfbparams);//组装请求签名参数
        $RSAsign = $aop->alonersaSign($paramsStr, $ttConfig->privateKey, 'RSA2');//生成签名
        $zfbparams['sign'] = $RSAsign;
        $zfbstr = $aop->getSignContentUrlencode($zfbparams);//最终请求参数
        //支付参数
        $payparams = [
            'app_id' => $ttConfig->payAppId,
            'sign_type' => 'MD5',
            'timestamp' => "{$time}",
            'trade_no' => $tradeNo,
            'merchant_id' => $ttConfig->merchantId,
            'uid' => $openid,
            'total_amount' => $money * 100,//单位分
            'params' => json_encode(["url"=>$zfbstr])
        ];
        $paysign=tt_sign($payparams,$ttConfig->paySecret);
        $payparams['sign']=$paysign;
        // $payparams['url']=$zfbstr;
        $payparams['method']='tp.trade.confirm';
        $payparams['pay_channel']='ALIPAY_NO_SIGN';
        $payparams['pay_type']='ALIPAY_APP';
        $payparams[ "risk_info"] =json_encode(["ip"=>"127.0.0.1"]);

        return $payparams;
    }
    /**
     * 支付宝支付回调 支付宝APP支付验签（头条APP支付）
     * @param $wid
     * @param $posts
     * @return mixed
     */
    function tt_check_sign($wid,$posts){
        //获取小程序配置信息
        $ttConfig = new \Model('vshop_tt_pay');
        $ttConfig->find(array('wid' => $wid));
        $aop = new AliHelper();
        $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
        $aop->appId =$ttConfig->zfbAppId;
        $aop->rsaPrivateKey = $ttConfig->privateKey;
        $aop->alipayrsaPublicKey= $ttConfig->publicKey;
        $aop->apiVersion = '1.0';
        $aop->signType = 'RSA2';
        $aop->postCharset='UTF-8';
        $aop->format='json';
        $checkSign=$aop->rsaCheckV1($posts, NULL,$aop->signType);
        return $checkSign;
    }

    function tt_sign($params, $key)
    {
        ksort($params);
        $string = array_to_string($params);  //参数进行拼接key=value&k=v
        //签名步骤二：在string后加入KEY
        $string = $string . $key;
        //签名步骤三：MD5加密
        $result = md5($string);
        return $result;
    }

    /**
     * 获取头条token
     * @param $app_key
     * @param $app_secret
     * @return array|mixed
     */
    public function getAccessToken($app_key,$app_secret){
        if(!$app_key||!$app_secret)return $this->error("配置错误");
        $cache_key='tt_token_'.md5($app_key.$app_secret);
        $data=\Cache::get($cache_key);

        if(!$data||true){
            $res=\HttpCurl::get('https://developer.toutiao.com/api/apps/token',['appid'=>$app_key,'secret'=>$app_secret,'grant_type'=>'client_credential']);

            $arr=json_decode($res,true);
            if($arr['errcode']==0){
                $data=$this->success('获取成功',['access_token'=>$arr['access_token'],'expires_in'=>$arr['expires_in']]);
                \Cache::set($cache_key,$data,1);
            }else{
                \Cache::remove($cache_key);
                $data=$this->error('获取token失败:'.$arr['errmsg']);
            }
        }
        return $data;


    }
    /**
     * 生成小程序二维码
     * @param $wid
     * @param $platPath
     * @param $params
     * @param null $filePath
     * @param string $describe
     * @return array
     * @throws \Exception
     */
    function create_qr($wid,$platPath,$params,$filePath=null,$describe=""){
        $config=(new Model("vshop_tt_pay"))->find(['wid'=>$wid]);
        if(!$config->id)return error("出现错误错误:没有找到商家对应的配置信息");
        $tokenInfo=$this->getAccessToken($config->TtAppId,$config->TtAppSecret);
        if($tokenInfo['status']!='success'||!$token=$tokenInfo['data']['access_token'])return $this->error($tokenInfo['msg'],$tokenInfo);
        $name_arr=[
            "toutiao"=>"toutiao",
            "douyin"=>"douyin",
            "pipixia"=>"pipixia",
            "huoshan"=>"huoshan"
        ];
        $request=Request::instance();
        $appname=strtolower($params['appname']);
        \Log::error("appname:".$appname);
        $requestBody=json_encode([
            'access_token'=>$token,
            'path'=>urlencode($platPath."?scene=".$params['scene']),
            'appname'=>isset($name_arr[$appname]) ? $name_arr[$appname] : 'toutiao' ,
            'width'=>$params['width'] ? $params['width'] : 430,
        ]);
        $ch = curl_init();
        $headers = array(
            "Content-Type: application/json"
        );

        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $requestBody);
        curl_setopt($ch, CURLOPT_URL, 'https://developer.toutiao.com/api/apps/qrcode');
        // 发送一个常规的Post请求
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        $result_data = curl_exec($ch);

        curl_close($ch);
        if (strlen($result_data) < 1024 ) {
            $resut=json_decode($result_data,true);
            return error("生成失败:".$resut['errmsg'],[$token]);
        }else{
            if($filePath==null)$filePath="UserPage/qrcode_".date('Ymd') . DS . md5(microtime(true)).".png";
            $full_Path=pub_path($filePath);
            $path=dirname($full_Path);
            is_dir($path) or mkdir($path,0751,true);
            $content=$result_data;
            file_put_contents($full_Path,$content);
            return success('生成成功',['url'=>get_host($filePath),'path'=>$filePath]);
        }


    }
}