<?php
/**
 * Created by daniel
 * User: Daniel
 * Date: 2019/10/21
 * Time: 11:18
 */

namespace Addons\TtSupport;
$AlipayTradeCreateRequest=app_path("/fun/alipay/aop/request/AlipayTradeCreateRequest.php");
if(file_exists($AlipayTradeCreateRequest)){
    require_once $AlipayTradeCreateRequest;
}
$AlipayTradeCreateRequest="/fun/alipay/aop/request/AlipayTradeCreateRequest.php";
if(file_exists($AlipayTradeCreateRequest)){
    require_once $AlipayTradeCreateRequest;
}
use Addons\TtSupport\Services\Library\AliHelper;
use AlipayTradeRefundRequest;
use AopClient;
use Models\BaseModel as Model;
use Services\Service;

class HelperCheckStand extends Service
{
    /**
     * 头条收银台签名
     * @param $params
     * @param $key
     * @return string
     */
    function tt_checkout_stand_sign($params, $key)
    {
        ksort($params);
        $signStr = '';
        foreach($params as $k=>$v){
            if(!$v||in_array($k,['risk_info', 'sign'])){
                continue;
            }
            if(strlen($signStr) >0){
                $signStr.="&";
            }
            if(is_array($v)){
                $v=json_encode($v);
            }
            $signStr.=$k."=".$v;
        }
        $signStr.=$key;
//        echo $signStr;die;
        $sign=md5($signStr);
        return $sign;
    }
    function tt_sign($params, $key)
    {
        ksort($params);
        $string = array_to_string($params);  //参数进行拼接key=value&k=v
        //签名步骤二：在string后加入KEY
        $string = $string . $key;
        //签名步骤三：MD5加密
        $result = md5($string);
        return $result;
    }
    /**
     * 头条小程序获取支付参数
     * @param $wid
     * @param $openid
     * @param $money
     * @param $notifyUrl
     * @param $orderNo
     * @param $remark
     * @param string $attach
     * @return array|bool
     */
    function prepay($wid, $openid, $money, $notifyUrl, $orderNo, $remark, $attach = '') {
        $ttConfig = new \Model('vshop_tt_pay');
        $ttConfig->find(array('wid' => $wid));
        $time=time();

        $orderInfo=[
           "merchant_id"=>$ttConfig->merchantId,
            "app_id"=>$ttConfig->payAppId,
            "sign_type"=>"MD5",
            'timestamp' => $time,
            'version'   => '2.0',
            'trade_type'=>"H5",
            'product_code'=>'pay',
            'payment_type'=>'direct',
            'out_order_no'=>$orderNo,
            'uid'=>$openid,
            'total_amount'=>$money*100,//单位分
            'currency'=>'CNY',
            'subject'=>$remark,
            'body'=>$remark,
            'trade_time'=>$time,
            'valid_time'=>86400,
            'notify_url'=>$notifyUrl,
            "risk_info"=> '{"ip":"127.0.0.1"}',


            ];
        $alipay_params=$this->getAlipayUrl($ttConfig, $openid, $money, $notifyUrl, $orderNo, $remark, $attach );
        if($alipay_params['status']=='success'){
            $orderInfo['alipay_url']=$alipay_params['data']['alipay_url'];

        }
        $wx_params=$this->getWxUrl($ttConfig, $openid, $money, $notifyUrl, $orderNo, $remark, $attach);
        if($wx_params['status']=='success'){
            $orderInfo['wx_url']=$wx_params['data']['mweb_url'];
            $orderInfo['wx_type']='MWEB';
            diy_log("微信参数获取成功:".json_encode($wx_params));
        }else{
            diy_log("微信参数获取失败:".json_encode($wx_params));
        }

        $orderInfo['sign']=$this->tt_checkout_stand_sign($orderInfo,$ttConfig->paySecret);
        if(!$orderInfo['wx_url']&&!$orderInfo['alipay_url']){
            return error("获取支付信息失败:微信和支付宝信息错误",$orderInfo);
        }

        return success('获取成功',$orderInfo);
    }

    /**
     * 获取支付宝支付参数
     * @param \Model $config
     * @param $openid
     * @param $money
     * @param $notifyUrl
     * @param $orderNo
     * @param $remark
     * @param string $attach
     * @param $alipayUrl
     * @return array
     */
    public  function getAlipayUrl($config, $openid, $money, $notifyUrl, $orderNo, $remark, $attach = ''){
        //获取小程序配置信息

        $time=time();
        //构造业务请求参数的集合(订单信息)
        $zfbbizContent = array();
        $zfbbizContent['subject'] = $remark;
        $zfbbizContent['out_trade_no'] = $orderNo;//平台订单号
        $zfbbizContent['total_amount'] = "".$money;//单位元
        $zfbbizContent['product_code'] = "QUICK_MSECURITY_PAY";//销售产品码,固定值
        $zfbbizContentJson = json_encode($zfbbizContent,320);//$content是biz_content的值,将之转化成json字符串
        //公共参数
        $aop = new AliHelper();//实例化支付宝sdk里面的AopClient类,下单时需要的操作,都在这个类里面
        $zfbparams['app_id'] = $config->zfbAppId;
        $zfbparams['method'] = 'alipay.trade.app.pay';//接口名称，固定值
        $zfbparams['charset'] = 'utf-8';//请求使用的编码格式
        $zfbparams['sign_type'] = 'RSA2';//商户生成签名字符串所使用的签名算法类型
        $zfbparams['timestamp'] = date("Y-m-d H:i:s",$time);//发送请求的时间
        $zfbparams['version'] = '1.0';//调用的接口版本，固定为：1.0
        $zfbparams['notify_url'] = $notifyUrl;
        $zfbparams['biz_content'] = $zfbbizContentJson;//业务请求参数的集合,长度不限,json格式，即前面一步得到的
        \Log::debug('支付宝签名内容'.http_build_query($zfbparams));
        $paramsStr = $aop->getSignContent($zfbparams);//组装请求签名参数
        $RSAsign = $aop->alonersaSign($paramsStr, $config->privateKey, 'RSA2');//生成签名
        $zfbparams['sign'] = $RSAsign;
        $zfbstr = $aop->getSignContentUrlencode($zfbparams);//最终请求参数

        if($config->zfbAppId&& $config->privateKey&&$config->publicKey){

            return success('获取支付信息成功',['alipay_url'=>$zfbstr]);
        }else{

            return error('商户未配置支付宝，无法获取配置');
        }

    }
    public  function getWxUrl($config, $openid, $money, $notifyUrl, $orderNo, $remark, $attach = ''){

        $time = time();
        $nonce_str = md5(time() . rand() . rand() . '微信支付');
        $body = $remark ?$remark:"产品下单" ;

        if($config->wxStatus==1){
            $params = [
                'appid'            => $config->wxAppId,//小程序ID
                'mch_id'           =>$config->wxPartnerId,//商户号
                'nonce_str'        => $nonce_str,//随机字符串
                'body'             => $body,//商品描述(可以拼接字符串生成)
                'out_trade_no'     => $orderNo,//商品订单号
                'total_fee'        => $money * 100,//总金额
                'spbill_create_ip' => $this->get_client_ip(),//终端IP
                'notify_url'       => $notifyUrl,//通知地址
                'trade_type'       => 'MWEB',//交易类型(小程序固定是JSAPI)
//                'openid'           => $openid,//用户的openid
                'scene_info'       => '{"h5_info": {"type":"Wap","wap_url": "","wap_name": ""}}',
                'attach'           => is_string($attach) ? $attach : json_encode([])
            ];
        }else{
            $params = [
                'appid' => $config->wxServiceAppId ,//服务商ID
                'mch_id' =>$config->wxServicePartnerId,//商户号
                'sub_appid' =>$config->wxAppId,//小程序的APPID
                'sub_mch_id' => $config->wxServicePartnerId,//子商户号

                'nonce_str'        => $nonce_str,//随机字符串
                'body'             => $body,//商品描述(可以拼接字符串生成)
                'out_trade_no'     => $orderNo,//商品订单号
                'total_fee'        => $money * 100,//总金额
                'spbill_create_ip' => $this->get_client_ip(),//终端IP
                'notify_url'       => $notifyUrl,//通知地址
                'trade_type'       => 'MWEB',//交易类型(小程序固定是JSAPI MWEB 为h5)
//                'sub_openid'           => $openid,//用户的openid
                'scene_info'       => '{"h5_info": {"type":"Wap","wap_url": "","wap_name": ""}}',
                'attach'           => is_string($attach) ? $attach : json_encode([])
            ];
        }


        $params['sign'] =make_sign(array_filter($params), $config->wxPartnerKey);
        $xml_params = array_to_cdata_xml($params);
        $resp = postXmlCurl('https://api.mch.weixin.qq.com/pay/unifiedorder', $xml_params);
        $resp_arr = xml_to_array($resp);
        //判断预支付订单是否已经创建成功
        if ($resp_arr['return_code'] == 'SUCCESS') {//请求下单成功
            if ($resp_arr['result_code'] == 'SUCCESS') {//生成预支付订单成功

                return success("获取成功",$resp_arr);
            } else {
                return error($resp_arr['err_code_des']);
            }
        } else {
          return error($resp_arr['return_msg']);
        }
    }
    /**
     * 查询头条微信订单用于判断是微信支付还是支付宝支付
     * @param $ttConfig
     * @param $order_no
     * @return array
     */
    public function queryWxOrder($ttConfig,$order_no){

        //准备查询所需的参数
        $nonce_str = md5(microtime() . 'adhfiahsdfjas;kljfdsadfnsajkdfhsdufhsa' . rand());
        if($ttConfig->wxStatus ==1){
            $data = [
                'appid' => $ttConfig->wxAppId,
                'mch_id' => $ttConfig->wxPartnerId,
                'nonce_str' => $nonce_str,
                'transaction_id' => $order_no,

            ];
        }else{
            $data = [
                'appid' => $ttConfig->wxServiceAppId,
                'mch_id' => $ttConfig->wxServicePartnerId,
                'sub_appid' => $ttConfig->wxAppId,//小程序的APPID
                'sub_mch_id' => $ttConfig->wxServicePartnerId,//子商户号
                'nonce_str' => $nonce_str,
                'transaction_id' => $order_no,

            ];
        }

        $data['sign'] = make_sign($data, $ttConfig->wxPartnerKey );
        $xml_data = array_to_cdata_xml($data);
        $ch = curl_init();
        //超时时间
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, 'https://api.mch.weixin.qq.com/pay/orderquery');
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        //设置证书
        //POST的数据
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_data);
        //发起请求
        $data = curl_exec($ch);

        if ($data) {
            curl_close($ch);
            $data = xml_to_array($data);
            if ($data['result_code'] == 'SUCCESS') {
                return success("查询成功",$data);
            } else {
                return error("查询失败".$data['err_code_des'],$data);
            }
            return success("查询成功",$data);
        } else {
            $error = curl_error($ch);
            curl_close($ch);
            return error('查询失败'.$error);
//        return false;
        }
    }
    public function  tt_check_sign($wid, $data,$type){
        //获取小程序配置信息
        $ttConfig = new \Model('vshop_tt_pay');
        $ttConfig->find(array('wid' => $wid));
        if($type=='alipay'){
//            $aop = new AliHelper();
//            $aop->appId =$ttConfig->zfbAppId;
//            $aop->rsaPrivateKey = $ttConfig->privateKey;
//            $aop->alipayrsaPublicKey= $ttConfig->publicKey;
//            $aop->apiVersion = '2.0';
//            $aop->signType = 'RSA2';
//            $aop->postCharset='UTF-8';
//            $aop->format='json';
//            $checkSign=$aop->rsaCheckV1($data, NULL,$aop->signType);
//            return $checkSign;

            $aop = new \AopClient();
            $aop->appId =$ttConfig->zfbAppId;
            $aop->rsaPrivateKey = $ttConfig->privateKey;
            $aop->alipayrsaPublicKey= $ttConfig->publicKey;
            $aop->apiVersion = '1.0';
            $aop->signType = 'RSA2';
            $aop->postCharset='UTF-8';
            $aop->format='json';
            $checkSign=$aop->rsaCheckV1($data, NULL,$aop->signType);
            return $checkSign;
        }else{
            return confirm_sign($data, $ttConfig->wxPartnerKey);
        }
    }

    /**
     * @param $ttConfig
     * @param $order_no 商户单号
     * @param $out_trade_no 支付平台单号
     * @param $money
     * @param string $type
     * @return array
     * @throws \Exception
     */
    public function refundOrder($ttConfig,$order_no,$out_trade_no,$money,$type='wechat'){
        if($type=='alipay'){
            require_once app_path("/fun/alipay/aop/AopClient.php");
            require_once app_path("/fun/alipay/aop/request/AlipayTradeRefundRequest.php");

            $aop = new AopClient ();
            $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
            $aop->appId = $ttConfig->zfbAppId;
            $aop->rsaPrivateKey = $ttConfig->privateKey;
            $aop->alipayrsaPublicKey= $ttConfig->publicKey;
            $aop->apiVersion = '1.0';
            $aop->signType = 'RSA2';
            $aop->postCharset='UTF-8';
            $aop->format='json';
            $request = new AlipayTradeRefundRequest ();
            $request->setBizContent("{" .
                "\"out_trade_no\":\"$order_no\"," .
                "\"trade_no\":\"$out_trade_no\"," .
                "\"refund_amount\":\"$money\"" .
                "}");
            $resultTradeCreate = $aop->execute ($request);
            $result=is_string($resultTradeCreate)?$resultTradeCreate:json_decode(json_encode($resultTradeCreate),true);
            $responseNode = str_replace(".", "_", $request->getApiMethodName()) . "_response";
            if($result[$responseNode]['code']==10000){
                //找到订单
                return success("退款成功",$result[$responseNode]);
            }else{
                return error("退款失败:".$result[$responseNode]['sub_msg']);
            }
        }else{
            //准备退款所需的参数
            $nonce_str = md5(microtime() . 'adhfiahsdfjas;kljfdsadfnsajkdfhsdufhsa' . rand());
            if($ttConfig->wxStatus==1 ){
                $data = [
                    'appid' => $ttConfig->wxAppId,
                    'mch_id' => $ttConfig->wxPartnerId,
                    'nonce_str' => $nonce_str,
                    'transaction_id' => $out_trade_no,
                    'out_refund_no' => $order_no,
                    'total_fee' => $money * 100,//换算单位
                    'refund_fee' => $money * 100,//换算单位
                    'op_user_id' => $ttConfig->wxPartnerId
                ];
            }else{
                $data = [
                    'appid' => $ttConfig->wxServiceAppId,
                    'mch_id' => $ttConfig->wxServicePartnerId,
                    'sub_appid' => $ttConfig->wxAppId,//小程序的APPID
                    'sub_mch_id' => $ttConfig->wxServicePartnerId,//子商户号
                    'nonce_str' => $nonce_str,
                    'transaction_id' => $out_trade_no,
                    'out_refund_no' => $order_no,
                    'total_fee' => $money * 100,//换算单位
                    'refund_fee' => $money * 100,//换算单位
                    'op_user_id' => $ttConfig->wxPartnerId
                ];
            }

            $data['sign'] = make_sign($data, $ttConfig->wxPartnerKey);
            $xml_data = array_to_cdata_xml($data);
            $ch = curl_init();
            //超时时间
            curl_setopt($ch, CURLOPT_TIMEOUT, 10);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_URL, 'https://api.mch.weixin.qq.com/secapi/pay/refund');
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
            //设置证书
            curl_setopt($ch, CURLOPT_SSLCERT, static_path($ttConfig->wxCert));
            curl_setopt($ch, CURLOPT_SSLKEY, static_path($ttConfig->wxKey));
            //POST的数据
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_data);
            //发起请求
            $data = curl_exec($ch);
            if ($data) {
                curl_close($ch);
                $data = xml_to_array($data);
                if ($data['return_code'] == 'SUCCESS') {
                    if ($data['result_code'] == 'SUCCESS') {

                        return success("退款成功",$data);
                    } else {
                        return error("退款失败：".(arr_get($data, 'err_code_desc') ? arr_get($data, 'err_code_desc') :arr_get($data, 'err_code') ));
                    }
                } else {
                    return error('发起退款失败：' . $data['return_msg']);
                }
            } else {
                $error = curl_error($ch);
                curl_close($ch);
                return error('退款请求失败'.$error);
            }

        }

    }

    /**
     * 获取设备ip
     * @return string
     */
    public function get_client_ip(){
        foreach (array(
                     'HTTP_CLIENT_IP',
                     'HTTP_X_FORWARDED_FOR',
                     'HTTP_X_FORWARDED',
                     'HTTP_X_CLUSTER_CLIENT_IP',
                     'HTTP_FORWARDED_FOR',
                     'HTTP_FORWARDED',
                     'REMOTE_ADDR') as $key) {
            if (array_key_exists($key, $_SERVER)) {
                foreach (explode(',', $_SERVER[$key]) as $ip) {
                    $ip = trim($ip);
                    //会过滤掉保留地址和私有地址段的IP，例如 127.0.0.1会被过滤
                    //也可以修改成正则验证IP
                    if ((bool) filter_var($ip, FILTER_VALIDATE_IP,
                        FILTER_FLAG_IPV4 |
                        FILTER_FLAG_NO_PRIV_RANGE |
                        FILTER_FLAG_NO_RES_RANGE)) {
                        return $ip;
                    }
                }
            }
        }
        return 'unknown';

    }

}
