<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/20
 * Time: 12:57
 */

namespace Addons\TtSupport\Services\Plugins;


use Addons\TtSupport\Helper;
use Addons\TtSupport\HelperCheckStand;
use Services\Service;

class Payment extends Service
{
    /**
     * 头条支付钩子
     * @param $params
     * @param array $extra
     * @return array|bool
     */
//    public function _pay_params(&$params,array $extra){
////         $wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = ''
//        $pay_type=$extra['pay_type'];
//        if($pay_type!='toutiao')return error('非 toutiao 类型');
//        \Log::debug('toutiao 支付参数:'.json_encode($extra));
//        $pay_params=Helper::getInstance()->prepay($extra['wid'],$extra['openid'],
//            $extra['money'],$extra['notifyUrl'],$extra['OrderNo'],$extra['remark'],$extra['attach']);
//        if($pay_params){
//            $params=success('ok',$pay_params);
//        }else{
//            $params=error('err',null);
//        }
//        return false;#停止继续执行
//    }
//
//    /**
//     * 头条支付回调钩子
//     * @param $params
//     * @param array $extra
//     * @return bool|string
//     */
//    public function _pay_notify(&$params,array $extra){
//        \Log::debug('toutiao 支付插件回调获得参数:'.json_encode($extra));
//        if($extra['pay_type'] != 'toutiao')return true;
//        ini_set('date.timezone', 'Asia/Shanghai');
//        error_reporting(0);
//        $wid = $extra['wid'];
//        $post=$_POST;
//        $pay_resp = $post;
//        //支付参数
//        //验证签名
//        $helper=Helper::getInstance();
//        $pay_resp['transaction_id']=$pay_resp['trade_no'];
//        if (!$helper->tt_check_sign($wid, $post)) {
//            \Log::debug('签名失败:'.json_encode($post));
//            $return= "failure";
//            $params=error('签名失败',['pay_resp'=>null,'return'=>$return]);
//            return  false;
//
//        }
//
//        $return = "success";
//        $params=success('ok',['pay_resp'=>$pay_resp,'return'=>$return]);//返回解析数据
//        return false;
//    }
    /**
     * 头条支付收银台钩子
     * @param $params
     * @param array $extra
     * @return array|bool
     */
    public function _pay_params(&$params,array $extra){
        $pay_type=$extra['pay_type'];
        if($pay_type!='tt_pay')return error('非 tt_pay 收银台类型');
        \Log::debug('tt_pay 支付参数:'.json_encode($extra));
        $pay_params=HelperCheckStand::getInstance()->prepay($extra['wid'],$extra['openid'],
            $extra['money'],$extra['notifyUrl'],$extra['OrderNo'],$extra['remark'],$extra['attach']);
        if($pay_params['status']=='success'){
            $params=success('ok',$pay_params['data']);
        }else{
            $params=error('err:'.$pay_params['msg'],null);
        }
        return false;#停止继续执行
    }
    /**
     * 头条支付回调钩子
     * @param $params
     * @param array $extra
     * @return bool|string
     */
    public function _pay_notify(&$params,array $extra){
        \Log::debug('tt_pay 支付插件回调获得参数:'.json_encode($extra));
        if($extra['pay_type'] != 'tt_pay')return true;
        ini_set('date.timezone', 'Asia/Shanghai');
        error_reporting(0);
        $wid = $extra['wid'];
        if(!empty($_POST['trade_no'])){
            $type="alipay";
            $data=$_POST;

            $return_success = "success";
            $return_error = "failure";
        }else{
            $type="wechat";
            $xml = file_get_contents("php://input");
            $data = xml_to_array($xml);
            $return_success = "<xml><return_code><![CDATA[SUCCESS]]></return_code><return_msg><![CDATA[OK]]></return_msg></xml>";
            $return_error =  "<xml><return_code><![CDATA[FAIL]]></return_code><return_msg><![CDATA[签名失败]]></return_msg></xml>";;
        }
        \Log::debug(sprintf("回调类型:%s",$type));
        //支付参数
        //验证签名
        $helper=HelperCheckStand::getInstance();
        if (!$helper->tt_check_sign($wid, $data,$type)) {
            \Log::debug('签名失败:'.json_encode($data));
            $params=error('签名失败',['pay_resp'=>null,'return'=>$return_error]);
            return  false;

        }
        if($type=='alipay'){
            $data['transaction_id']=$data['trade_no'];
        }
        \Log::debug(sprintf("回调返回数据:%s",json_encode($data)));
        $params=success('ok',['pay_resp'=>$data,'return'=>$return_success]);//返回解析数据
        return false;
    }
    public function  _pay_refund(&$params,array $extra){
        if($extra['pay_type'] != 'tt_pay')return true;
        ini_set('date.timezone', 'Asia/Shanghai');
        error_reporting(0);
        $wid = $extra['wid'];
        $out_trade_no=$extra['out_trade_no'];
        $order_no=$extra['order_no'];
        $money=$extra['money'];
        //查询是否微信订单
        $helper=HelperCheckStand::getInstance();
        $ttConfig = new \Model('vshop_tt_pay');
        $ttConfig->find(array('wid' => $wid));
        if(!$ttConfig->id){
            $params= error("获取头条配置错误，请检查");
            return false;
        }
        $wxQueryRe=$helper->queryWxOrder($ttConfig,$out_trade_no);
        diy_log("微信查询结果:".json_encode($wxQueryRe)."out_trade_no:".$out_trade_no);
        if($wxQueryRe['status']=='success'){
            $type="wechat";
        }else{
            $type="alipay";
        }

        try{
            $params=$helper->refundOrder($ttConfig,$order_no,$out_trade_no,$money,$type);
        }catch (\Exception $e){
            $params=error("出现错误:".$e->getMessage());
        }
        return false;
    }


}