<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/24
 * Time: 11:15
 */

namespace Addons\VipCard\Controller\Api;


use Addons\VipCard\Helper;
use Addons\VipCard\Models\VipCard;
use Addons\VipCard\Models\VipPayment;
use Addons\VipCard\Models\VipSetting;
use Addons\VipCard\Services\Plugins\Data\NotifyParams;

class VipPay extends \BaseController
{
    public function index()
    {
        $req = getPayloadParams();
        if(!empty($req['transaction_id'])){
            $where=['transaction_id'=>$req['transaction_id']];
        }elseif (!empty($req['order_no'])&&!empty($req['wid'])&&!empty($req['openid'])){
            $where=['order_no'=>$req['order_no'],'wid'=>$req['wid'],'openid'=>$req['openid']];
        }else{
           return error('参数错误',$req);
        }
        $transaction_id=$req['transaction_id'];

        $vip_payment=VipPayment::where($where)->whereIn('status',[0,1])->first();
        if(!$vip_payment)return error('待支付订单不存在');
        $openid=$vip_payment['openid'];
        $wid=$vip_payment['wid'];
        $vip = VipCard::where(['wid' => $wid, 'openid' => $openid])->first();
        $setting = VipSetting::where(['wid' => $wid])->first();
        if(!$vip)return error('请先开卡',['isVip'=>0,'vipSetting'=>$setting]);
        if ($req['pay'] == 0) {
            $vipInfo=$vip;
            $vipInfo['isset_passwd'] = $vipInfo['passwd'] !== null ? 1 : 0;
            unset($vipInfo['passwd']);
            return success('成功',['dataList' => [
                'old_count' => $vip_payment['money'],
                'vip_discount' => $vip_payment['vip_discount'],
                'point_discount' => $vip_payment['point_discount'],
                'new_count' => $vip_payment['vip_pay_money'],
            ], 'vipInfo' => $vipInfo, 'vipSetting' => $setting, 'isVip' => 1]);
        }else{
            if ($vip->passwd != arr_get($req, 'passwd')) {
                return error('密码错误');
            }
            // 支付
            if ($vip->balance < $vip_payment['vip_pay_money']) {
                return error('余额不足');
            }
           if($vip_payment->status==0){ #如果没有支付过的先支付 支付过得直接请求回调
             #修改流水业务单状态
            $vip_payment->status=1;
            $vip_payment->save();
            // 返积分
            $fullNum = intval($vip_payment['vip_pay_money'] / $setting->consume_count);//满足几次返积分
            $returnPoint = $setting->consume_point * $fullNum;//满足x次返积分*返积分数
            $vip->point = $vip->point + $returnPoint;
            $vip->total_point = $vip->total_point + $returnPoint;
            $vip->total_consume = $vip->total_consume + $vip_payment['vip_pay_money'];

            $vip->balance = $vip->balance - $vip_payment['vip_pay_money'];
            $vip->point = $vip->point - $vip_payment['consume_point'];
            $vip->save();
           }
            //扣除金额
            $notifyUrl = $vip_payment['notify_url'];
            $nodifyData=new NotifyParams(['out_trade_no'=>$vip_payment['order_no'],'transaction_id'=>$vip_payment['transaction_id']]);
            $notify_result = file_get_contents($notifyUrl.'?'.http_build_query($nodifyData->toArray()));
            \Log::debug('会员卡支付回调结果:'.$notify_result);
            $arr_result=json_decode($notify_result,true);
            if(!$arr_result)return error('支付失败',$arr_result);
            if($arr_result['status']=='error'){
                return error($arr_result['msg']);
            }else{
                try{
                    $cfg=(new \Model('vshop_order_task'))->find(['wid'=>$req['wid']]);
                    $pub=(new \Model('pubs'))->find(['id'=>$req['wid']]);
                    if($cfg->id && $cfg->is_sms_notify==1){
                        send_sms($pub->uid, $cfg->sms_notify_phone, '【有用户下单啦，快去看看吧】'.'订单号：'.$vip_payment['order_no'].'；订单金额：'.$vip_payment['vip_pay_money']);
                    }
                }catch (\Exception $e){}
                //支付成功模板消息
                $tpl = arr_get(json_decode($setting->tpl_msg, true), 'tplmsg_pay');
                $tplMsg = sendTplMsg_vip_pay_success($wid, $tpl, $openid, $vip_payment['order_no'], $vip_payment['money'], $vip_payment['vip_pay_money'], $vip_payment['vip_discount'], $vip_payment['point_discount'], $vip->balance, $returnPoint, $vip->point);
                //导入已购订单
                import_purchased_orders($req['wid'],$req['openid'],$vip_payment['order_no'],2);
                return success('支付成功，付款￥' .  $vip_payment['vip_pay_money'] . '元，获得积分' . $returnPoint,[ 'tplMsg' => $tplMsg]);
            }

        }


    }


}
