<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/21
 * Time: 17:27
 */

namespace Addons\VipCard;


use Addons\VipCard\Models\VipPayment;
use Services\Service;

class Helper extends Service
{
    public $key='aiifhajj0kk';
    /**
     * 会员卡支付预处理
     * @param $wid
     * @param $openid
     * @param $money
     * @param $notifyUrl
     * @param $OrderNo
     * @param $remark
     * @param string $attach
     * @return array|bool
     */
    function prepay($wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = '') {
        if(!$OrderNo||!$openid||!$notifyUrl){
            \Log::debug('余额支付请求参数异常:'.json_encode(['OrderNo'=>$OrderNo,'openid'=>$openid,'notifyUrl'=>$notifyUrl]));
            return false;
        }
        $transaction_id=getRandomOrderNo('1');
        // 计算折扣
        $vip = (new \Model('vip_card'))->find(['wid' => $wid, 'openid' => $openid]);
        $setting = (new \Model('vip_setting'))->find(['wid' => $wid]);
        $vipInfo = $vip->get_model_array_with_id();
        if(!$vipInfo['id'])return $this->error('请先开通会员卡再使用余额支付',['need_register_card'=>1]);
        $vipInfo['isset_passwd'] = $vipInfo['passwd'] !== null ? 1 : 0;
        $level = get_vip_level($setting->vip_level, $vip->total_point);
        $vip_discount = $money * $level['discount'] / 100;
        // 计算积分抵扣
        if ($setting->point_to_money_open) {  // 开启了积分抵扣
            $all2money = $vip->point / $setting->point_to_money;  // 所有积分可以抵扣多少元
            if ($all2money >= $money - $vip_discount) {
                $point_discount = $money - $vip_discount;
            } else {
                $point_discount = $all2money;
            }
            $consume_point = $point_discount * $setting->point_to_money;
        } else {
            $consume_point =0;
            $point_discount = 0;
        }

        $new_count = $money - $vip_discount - $point_discount;
        // 支付
        if ($vip->balance < $new_count) {

            return $this->error('余额不足');
        }

        $vip_payment=new VipPayment();
        $vip_payment->wid=$wid;
        $vip_payment->openid=$openid;
        $vip_payment->money=$money;
        $vip_payment->vip_pay_money=$new_count; #vip支付价格
        $vip_payment->vip_discount=$vip_discount; #vip抵扣金额
        $vip_payment->point_discount= $point_discount; #vip积分抵扣金额
        $vip_payment->consume_point = $consume_point; #vip消耗积分数
        $vip_payment->notify_url=$notifyUrl; #回调地址
        $vip_payment->transaction_id=$transaction_id; #业务流水号
        $vip_payment->order_no=$OrderNo; #订单号
        $vip_payment->remark=$remark; #备注
        $vip_payment->attach=$attach; #额外参数
        $vip_payment->ctime=time(); #创建时间
        $vip_payment->save();
        return $this->success('获取参数成功',$vip_payment);


    }

    /**
     * 加密函数
     * @param $params
     * @param $key
     * @return string
     */
    function make_sign($params, $key)
    {
        ksort($params);
        $string = array_to_string($params);  //参数进行拼接key=value&k=v
        //签名步骤二：在string后加入KEY
        $string = $string . "&key=" . $key;
        //签名步骤三：MD5加密
        $string = md5($string);
        //签名步骤四：所有字符转为大写
        $result = strtoupper($string);
        return $result;
    }
    function http_post($url, $param,$header=[], $wxchat=null) {
        $oCurl = curl_init();
        if (stripos($url, "https://") !== FALSE) {
            curl_setopt($oCurl, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($oCurl, CURLOPT_SSL_VERIFYHOST, FALSE);
            curl_setopt($oCurl, CURLOPT_FOLLOWLOCATION, true);
        }
        curl_setopt($oCurl, CURLOPT_URL, $url);
        curl_setopt($oCurl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($oCurl, CURLOPT_POST, 1);
        curl_setopt($oCurl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']); // 模拟用户使用的浏览器
        curl_setopt($oCurl, CURLOPT_POSTFIELDS, http_build_query($param));
        if($wxchat){
            curl_setopt($oCurl,CURLOPT_SSLCERT,dirname(THINK_PATH).$wxchat['api_cert']);
            curl_setopt($oCurl,CURLOPT_SSLKEY,dirname(THINK_PATH).$wxchat['api_key']);
            curl_setopt($oCurl,CURLOPT_CAINFO,dirname(THINK_PATH).$wxchat['api_ca']);
        }
        $sContent = curl_exec($oCurl);
        $aStatus = curl_getinfo($oCurl);
        curl_close($oCurl);
        if (intval($aStatus["http_code"]) == 200) {
            return $sContent;
        } else {

            return false;
        }
    }
}