<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/21
 * Time: 17:24
 */

namespace Addons\VipCard\Services\Plugins;


use Addons\VipCard\Helper;
use Addons\VipCard\Models\VipPayment;
use Addons\VipCard\Services\Plugins\Data\NotifyParams;
use Services\Service;

class Payment extends Service
{

    /**
     * 会员卡支付钩子
     * @param $params
     * @param array $extra
     * @return array|bool
     */
    public function _pay_params(&$params,array $extra){
        $pay_type=$extra['pay_type'];
        if($pay_type!='vipcard')return null;
        \Log::debug('vipcard支付参数:'.json_encode($extra));
        $pay_params=Helper::getInstance()->prepay($extra['wid'],$extra['openid'],
        $extra['money'],$extra['notifyUrl'],$extra['OrderNo'],$extra['remark'],$extra['attach']);
        $params=$pay_params;

        return false;#停止继续执行
    }

    /**
     * 会员卡支付回调钩子
     * @param $params
     * @param array $extra
     * @return bool|string
     */
    public function _pay_notify(&$params,array $extra){
        \Log::debug('vipcard 支付插件回调获得参数:'.json_encode($extra));
        if($extra['pay_type']!='vipcard')return null;
        ini_set('date.timezone', 'Asia/Shanghai');
        // error_reporting(0);
        $wid = $extra['wid'];
        $pay_resp =new NotifyParams($_REQUEST); #数据标准化
        $transaction_id=$pay_resp['transaction_id'];
        $vip_payment=VipPayment::where(['transaction_id'=>$transaction_id,'status'=>1])->first();
        if(!$vip_payment||$vip_payment['order_no']!=$pay_resp['out_trade_no']){
            \Log::debug('会员卡信息验证失败:'.json_encode($pay_resp));
            $return =json_encode($this->error('会员卡信息验证失败',$pay_resp));
            $params=$this->error('会员卡支付信息验证失败',['pay_resp'=>$pay_resp,'return'=>$return]);
        }else{
            $pay_resp['vip_payment']=$vip_payment;
            $return =json_encode($this->success('成功'));
            $params=$this->success('ok',['pay_resp'=>$pay_resp,'return'=>$return]);//返回解析数据
        }

        return false; #停止继续执行
    }
}