<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/18
 * Time: 16:24
 */

namespace Addons\WechatSupport;


use Conf;
use HttpCurl;
use Services\Service;

class Helper extends Service
{
    /**
     * 微信小程序获取支付参数
     * @param $wid
     * @param $openid
     * @param $money
     * @param $notifyUrl
     * @param $OrderNo
     * @param $remark
     * @param string $attach
     * @return array|bool
     */
    function prepay($wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = '') {
        // Conf::$http_path_api . "Payment/Wxpay/wxRechargeNotify-" . arr_get($req, 'wid') . ".html"
        if (!$attach) {
            $attach = json_encode([]);
        }
        $payParams = db_query("SELECT * FROM vshop_weixin_pay WHERE wid=?", [$wid])[0];
        $time = time();
        $nonce_str = md5(time() . rand() . rand() . '微信支付');
        $body = $remark ?$remark:"产品下单" ;

        if($payParams['status']==1){
            $params = [
                'appid'            => $payParams['AppId'],//小程序ID
                'mch_id'           => $payParams['PartnerId'],//商户号
                'nonce_str'        => $nonce_str,//随机字符串
                'body'             => $body,//商品描述(可以拼接字符串生成)
                'out_trade_no'     => $OrderNo,//商品订单号
                'total_fee'        => $money * 100,//总金额
                'spbill_create_ip' => '192.168.1.1',//终端IP
                'notify_url'       => $notifyUrl,//通知地址
                'trade_type'       => 'JSAPI',//交易类型(小程序固定是JSAPI)
                'openid'           => $openid,//用户的openid
                'attach'           => $attach
            ];
        }else{
            $params = [
                'appid' => $payParams['sAppId'],//服务商ID
                'mch_id' => $payParams['PartnerId'],//商户号
                'sub_appid' => $payParams['AppId'],//小程序的APPID
                'sub_mch_id' => $payParams['sPartnerId'],//子商户号

                'nonce_str'        => $nonce_str,//随机字符串
                'body'             => $body,//商品描述(可以拼接字符串生成)
                'out_trade_no'     => $OrderNo,//商品订单号
                'total_fee'        => $money * 100,//总金额
                'spbill_create_ip' => '192.168.1.1',//终端IP
                'notify_url'       => $notifyUrl,//通知地址
                'trade_type'       => 'JSAPI',//交易类型(小程序固定是JSAPI)
                'sub_openid'           => $openid,//用户的openid
                'attach'           => $attach
            ];
        }


        $params['sign'] = make_sign(array_filter($params), $payParams['PartnerKey']);
        $xml_params = array_to_cdata_xml($params);
        $resp = postXmlCurl('https://api.mch.weixin.qq.com/pay/unifiedorder', $xml_params);
        $resp_arr = xml_to_array($resp);
        diy_log(['调起支付返回参数：', $resp_arr]);
        //判断预支付订单是否已经创建成功
        if ($resp_arr['return_code'] == 'SUCCESS') {//请求下单成功
            if ($resp_arr['result_code'] == 'SUCCESS') {//生成预支付订单成功
                //签名gaode
                $paySign = make_sign([
                    'appId'     => $payParams['AppId'],
                    'timeStamp' => "" . $time,
                    'nonceStr'  => $resp_arr['nonce_str'],
                    'package'   => 'prepay_id=' . $resp_arr['prepay_id'],
                    'signType'  => 'MD5',
                ], $payParams['PartnerKey']);
                //要返回的数据
                $respData = [
                    'timeStamp' => "" . $time,
                    'nonceStr'  => $resp_arr['nonce_str'],
                    'package'   => 'prepay_id=' . $resp_arr['prepay_id'],
                    'signType'  => 'MD5',
                    'paySign'   => $paySign,
                ];
                return $respData;
            } else {
                return $this->setErrorMessage($resp_arr['return_msg']?$resp_arr['return_msg']:$resp_arr['err_code_des']);
                diy_log($resp_arr);
//                return false;
            }
        } else {
            diy_log($resp_arr);
            return $this->setErrorMessage($resp_arr['return_msg']?$resp_arr['return_msg']:$resp_arr['err_code_des']);
//            return false;
        }
    }

    /**
     * @param $ttConfig
     * @param $order_no
     * @param $out_trade_no
     * @param $money
     */
    public function  refundOrder($config,$order_no,$out_trade_no,$money){
        //准备退款所需的参数
        $nonce_str = md5(microtime() . 'adhfiahsdfjas;kljfdsadfnsajkdfhsdufhsa' . rand());
        if($config->status==1 ){
            $data = [
                'appid' => $config->AppId,
                'mch_id' => $config->PartnerId,
                'nonce_str' => $nonce_str,
                'transaction_id' => $out_trade_no,
                'out_refund_no' => $order_no,
                'total_fee' => $money * 100,//换算单位
                'refund_fee' => $money * 100,//换算单位
                'op_user_id' => $config->PartnerId
            ];
        }else{
            $data = [
                'appid' => $config->sAppId,
                'mch_id' => $config->sPartnerId,
                'sub_appid' => $config->AppId,//小程序的APPID
                'sub_mch_id' => $config->sPartnerId,//子商户号
                'nonce_str' => $nonce_str,
                'transaction_id' => $out_trade_no,
                'out_refund_no' => $order_no,
                'total_fee' => $money * 100,//换算单位
                'refund_fee' => $money * 100,//换算单位
                'op_user_id' => $config->PartnerId
            ];
        }

        $data['sign'] = make_sign($data, $config->PartnerKey);
        $xml_data = array_to_cdata_xml($data);
        $ch = curl_init();
        //超时时间
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, 'https://api.mch.weixin.qq.com/secapi/pay/refund');
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        //设置证书
        curl_setopt($ch, CURLOPT_SSLCERT, DOXCX_STATIC.$config->cert);
        curl_setopt($ch, CURLOPT_SSLKEY,DOXCX_STATIC.$config->key);
        //POST的数据
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_data);
        //发起请求
        $data = curl_exec($ch);
        if ($data) {
            curl_close($ch);
            $data = xml_to_array($data);
            if ($data['return_code'] == 'SUCCESS') {
                if ($data['result_code'] == 'SUCCESS') {

                    return success("退款成功",$data);
                } else {
                    return error("退款失败：".(arr_get($data, 'err_code_desc') ? arr_get($data, 'err_code_desc') :arr_get($data, 'err_code') ));
                }
            } else {
                return error('发起退款失败：' . $data['return_msg']);
            }
        } else {
            $error = curl_error($ch);
            curl_close($ch);
            return error('退款请求失败'.$error);
        }
    }
    function create_qr($wid,$platPath,$params,$filePath=null,$describe=""){
        //生成推广二维码
        $access_token = WX_getAccessToken($wid);
        $post_url = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token='.$access_token;
        $post_data =json_encode([
            "scene"=>$params['scene']?$params['scene'] : '',
            "path"=>$platPath,
            "width"=>$params['width'] ? $params['width'] : "430"
        ]);
        $result_data = HttpCurl::post($post_url,$post_data);

        /**
        //图片路径
        $imgpath = 'UserPage/qrcode_'.$userId.'.jpg';
        file_put_contents(DOXCX_STATIC.$imgpath,$result_data);

        //二维码路径
        $qrcode = Conf::$http_path_static.$imgpath;
         */
        $tryJson = json_decode($result_data, true);
        if (strlen($result_data) < 1024 || isset($tryJson['errcode'])) {
            return error("生成失败:".$tryJson['errmsg']);
        }else{
            if($filePath==null)$filePath="UserPage/qrcode_".date('Ymd') . DS . md5(microtime(true)).".png";
            $full_Path=pub_path($filePath);
            $path=dirname($full_Path);
            is_dir($path) or mkdir($path,0751,true);
            $content=$result_data;
            file_put_contents($full_Path,$content);
            return success('生成成功',['url'=>get_host($filePath),'path'=>$filePath]);
        }

    }
}