<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2019/5/16
 * Time: 16:35
 */

namespace Addons\WechatSupport\Services\Plugins;


use Addons\WechatSupport\Helper;

class Payment extends \BaseController
{
    /**
     * 微信支付钩子
     * @param $params
     * @param array $extra
     * @return array|bool
     */
    public function _pay_params(&$params,array $extra){
//         $wid, $openid, $money, $notifyUrl, $OrderNo, $remark, $attach = ''
        $pay_type=$extra['pay_type'];
        if($pay_type!='wechat')return error('非wechat类型');
        \Log::debug('wechat支付参数:'.json_encode($extra));
        $helper=Helper::getInstance();
        $pay_params=$helper->prepay($extra['wid'],$extra['openid'],
            $extra['money'],$extra['notifyUrl'],$extra['OrderNo'],$extra['remark'],$extra['attach']);
        if($pay_params){
            $pay_params['pay_type']='wechat';
            $params=success('ok',$pay_params);
        }else{
            $params=error('err',$helper->getErrorMessage());
        }
        return false;#停止继续执行
    }

    /**
     * 微信支付回调钩子
     * @param $params
     * @param array $extra
     * @return bool|string
     */
    public function _pay_notify(&$params,array $extra){
        \Log::debug('wechat 支付插件回调获得参数:'.json_encode($extra));
        if($extra['pay_type']!='wechat')return true;
        ini_set('date.timezone', 'Asia/Shanghai');
        error_reporting(0);
        $wid = $extra['wid'];
        $xml = file_get_contents("php://input");
        $pay_resp = xml_to_array($xml);
        //支付参数
        $payParams = db_query("SELECT * FROM vshop_weixin_pay WHERE wid=?", [$wid])[0];
        //验证签名
        if (!confirm_sign($pay_resp, $payParams['PartnerKey'])) {
            \Log::debug('wechat 签名失败:'.$xml);
            $return= "<xml><return_code><![CDATA[FAIL]]></return_code><return_msg><![CDATA[签名失败]]></return_msg></xml>";
            $params=error('wechat 签名失败',['pay_resp'=>null,'return'=>$return]);
            return  false;

        }

        $return = "<xml><return_code><![CDATA[SUCCESS]]></return_code><return_msg><![CDATA[OJBK]]></return_msg></xml>";
        $params=success('ok',['pay_resp'=>$pay_resp,'return'=>$return]);//返回解析数据
        return false; #停止继续执行
    }

    /**
     * 微信退款
     * @param $params
     * @param array $extra
     * @return array|bool
     */
    public function  _pay_refund(&$params,array $extra){
        if($extra['pay_type'] != 'wechat')return true;
        ini_set('date.timezone', 'Asia/Shanghai');
        error_reporting(0);
        $wid = $extra['wid'];
        $out_trade_no=$extra['out_trade_no'];
        $order_no=$extra['order_no'];
        $money=$extra['money'];
        //查询是否微信订单
        $helper=Helper::getInstance();
        $Config = new \Model('vshop_weixin_pay');
        $Config->find(array('wid' => $wid));
        if(!$Config->id){
            $params=error("获取微信配置错误，请检查");
            return false;
        }

        try{
            $params=$helper->refundOrder($Config,$order_no,$out_trade_no,$money);
        }catch (\Exception $e){
            $params=error("出现错误:".$e->getMessage());
        }
        return false;
    }
}