<?php
/**
 * Created by daniel
 * User: Daniel
 * Date: 2020/2/26
 * Time: 17:05
 */

namespace Addons\Zhibo\Controller\Admin;


use Addons\Zhibo\Helper;
use Lib\Request;
class RoomList extends BaseAdmin
{
    /**
     * 获取直播列表
     * @param Request $r
     * @return false|string
     * @throws \Exception
     */
    public function index(Request $r){
        //获取直播间列表
        $wid=$this->wid;
        $where=['wid'=>$wid];
//        $tj = new \SampleModel();
//        $pag = $tj->load_array_from_get();
        if($keyword=$r->param('keyword','')){
            $where['name@~'] = $keyword;
        }
        $page=new \Pagination(10,10,false);
        $res=$page->model_list((new \Model('vshop_live_room'))->where($where)->order('id desc'),true);
        $pnum=(new \Model('vshop_live_room'))->where($where)->count();
//        $this->assign('tj',$tj);
        $h=Helper::getInstance();
        $this->assign('h',$h);
        $this->assign('pnum',$pnum);
        $this->assign('p',$page);
        $this->assign('P',$GLOBALS['P']);
        $this->assign('res',$res);
        return $this->show();
    }
    public function refresh(Request $r){
        $h=Helper::getInstance();
        $wid=$this->wid;
       $page=1;
       $limit=10;
       $insert_room_sql='';
       $insert_goods_sql='';
       db_query("delete from vshop_live_room");
       db_query("delete from vshop_live_room_goods");
        do{
            $data=$h->getLiveRoms($wid,$page,$limit);
//            dump($data);
            if($data['status']!='success'){
                break;
            }

            $romList=$data['data']['room_info'];
            if(count($romList) <= 0)break;

            foreach ($romList as $room){
//                dump($room);
                $room_id=$room['roomid'];
                $name=$room['name'];
                $cover_img=$room['cover_img'];
                $start_time=date("Y-m-d H:i:s",$room['start_time']);
                $end_time=date("Y-m-d H:i:s",$room['end_time']);
                if(!$insert_room_sql){
                    $insert_room_sql="insert into vshop_live_room (room_id,wid,name,cover_img,start_time,end_time,anchor_name,anchor_img) values
                ({$room_id},{$wid},'{$name}','{$cover_img}','{$start_time}','{$end_time}','{$room['anchor_name']}','{$room['anchor_img']}')";
                }else{
                    $insert_room_sql.=",({$room_id},{$wid},'{$name}','{$cover_img}','{$start_time}','{$end_time}','{$room['anchor_name']}','{$room['anchor_img']}')";
                }
                $goods=$room['goods'];
                foreach($goods as $good){
                   if(!$insert_goods_sql){
                       $insert_goods_sql="insert into vshop_live_room_goods (room_id,wid,cover_img,url,price,name) values 
                        ({$room_id},{$wid},'{$good['cover_img']}','{$good['url']}','{$good['price']}','{$good['name']}')";
                   }else{
                       $insert_goods_sql.=",({$room_id},{$wid},'{$good['cover_img']}','{$good['url']}','{$good['price']}','{$good['name']}')";
                   }
                }
            }

            $page++;
        }while($page<3);
//        dump($insert_goods_sql);
//        dump($insert_room_sql);
        if($insert_goods_sql){
           \DB::get_db(false)->execute($insert_goods_sql);

        }
        if($insert_room_sql){
           \DB::get_db(false)->execute($insert_room_sql);
        }
        return success("同步成功",['url'=>'refresh']);
    }
}
