<?php
/**
 * Created by daniel
 * User: Daniel
 * Date: 2020/2/26
 * Time: 16:26
 */

namespace Addons\Zhibo;


use Services\Service;

class Helper extends Service
{
    /**
     * 获取直播间列表
     * @param int $wid
     * @param int $page
     * @param int $limit
     * @return array
     */
    public function  getLiveRoms($wid,$page=1,$limit=10){
        $token= WX_getAccessToken($wid);
        $url="http://api.weixin.qq.com/wxa/business/getliveinfo?access_token=".$token;
        $start=($page-1)*$limit;
        $params=json_encode([
            'start'=>$start,
            'limit'=>$limit
        ]);
        $json_data= \HttpCurl::post($url,$params);
        $resp = json_decode($json_data, 1);
        if($resp['errcode'] == 0){
            return $this->success("获取成功",$resp);
        }else{
            return $this->error("获取失败:".$resp['errmsg']);
        }
    }

    /**
     * 获取直播间回放列表
     *  @param int $wid
     * @param $roomId
     * @param int $page
     * @param int $limit
     * @return array
     */
    public function getLiveList($wid,$roomId,$page =1,$limit=10){
        $token=WX_getAccessToken($wid);
        $url="http://api.weixin.qq.com/wxa/business/getliveinfo?access_token=".$token;
        $start=($page-1)*$limit;
        $params=json_encode([
            'action'=> 'get_replay',
            'room_id' => $roomId,
            'start'=>$start,
            'limit'=>$limit
        ]);
        $json_data= \HttpCurl::post($url,$params);
        $resp = json_decode($json_data, 1);
        if($resp['errcode'] == 0){
            return $this->success("获取成功",$resp);
        }else{
            return $this->error("获取失败:".$resp['errmsg']);
        }
    }
    public function  pluginPath($son){
        return dirname(__FILE__).'/'.ltrim($son,'/\\');
    }
}
