<?php
/**
 * 跳转到授权页面
 * Created by PhpStorm.
 * User: Jeffrey
 * Date: 2017/12/11
 * Time: 20:31
 */
require(DOXCX_FRAME_PATH . 'fun/baiduOpenApi.php');//开放平台api函数集
$wid = Session::get('wid');
$pub = (new Model('pubs'))->find(['id' => $wid]);
$admin = get_user_agency();
if ($admin->app_id) {
  $appid = $admin->app_id;
} else {
  $agency = (new Model('user_agency'))->find(['un' => 'admin']);
  $appid = $agency->app_id;
}
if (!$pub->authorizer_access_token || $_GET['rebind']) {
  rebind();
  exit();
} else {
  try {
    Page::$need_view = true;
    //获取小程序基本信息
    $authorizer_info = get_authorizer_info();
    //设置域名(03.14改为手动设置)
    $set_domains = set_applet_domains();
    //获取阿拉丁appKey
    $m = new Model('ald_set');
    $m->find(array('wid' => $wid));
    if (!$m->ald_appkey) {
      $url = "http://openapi.aldwx.com/Main/action/Appregister/Appregister/getApp";
      $post_data = array(
        'access_token' => $m->ald_access_token,
        'app_name'     => $authorizer_info['authorizer_info']['nick_name'],
        'app_logo'     => $authorizer_info['authorizer_info']['head_img'],
        'user_id'      => $wid,
      );
      $body = send_post($url, $post_data);
      $arr = json_decode($body, true);
      $appkey = $arr['data']['appkey'];
      $m->name = $authorizer_info['authorizer_info']['nick_name'];
      $m->logo = $authorizer_info['authorizer_info']['head_img'];
      $m->ald_appkey = $appkey;
      $m->save();
    }
  } catch (Exception $e) {
    rebind();
    exit();
  }
  //体验者列表
  $testers = (new Model('wx_tester'))->list_all_array(['wid' => $wid]);
  //找出ID用来查询审核状态
  $uploadRecordList = (new Model('user_upload_code_record'))->order('id desc')->limit(10)->list_all_array(['wid' => $wid]);
  //处理状态信息
  foreach ($uploadRecordList as $k => $uploadRecord) {
    diy_log($uploadRecord['id']);
    get_audit_status($uploadRecord['id']);
  }
  //上传的小程序列表
  $uploadRecordList = (new Model('user_upload_code_record'))->order('id desc')->list_all_array(['wid' => $wid]);
  //处理时间戳
  foreach ($uploadRecordList as $k => $uploadRecord) {
    $uploadRecordList[$k]['upload_time'] = date('Y-m-d H:i:s', $uploadRecord['upload_time']);
  }

}


// 给用户的小程序平台设置域名白名单
function set_applet_domains() {
  $admin = get_user_agency();//管理员（管理员配置）
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  //发起请求
  $body = HttpCurl::post(
    "https://api.weixin.qq.com/wxa/modify_domain?access_token=" . $authorizer_access_token,
    json_encode([
      "action"          => "add",
      "requestdomain"   => ["https://" . $admin->config_domain],
      "wsrequestdomain" => ["wss://" . $admin->config_domain],
      "uploaddomain"    => ["https://" . $admin->config_domain],
      "downloaddomain"  => ["https://" . $admin->config_domain],
    ])
  );
  $resp_arr = json_decode($body, 1);
  diy_log($resp_arr);
  if ($resp_arr['errcode'] == 0) {
    //成功设置
    return true;
  } else {
    //获取失败
    return false;
  }
}

function audit_status_to_text($item) {
  $status = $item['is_audit'];
  switch ($status) {
    case -1:
      return '未提交审核';
      break;
    case 0:
      return '审核成功';
      break;
    case 1:
      return '审核未通过 : ' . $item['unpass_reason'];
      break;
    case 2:
      return '审核中，请耐心等待';
      break;
    default:
      return '查询状态信息出现错误';
      break;
  }
}

function send_post($url, $post_data) {
  $postdata = http_build_query($post_data);
  $options = array(
    'http' => array(
      'method'  => 'POST',
      'header'  => 'Content-type:application/x-www-form-urlencoded',
      'content' => $postdata,
      'timeout' => 15 * 60 // 超时时间（单位:s）
    ),
  );
  $context = stream_context_create($options);
  $result = file_get_contents($url, false, $context);

  return $result;
}

function getHost() {
  return getHttp() . '://' . $_SERVER['HTTP_HOST'] . '/admin/Publish/FinishAuth.html';
}

function getHttp() {
  if (strtolower(explode('://', $_SERVER['HTTP_REFERER'])[0]) == 'https') {
    return 'https';
  }
  if (strtolower($_SERVER['REQUEST_SCHEME']) == 'https') {
    return 'https';
  }
  return 'http';
}