<?php
require_once "common.php";
if (!is_post()) {
  $p = new Pagination(10, 10, true);
  $list = $p->model_list((new Model('jd_order'))->where(['wid'=>$wid])->order('id desc'));
  foreach ($list as $k=>$v) {
    $names=db_query("select jd_jd.name as jd_name,jd_kf.name as kf_name from jd_order left join jd_kf on jd_kf.id=jd_order.kf_id left join jd_jd on jd_jd.id=jd_kf.jd_id where jd_jd.wid=? and jd_order.id = ?",[$wid,$v->id])[0];
    $v->jd_name=$names['jd_name'];
    $v->kf_name=$names['kf_name'];
    $list[$k]=$v;
  }
} else {
  setApi();
  $id = pget('id');
  $order = (new Model('jd_order'))->find(['wid' => $wid, 'id' => $id]);
  if (!$order->id) sendError('找不到订单');
  if (pget('opt') == 'ruzhu') {
    if($order->is_refund==1){
      sendError('此订单已经取消并退款！');
    }
    if ($order->is_ruzhu == 0) {
      $order->is_ruzhu = 1;
      $order->save();
      sendSuccess('入住成功');
    } else {
      sendError('此订单已经入住了');
    }
  } else if (pget('opt') == 'tuifang') {
    if ($order->is_ruzhu == 0) {
      sendError('此订单未入住');
    } else if ($order->is_ruzhu == 2) {
      sendError('此订单已经退房了');
    } else {
      $order->is_ruzhu = 2;
      $order->save();
      sendSuccess('退房成功');
    }
  } else if (pget('opt') == 'refund') {
    if($order->is_refund==1){
      sendError('此订单已经退款！');
    }
    //准备退款所需的参数
    $payParams = db_query("SELECT * FROM vshop_weixin_pay WHERE wid=?", [$wid])[0];
    $nonce_str = getRandomOrderNo('refund');
    $data = [
      'appid'         => $payParams['AppId'],
      'mch_id'        => $payParams['PartnerId'],
      'nonce_str'     => $nonce_str,
      'out_trade_no'  => $order->order_no,
      'out_refund_no' => $order->order_no,
      'total_fee'     => $order->total_price * 100,//换算单位
      'refund_fee'    => $order->total_price * 100,//换算单位
      'op_user_id'    => $payParams['PartnerId'],
      // 'refund_account' => 'REFUND_SOURCE_RECHARGE_FUNDS'
    ];
    diy_log(['退款参数', $data]);
    $data['sign'] = make_sign($data, $payParams['PartnerKey']);
    $xml_data = array_to_cdata_xml($data);
    $refund = doRefund($xml_data, $payParams);
    if($refund['status']=='success'){
        $order->is_refund = 1;
        $order->save();
        sendSuccess("取消成功");
    }else{
        sendError($refund['msg']?$refund['msg']:"退款失败");
    }
  }
}
function toReFund($order){
    switch ($order->pay_type){
        case  4:
            $payParams = db_query("SELECT * FROM vshop_weixin_pay WHERE wid=?", [$order->wid])[0];
            $nonce_str = getRandomOrderNo('refund');
            $data = [
                'appid'         => $payParams['AppId'],
                'mch_id'        => $payParams['PartnerId'],
                'nonce_str'     => $nonce_str,
                'out_trade_no'  => $order->order_no,
                'out_refund_no' => $order->order_no,
                'total_fee'     => $order->total_price * 100,//换算单位
                'refund_fee'    => $order->total_price * 100,//换算单位
                'op_user_id'    => $payParams['PartnerId'],
                // 'refund_account' => 'REFUND_SOURCE_RECHARGE_FUNDS'
            ];
            diy_log(['退款参数', $data]);
            $data['sign'] = make_sign($data, $payParams['PartnerKey']);
            $xml_data = array_to_cdata_xml($data);
            $refund = doRefund($xml_data, $payParams);
            return  $refund;
        case 8:
            return doRefundSyk($order);
        default:
            return error("当前支付方式暂不支持退款");

    }
}
function doRefundSyk($order){
    $refund = syk_refund($order->wid,$order->total_price,$order->order_no);
    if($refund == 100 or $refund == 111){
       return success("退款成功");
    }else{
        return error("退款失败");
        //退款失败

    }
}
/**
 * 退款
 * @param $post_data
 * @param $setting
 * @return array
 */
function doRefund($post_data, $setting) {
  $ch = curl_init();
  //超时时间
  curl_setopt($ch, CURLOPT_TIMEOUT, 10);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_URL, 'https://api.mch.weixin.qq.com/secapi/pay/refund');
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
  //设置证书
  curl_setopt($ch, CURLOPT_SSLCERT, DOXCX_STATIC . $setting['cert']);
  curl_setopt($ch, CURLOPT_SSLKEY, DOXCX_STATIC . $setting['key']);
  //POST的数据
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
  //发起请求
  $data = curl_exec($ch);
  if ($data) {
    curl_close($ch);
    $data = xml_to_array($data);
    diy_log($data);
    if ($data['return_code'] == 'SUCCESS') {
      if ($data['result_code'] == 'SUCCESS') {
        return success("退款成功");
      } else {
        diy_log('退款请求成功,但是退款操作失败。错误代码：' . arr_get($data, 'err_code') . '；错误描述：' . arr_get($data, 'err_code_desc') . '。');
       return error("退款失败：".$data['err_code_desc']);
      }
    } else {
      diy_log('发起退款失败,原因：' . $data['return_msg']);
      return error("退款失败：".$data['return_msg']);
//      return false;
    }
  } else {
    $error = curl_errno($ch);
    curl_close($ch);
    diy_log('退款请求失败');
    return error("退款失败：请求微信出现错误".$error);
//    return false;
  }
}