<?php
$wid = Session::get('wid');
$setting = (new Model('vip_setting'))->find(['wid' => $wid]);
if (Request::post()) {
  header('Content-Type:application/json');
  Page::$need_view = false;
  // 处理传来的数组
  // 检查是否有空值
  $result = [];
  foreach (arr_get($_POST, 'name') as $k => $name) {
    if (trim($name) == '') {
      sendResponse(['status' => 'error', 'msg' => '请完整填写'], true);
    }
    $result[$k]['name'] = trim($name);
  }
  foreach (arr_get($_POST, 'total_point') as $k => $p) {
    $p = intval(trim($p));
    if (!is_numeric($p)) {
      sendResponse(['status' => 'error', 'msg' => '累计积分必须是数字'], true);
    }
    if ($p < 0) {
      sendResponse(['status' => 'error', 'msg' => '累计积分不能小于0'], true);
    }
    $result[$k]['total_point'] = $p;
  }
  foreach (arr_get($_POST, 'discount') as $k => $d) {
    $d = intval(trim($d));
    if (!is_numeric($d)) {
      sendResponse(['status' => 'error', 'msg' => '折扣必须是数字'], true);
    }
    if ($d < 0 || $d > 100) {
      sendResponse(['status' => 'error', 'msg' => '折扣必须在 0<=折扣<100 范围内'], true);
    }
    $result[$k]['discount'] = $d;
  }
  $setting->wid = $wid;
  $setting->vip_level = json_encode($result);
  $setting->save();
  sendResponse(['status' => 'success', 'msg' => '保存成功'], true);
} else {
  if (!$setting->vip_level) {
    $setting->vip_level = json_encode([
      [
        'name' => '会员',
        'total_point' => 0,
        'discount' => 0
      ]
    ]);
    $setting->save();
  }
  $vipLevel = json_decode($setting->vip_level, true);
  Page::$need_view = true;
}