<?php
Page::$need_view = 0;
header("Content-Type:application/json");
$wid = Session::get('wid');
$order_id = Request::get(1);
$order = (new Model('vshop_product_groupbuy_order'))->where(['wid' => $wid, 'id' => $order_id])->find();
if (!$wid || !$order_id || !$order->id ) {
    exit();
}

//准备退款所需的参数

//$refund = doRefund($xml_data, $payParams);
$refund = doRefund($wid,$order->order_no,$order->transaction_id,$order->total_price);
if (!$refund) {
    sendResponse([
        'status' => 0,
        'message' => '退款失败',
    ]);
} else {
    sendResponse([
        'status' => 1,
        'message' => '退款成功',
    ]);
}

/**
 * 退款
 * @param $post_data
 * @param $setting
 * @return bool
 */
function doRefund($wid,$out_trade_no,$trade_no,$money)
{

    require_once DOXCX_FRAME_PATH . "/fun/alipay/aop/AopClient.php";
    require_once DOXCX_FRAME_PATH . "/fun/alipay/aop/request/AlipayTradeRefundRequest.php";
    //获取小程序配置信息
    $ttConfig = new Model('vshop_tt_pay');
    $ttConfig->find(array('wid' => $wid));
    $aop = new AopClient ();
    $aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
    $aop->appId = $ttConfig->zfbAppId;
    $aop->rsaPrivateKey = $ttConfig->privateKey;
    $aop->alipayrsaPublicKey= $ttConfig->publicKey;
    $aop->apiVersion = '1.0';
    $aop->signType = 'RSA2';
    $aop->postCharset='UTF-8';
    $aop->format='json';

    $request = new AlipayTradeRefundRequest ();
    $request->setBizContent("{" .
        "\"out_trade_no\":\"$out_trade_no\"," .
        "\"trade_no\":\"$trade_no\"," .
        "\"refund_amount\":\"$money\"" .
        "}");
    $result = $aop->execute ($request);
    //file_put_contents(DOXCX_FRAME_PATH.'/log/info/'.date('Y_m_d',time()).'.log', date('H:i:s',time()).': 退款:'.json_encode($result,JSON_FORCE_OBJECT),FILE_APPEND);
    if($result->alipay_trade_refund_response->code==10000){
        //找到订单
        $order = (new Model('vshop_product_groupbuy_order'))->where(['order_no' => $out_trade_no])->find();
        //标记为已退款
        $order->is_refund = 1;
        $order->save();
        return true;
    }
    return false;
}