<?php
Page::$need_view = 0;
header("Content-Type:application/json");
$wid = Session::get('wid');
$order_id = Request::get(1);
$order = (new Model('vshop_order'))->where(['wid' => $wid, 'id' => $order_id])->find();
if (!$wid || !$order_id || !$order->id) {
    exit();
}

if($order->is_vip_pay==1){
  $card=(new Model('vip_card'))->where(['openid'=>$order->wxid])->find();
  if($card){
    $card->balance+=$order->vip_pay_money;
    $card->point+=intval($order->consume_point);
    $card->save();
    $order->is_refund_money=2;
    $order->save();
    sendResponse([
      'status' => 1,
      'message' => '退款成功',
    ]);
    exit();
  }else{
    sendResponse([
      'status' => 0,
      'message' => '退款失败',
    ]);
    exit();
  }
}

$refund = doRefund($wid,$order->OrderNo,$order->tradeNo,$order->payAmount);
if (!$refund) {
    sendResponse([
        'status' => 0,
        'message' => '退款失败',
    ]);
} else {
    sendResponse([
        'status' => 1,
        'message' => '退款成功',
    ]);
}

/**
 * 退款
 * @return bool
 */
function doRefund($wid,$out_trade_no,$trade_no,$money){
	require_once DOXCX_FRAME_PATH . "/fun/alipay/aop/AopClient.php";
	require_once DOXCX_FRAME_PATH . "/fun/alipay/aop/request/AlipayTradeRefundRequest.php";
	//获取小程序配置信息
	$ttConfig = new Model('vshop_tt_pay');
	$ttConfig->find(array('wid' => $wid));
	$aop = new AopClient ();
	$aop->gatewayUrl = 'https://openapi.alipay.com/gateway.do';
	$aop->appId = $ttConfig->zfbAppId;
	$aop->rsaPrivateKey = $ttConfig->privateKey;
	$aop->alipayrsaPublicKey= $ttConfig->publicKey;
	$aop->apiVersion = '1.0';
	$aop->signType = 'RSA2';
	$aop->postCharset='UTF-8';
	$aop->format='json';
	$request = new AlipayTradeRefundRequest ();
	$request->setBizContent("{" .
							"\"out_trade_no\":\"$out_trade_no\"," .
							"\"trade_no\":\"$trade_no\"," .
							"\"refund_amount\":\"$money\"" .
							"}");
	$result = $aop->execute ($request); 
	//file_put_contents(DOXCX_FRAME_PATH.'/log/info/'.date('Y_m_d',time()).'.log', date('H:i:s',time()).': 退款:'.json_encode($result,JSON_FORCE_OBJECT),FILE_APPEND);
	if($result->alipay_trade_refund_response->code==10000){
		 //找到订单
         $order = (new Model('vshop_order'))->where(['OrderNo' => $out_trade_no])->find();
         //标记为已退款
         $order->is_refund_money = 2;
         $order->save();
         return true;
	}
	return false;
}


