<?php
/**
 * Created by daniel@liaodongting.com.
 * User: Daniel
 * Date: 2019/6/21
 * Time: 12:01
 */
use Lib\Request;
use Services\Library\PluginsManager;
Page::$need_view=false;
$request=Request::instance();
$action=$request->param('action');

if($action==='install'){
    $params=$request->post();
    $sign=$params['sign'];
    unset($params['sign']);
    $plugin_code=$params['plugin_code'];
    $market_info=LDB::table('plugins_market_config')->first();
    if(!$market_info)return send_error('您还没有绑定应用市场，请先进行绑定后再操作');
    $check_sign=up_make_sign($params,$market_info['app_secret']);
    if($check_sign!==$sign)return send_error('请求密钥验证失败，请检查应用商城配置和网站配置是否一致',['sign'=>$check_sign]);
    $re=(new PluginsManager())->install_plugin($params);
    if($re['status']==='success'){
        return send_success($re['msg'],$re['data']);
    }else{
        return send_error(($re['msg'] ? $re['msg'] : '安装出现未知错误'),$re['data']);
    }

}
/**
 * 接收应用市场绑定数据
 */
if($action==='bind_market'){
    $params=$request->post();
    $must_params=[
        'token'=>'',
        'market_uid'=>'',
        'market_appid'=>'',
        'app_key'=>'',
        'app_secret'=>''
    ];
    $re=check_params($must_params,$params);
    if($re!==true) return send_error($re);

    $market_info=LDB::table('plugins_market_config')->first();
    if($market_info)return send_error('已经绑定过应用市场，请勿重复绑定');
    $token=Cache::get('market_token');
    Cache::remove('market_token');
    if($token!==$params['token'])return send_error('token验证错误');
    $re=LDB::table('plugins_market_config')->insertGetId([
            'market_uid'=>(int)$params['market_uid'],
            'market_appid'=>(int)$params['market_appid'],
            'app_key'=>strip_tags($params['app_key']),
            'app_secret'=>strip_tags($params['app_secret']),
            'create_time'=>time(),
            'web_name'=>$params['web_name'] ? $params['web_name'] : '',
              'nickname'=>$params['nickname'] ? $params['nickname'] : '',
              'phone'=>$params['tel'] ? $params['tel'] : '',
        ]);
    if($re){
        return send_success('绑定成功');
    }else{
        return send_error('绑定失败');
    }



}

/**
 * 检查必须参数
 * @param $must_params
 * @return array|bool|void
 */
 function check_params($must_params,$params){
    if(empty($must_params)) return true;
    $errormsg1 = '必填参数未定义:';
    $errormsg2 = '必填参数为空:';

    foreach($must_params as $k=>$v){
        if(!isset($params[$k])){
            return $errormsg1.$v."(".$k.")";
        }elseif(empty($params[$k])){
            return $errormsg2.$v."(".$k.")";
        }
    }

    return true;
}