<?php
setApi();
$req = getPayloadParams();
$wid = $req['wid'];
$orderid = $req['orderid'];
$goodsid = $req['goodsid'];
$openid = $req['otheropenid'];
$order = (new Model('vshop_goods_bargain_order'))->find($orderid);
$goods = (new Model('vshop_goods_bargain'))->find($goodsid);
if (!arr_get($req, 'wid') || !arr_get($req, 'otheropenid') || !$goods || !$order) {
  sendResponse([]);
  exit();
}
//帮砍次数已达上限
$bargain_info_arr = json_decode($order->bargain_info,true);
$has_bargain_count = count($bargain_info_arr);
if($goods->bargain_num <= $has_bargain_count){
  sendError('帮砍次数已达上限，请关注其他商品！');
}

//判断此人是否已经帮砍过
foreach ($bargain_info_arr as $k=>$v){
  if($v['openid'] == $openid){
    sendError('您已帮砍过，请关注其他商品！');
  }
}
if($order->is_submit){
    sendError("砍价失败，已提交订单不支持砍价");
}
//帮砍时间是否已到
$start = $order->sdate;
$limit = $goods->limit_day*86400;
if($start+$limit < time()){
  sendError('帮砍时间已过，请抓紧时间购买！');
}

//帮忙砍价
$ks = explode('-',$goods->bargain_money)[0];
$ke = explode('-', $goods->bargain_money)[1];
$bargainMoney = randomFloat($ks,$ke);
$new = ['openid'=>$openid,'bargainMoney'=>$bargainMoney];
array_push($bargain_info_arr, $new);
$order->bargain_info = json_encode($bargain_info_arr);
$order->really_price = $order->really_price-$bargainMoney;
$order->save();
sendSuccess('帮砍成功，请看看其他商品吧！');

function randomFloat($min = 0, $max = 1) {
  $num = $min + mt_rand() / mt_getrandmax() * ($max - $min);
  return round($num,2);
}