<?php
setApi();
$cf = new CustomForm();
$req = getPayloadParams();
if (!(arr_get($req, 'openid') && arr_get($req, 'wid'))) {
  sendResponse(['status' => 'error', 'msg' => '参数错误'], true);
}
$wid = $req['wid'];
$openid = $req['openid'];
if (!$openid || !$wid) sendError('参数缺失');
$formData = $req['formData'];
$form = (new Model('custom_form'))->find(['wid' => $wid, 'id' => $req['form_id']])->get_model_array();
if (!arr_get($form, 'id')) sendError('表单不存在');
$form['submit_tip'] = json_decode($form['submit_tip'], true);
$form['submit_limit'] = json_decode($form['submit_limit'], true);
$form['submit_btn'] = json_decode($form['submit_btn'], true);
// 判断是否可以进行提交
$submit_limit = $form['submit_limit'];
if ($form['form_limit'] == 1 && (time() > $form['etime'] || time() < $form['stime'])) {
  sendError('【' . $form['title'] . '】暂时无法使用');
}
if ($submit_limit['count']['limit'] == 1) {
  $count = (new Model('custom_form_data'))->where(['wid' => $wid, 'fid' => $form['id']])->count();
  if ($count >= $submit_limit['count']['value']) {
    sendError('【' . $form['title'] . '】已结束');
  }
}
if ($submit_limit['day_count']['limit'] == 1) {
  $day = strtotime(date('Y-m-d', time()));
  $day_count = (new Model('custom_form_data'))->where(['wid' => $wid, 'fid' => $form['id'], 'ctime@>' => $day])->count();
  if ($day_count >= $submit_limit['day_count']['value']) {
    sendError('【' . $form['title'] . '】今日提交数量已达上限');
  }
}
if ($submit_limit['per_count']['limit'] == 1) {
  $per_count = (new Model('custom_form_data'))->where(['wid' => $wid, 'fid' => $form['id'], 'openid' => $openid])->count();
  if ($per_count >= $submit_limit['per_count']['value']) {
    sendError('【' . $form['title'] . '】您提交数量已达上限');
  }
}
if ($submit_limit['per_day_count']['value'] == 1) {
  $day = strtotime(date('Y-m-d', time()));
  $per_day_count = (new Model('custom_form_data'))->where(['wid' => $wid, 'fid' => $form['id'], 'openid' => $openid, 'ctime@>' => $day])->count();
  if ($per_day_count >= $submit_limit['per_count']['value']) {
    sendError('【' . $form['title'] . '】您今日提交数量已达上限');
  }
}
// 整理字段数据
$tip_success = $form['submit_tip']['success'] ? $form['submit_tip']['success'] : '提交成功';
$tip_fail = $form['submit_tip']['fail'] ? $form['submit_tip']['fail'] : '提交失败';
$fields = (new Model('custom_form_field'))->order('sort desc')->list_all_array(['wid' => $req['wid'], 'fid' => $form['id'], 'is_del' => 0]);
// 进行数据验证
foreach ($fields as $field) {
  // 整理字段数据
  $field['attr'] = json_decode($field['attr'], true);
  if ($field['attr']['options']) {
    $field['attr']['options'] = explode("\n", trim($field['attr']['options']));
  }
  if (!in_array($field['type'], ['img', 'line'])) {
    // required验证
    if ($field['attr']['required'] == '1' && (!isset($formData[$field['id']]) || $formData[$field['id']] == '' || $formData[$field['id']] == null || $formData[$field['id']] == [] || count($formData[$field['id']]) == 0)) {
      sendError('【' . $field['title'] . '】不能为空');
    }
    // num验证
    if ($formData[$field['id']]!='' && $formData[$field['id']] != null && $field['type'] == 'num' && !is_numeric($formData[$field['id']])) sendError('【' . $field['title'] . '】必须是数字');
    // email验证
    if ($formData[$field['id']]!='' && $formData[$field['id']] != null && $field['type'] == 'email' && !is_email($formData[$field['id']])) sendError('【' . $field['title'] . '】邮箱格式不正确');
    // 手机号验证
    if ($formData[$field['id']]!='' && $formData[$field['id']] != null && $field['type'] == 'phone' && !is_mobile($formData[$field['id']])) sendError('【' . $field['title'] . '】手机号格式不正确');
    // 身份证验证
    if ($formData[$field['id']]!='' && $formData[$field['id']] != null && $field['type'] == 'idcard' && !is_idcard($formData[$field['id']])) sendError('【' . $field['title'] . '】身份证号码格式不正确');
    // 多选验证
    if ($field['type'] == 'multiselect' && $field['attr']['select_control']['switch'] == 1 && $field['attr']['select_control']['num'] > 0) {
      $num = $field['attr']['select_control']['num'];
      $s_num = count($formData[$field['id']]);
      if ($field['attr']['select_control']['handle'] == '<=' && $s_num > $num) {
        sendError('【' . $field['title'] . '】最多选择' . $num . '项');
      } else if ($field['attr']['select_control']['handle'] == '>=' && $s_num < $num) {
        sendError('【' . $field['title'] . '】最少选择' . $num . '项');
      } else if ($field['attr']['select_control']['handle'] == '==' && $s_num != $num) {
        sendError('【' . $field['title'] . '】必须选择' . $num . '项');
      }
    }
    // 数据进一步处理
    // 合并省市区数据
    if ($field['type'] == 'addr' && isset($formData[$field['id']])) {
      $formData[$field['id']] = implode('/', $formData[$field['id']]);
    }
    // 序列化[多选,图片上传]数据
    if (in_array($field['type'], ['multiselect', 'file']) && isset($formData[$field['id']])) {
      $formData[$field['id']] = json_encode($formData[$field['id']]);
    }
  }
}
// 保存数据
$saved = new Model('custom_form_data');
$saved->wid = $wid;
$saved->openid = $openid;
$saved->fid = $form['id'];
$saved->data = json_encode($formData);
$saved->need_pay = $form['need_pay'] ? 1 : 0;
$saved->is_pay = 0;
$saved->order_no = getRandomOrderNo($form['id']);
$saved->pay_amount = $form['price'];
$saved->ctime = time();
$saved->save();
// 发送短信
$userInfo = (new Model('wechat_group_list'))->find(['openid' => $openid]);
if ($form['sms_notice'] == 1 && $userInfo->id) {
  $phones = explode(",", $form['sms_notice_phone']);
  foreach ($phones as $phone) {
    $phone = trim($phone);
    if ($phone) {
      $content = '用户【' . $userInfo->nickname . '】提交了您发布的表单【' . $form['title'] . '】';
      send_sms(wid_to_uid($wid), $phone, $content);
    }
  }
}
if ($form['need_pay'] == 1) {
    /**$resultTradeCreate=ali_prepay($wid, $openid, intval($form['price'] * 100) / 100,
        Conf::$http_path_api."Payment/Zfbpay/customFormNotify-".$wid.".html", $saved->order_no, '表单支付');
    $payParams['alipay_trade_create_response']=(array)$resultTradeCreate->alipay_trade_create_response;*/
	$payParams = tt_prepay($wid, $openid, intval($form['price'] * 100) / 100, Conf::$http_path_api."Payment/Ttpay/customFormNotify-".$wid.".html", $saved->order_no, '表单支付');

  sendSuccess($tip_success, ['pay' => true, 'pay_params' => $payParams]);
} else {
  sendSuccess($tip_success, ['pay' => false]);
}
