<?php
Page::$need_view = false;
header('Content-Type:application/json');
$req = getPayloadParams();
$wid = $req['wid'];
$openid = $req['openid'];
if (!arr_get($req, 'wid') || !arr_get($req, 'openid')) {
  sendResponse(['status' => 'error', 'msg' => '缺少参数'], true);
}
// 所需数据
$wxUser = (new Model('wechat_group_list'))->find(['wid' => $wid, 'openid' => $openid]);
$dzpSetting = get_dzp_setting($wid)->get_model_array();
$vipCard = (new Model('vip_card'))->find(['wid' => $wid, 'openid' => $openid]);
$is_vip = $vipCard->id ? 1 : 0;
// 注意，这里的抽奖奖品，条件：未删除，数量大于0
$prizeList = (new Model('dzp_prize'))->order('sort desc')->list_all(['is_vip' => $is_vip, 'wid' => $wid, 'is_del' => 0, 'num@>' => 0]);
// 初始化抽奖次数和分享次数
$date = date('Y-m-d', time());
if ($wxUser->dzp_date != $date) {
  $wxUser->dzp_date = $date;// 日期更新
  $wxUser->dzp_frequency = $dzpSetting['day_num'];// 今日抽奖次数
  $wxUser->dzp_share_count = $dzpSetting['share_count'];
  $wxUser->save();
}
// 判断抽奖次数是否足够
// 如果会员卡用户的抽奖次数不足,自动扣取积分进行抽奖(因为前端那边进行了判断,次数不足的时候会进行询问是否使用积分)
if($dzpSetting['per_max']>0 && $wxUser->dzp_win_num >= $dzpSetting['per_max']){
  sendResponse(['status' => 'error', 'msg' => '抱歉，您的中奖次数已达到最大值'], true);
}else if ($wxUser->dzp_frequency <= 0) {
  if (!$is_vip) {
    // 不是会员
    sendResponse(['status' => 'error', 'msg' => '抽奖次数不足'], true);
  } else {
    // 是会员
    if ($dzpSetting['open_point_lottery']) {
      // 如果开启了积分抽奖
      if ($vipCard->point < $dzpSetting['point_lottery_consume']) {
        // 积分不够。。。
        sendResponse(['status' => 'error', 'msg' => '抱歉，您的抽奖次数不足且积分不足，请明天再来吧'], true);
      } else {
        // 积分够抽奖
        // 扣积分,可以进行抽奖了
        $vipCard->point = $vipCard->point - $dzpSetting['point_lottery_consume'];
        $vipCard->save();
      }
    } else {
      // 未开启积分抽奖
      sendResponse(['status' => 'error', 'msg' => '抽奖次数不足'], true);
    }
  }
} else {
  // 扣去一次抽奖机会
  $wxUser->dzp_frequency = $wxUser->dzp_frequency - 1;
  $wxUser->save();
}
// 随机抽取
$chanceCount = 0;
foreach ($prizeList as $prize) {
  $chanceCount += $prize->chance;
}
$randPrice = rand(1, $chanceCount);
// 查找抽到的是哪个奖品
$startRange = 1;
foreach ($prizeList as $prize) {
  $endRange = $startRange + $prize->chance;
  if ($dzpSetting['per_max']>0 && $wxUser->dzp_win_num >= $dzpSetting['per_max']) {
    if ($prize->is_empty == 1) {
      $resultPrize = $prize;
      break;
    }
  } else if ($startRange <= $randPrice && $randPrice < $endRange) {
    $resultPrize = $prize;
    break;
  }
  $startRange = $endRange;
}

if(!isset($resultPrize)){
  $dt=[
    'is_empty'=>1
  ];
}else if (!$resultPrize->is_empty) {// 如果不是空奖
  // 中奖次数+1
  $wxUser->dzp_win_num = $wxUser->dzp_win_num + 1;
  $wxUser->save();
  // 数量-1
  $resultPrize->num = $resultPrize->num - 1;
  $resultPrize->save();
  // 生成抽奖记录和兑换码
  $code = base64_encode(time() . rand(100, 999) . $resultPrize->id);
  $record = new Model('dzp_record');
  $record->wid = $wid;
  $record->openid = $openid;
  $record->prize_id = $resultPrize->id;
  $record->code = $code;
  $record->ctime = time();
  // 判断是不是积分，如果是积分则自动进行发放
  if ($resultPrize->type == 1 && $is_vip) {
    $record->is_ok = 1;
    $vipCard->point = $vipCard->point + $resultPrize->value;
    $vipCard->total_point = $vipCard->total_point + $resultPrize->value;
    $vipCard->save();
  }
  $record->save();
  $dt=$resultPrize->get_model_array();
  //模板消息
  if($dzpSetting['template_id']){
	  try {
      sendTplMsg_dzp_success($wid, $dzpSetting['template_id'], $openid, $req['formId'], $dt['name'], date('Y-m-d H:i:s',$record->ctime));
    } catch (Exception $e) {
      diy_log(['大转盘抽奖模板消息失败', $e]);
    }
  }
}else{
  $dt=[
    'is_empty'=>1
  ];
}
// 返回抽到的奖品
sendResponse(['status' => 'success', 'msg' => '抽奖成功', 'data' => $dt], true);