<?php
require_once "common.php";
// 删除本人未支付的订单
// (new Model('jd_order'))->delete(['wid' => $wid, 'openid' => $openid, 'is_pay' => 0]);
// 删除超过30分钟未支付的订单
(new Model('jd_order'))->delete(['wid' => $wid, 'is_pay' => 0, 'ctime@<' => date('Y-m-d H:i:s', time() - 30 * 60)]);
// 检查时间是否有错并计算天数
$sdate = $req['sdate'];
$edate = $req['edate'];
$stime = strtotime($sdate);
$etime = strtotime($edate);
$today = strtotime(date('Y-m-d'));
if ($stime < $today) {
  sendError('开始时间不能早于今天');
} else if ($stime >= $etime) {
  sendError('开始时间不能大于结束时间');
}
$day = (int)round(($etime - $stime) / (24 * 3600), 0);
if ($day <= 0) {
  sendError('时间计算错误');
}
// 检查客房和套餐是否存在
$kf = (new Model('jd_kf'))->find(['wid' => $wid, 'id' => $req['kfId']]);
if (!$kf->id) sendError('客房不存在');

// 是否在客房已满区间内

$fstime = strtotime($kf->full_stime);
$fetime = strtotime($kf->full_etime);

if (time() >= $fstime && time() <= $fetime) {
  sendError('客房已满，无法预订');
}

$tcList = json_decode($kf->taocan, true);
if (count($tcList) - 1 < $req['tcIdx']) {
  sendError('您选择的套餐参数错误');
}
$tc = $tcList[$req['tcIdx']];
// 检查客房的数量是否充足
$num = (int)$req['num'];
$sql = <<<SQL
SELECT coalesce(sum(num),0) AS used_num
FROM jd_order
WHERE
  (
    (sdate >= '%s' AND sdate < '%s') OR
    (edate > '%s' AND edate <= '%s') OR
    (sdate <= '%s' AND edate >= '%s')
  )
  AND
  is_refund = 0
  AND
  wid = %s
  AND
  kf_id = %s
SQL;
$sql = sprintf($sql, $sdate, $edate, $sdate, $edate, $sdate, $day, $wid, $kf->id);
$used_num = (int)db_query($sql)[0]['used_num'];
if ($num > ((int)$kf->num - $used_num)) {
  sendError('客房数量不足，请重新选择房间数');
}
// 计算金额，判断是否可取消，生成订单
$price = $tc['price'];
$total_price = $price * $num * $day;
$order_no = getRandomOrderNo();
$order = new Model('jd_order');
arr_to_model($order, [
  'wid' => $wid,
  'openid' => $openid,
  'kf_id' => $kf->id,
  'order_no' => $order_no,
  'name' => $req['name'],
  'phone' => $req['phone'],
  'num' => $num,
  'sdate' => $sdate,
  'edate' => $edate,
  'price' => $price,
  'day' => $day,
  'total_price' => $total_price,
  'cancel' => $tc['cancel'],
  'is_ruzhu' => 0,
  'is_pay' => 0,
  'is_refund' => 0,
  'ctime' => date('Y-m-d H:i:s'),
  'form_id' => $req['formId'],
  'tc_name' => $tc['name'],
]);
$order->save();
if ($tc['cancel'] == 0) {
  $cancelInfo = '随时取消';
} else if ($tc['cancel'] == 1) {
  $cancelInfo = '18点前可取消';
} else {
  $cancelInfo = '不可取消';
}
//通用支付逻辑
$respData=common_prepay($wid, $openid, $total_price, 'jdNotify', $order_no, '酒店预订-' . $tc['name'] . '-' . $cancelInfo, json_encode(['wid' => $wid]),$req);
//通用支付逻辑

if ($pay_params['status']=='error') {
  sendError('调起支付失败，请稍后重试');
}
$pay_params=$respData['data'];
$setting = (new Model('jd_setting'))->find(['wid' => $wid]);
if($setting->pay_tplid){
    $pay_params['tpl_ids']=[$setting->pay_tplid];
}
$prepay_id = explode('=', $pay_params['package'])[1];
$order->prepay_id = $prepay_id;
$order->save();

sendSuccess('OK', $pay_params);
