<?php
/**
 * 根据商品ID获取评价列表（分页加载）
 */

// API header信息
require_once "apiHead.php";
// 扩展库
require_once "../../vendor/autoload.php";
// 数据库模型
require_once DOXCX_FRAME_PATH . 'fun/EloquentModels/EloquentModels.php';

$params = json_decode(file_get_contents('php://input'), true);
// 需要openid+wid+orderid
$wid = arr_get($params, 'wid');
$product_id = arr_get($params, 'product_id');
$page = arr_get($params, 'page');
$pageSize = 5;
// 检查参数
if (!($wid && $product_id && $page)) {
  sendResponse([
    'status' => 'error',
    'msg' => '参数不正确'
  ]);
  exit();
}
// 获取评价列表
$evList = VshopEvaluation::where('product_id', $product_id)
  ->where('wid', $wid)
  ->where('is_show', 1)
  ->orderBy('id', 'desc')
  ->offset(intval($page - 1) * $pageSize)
  ->limit($pageSize)
  ->get();
// 发送响应数据
sendResponse($evList);
//退出防止接下来的报错
exit();