<?php
/**
 * 订单列表
*/
header("Content-Type: text/html; charset=UTF-8");
//加载核心文件
require_once(DOXCX_FRAME_PATH.'fun/AES.php');
//get post data, May be due to the different environments
$postStr = file_get_contents("php://input");
$data = json_decode($postStr);//获取数据

//实例化类
$aes = new aes();

if(!$data->data){//加密数据
    $arr = array('errcode'=>1,'errmsg'=>'缺少参数');
}else{

    //AES解密数据
    $json_data = $aes->aes128cbcHexDecrypt($data->data);
    //解析json数据
    $result = json_decode($json_data);

    if(!$result->wid){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：wid');
    }elseif (!$result->openId){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：openId');
    }elseif (!$result->currentPage){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：currentPage');
    }elseif (!$result->pageSize){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：pageSize');
    }else{

        //商户id
        $wid = $result->wid;

        /********************数据处理********************/
        $openid = $result->openId;
        $pageIndex = $result->currentPage;
        $pageSize = $result->pageSize;
        $type = $result->type;
        //搜索条件
        $where['wid'] = $wid;
        $where['wxid'] = $openid;
        if($type == 2){//待支付
            $where['OrderStatus'] = 1;//未完成订单
            $where['PayStatus'] = 0;//未支付
        }elseif($type == 3){//已发货，待收货
            $where['OrderStatus'] = 1;//未完成订单
            $where['PayStatus'] = 1;//已支付
            $where['DeliveryStatus'] = 1;//已发货，待收货
        }elseif($type == 5){//已发货，已收货、未评价
            $where['OrderStatus'] = 2;//完成订单
            $where['PayStatus'] = 1;//已支付
            $where['DeliveryStatus'] = 1;//已发货，待收货
        }

        //条数
        $lim = 	$pageSize*($pageIndex-1).','.$pageSize;

        //排序
        $order = 'id DESC';

        //获取订单列表
        $m = new Model('vshop_order');
        $res = $m->where($where)->limit($lim)->order($order)->list_all();
        $dataList = array();
        $i = 0;
        foreach($res as $_v){

            $IsPay = 0;//是否显示支付
            $IsCancel = 0;//是否显示取消订单
            $isTui = 0;
            $IsOrderEvaluate = 0;//是否显示去评价
            $IsShowEvaluate = 0;//是否显示 查看评价

            $IsCinfirmReceipt = 0;//是否显示确认收货

            //订单状态
            if($_v->OrderStatus == 2){//完成订单
                if($_v->EvaluationStatus == 0){//已完成,未评价
                    $OrderStatus = '已完成,未评价';
                    $IsOrderEvaluate = 0;//是否显示去评价
                  $IsShowEvaluate = 1;//是否显示 查看评价
                }elseif($_v->EvaluationStatus == 1){//已完成,已评价
                    $OrderStatus = '已完成,已评价';
                  $IsOrderEvaluate = 1;//是否显示去评价
                  $IsShowEvaluate = 0;//是否显示 查看评价
                }elseif($_v->EvaluationStatus == 2){//部分已评价
                    $OrderStatus = '已完成,部分已评价';
                    $IsShowEvaluate = 1;//是否显示 查看评价
                }elseif($_v->EvaluationStatus == 3){//已评价 维权超时
                    $OrderStatus = '已完成,已评价';
                    $IsShowEvaluate = 1;//是否显示 查看评价
                }
            }elseif($_v->OrderStatus == 3){//已关闭订单
                if($_v->IsMemberClose){//
                    $OrderStatus = '订单关闭';
                }else{
                    $OrderStatus = '商家已关闭';
                }
            }elseif($_v->OrderStatus == 4 || $_v->OrderStatus == 5){//已维权订单
                //退款中 = 0, 退货中 = 1, 已退款 = 2, 商家同意退货 = 3, 维权发货 = 4, 已维权已退款 = 5, 已维权已退货 = 6, 拒绝 = 7
                if($_v->RightsStatus == 0){
                    $OrderStatus = '等待退款';
                }elseif($_v->RightsStatus == 1){
                    $OrderStatus = '等待退货';
                }elseif($_v->RightsStatus == 2){
                    $OrderStatus = '已退款';
                }elseif($_v->RightsStatus == 3){
                    $OrderStatus = '已同意,等待发货';
                }elseif($_v->RightsStatus == 4){
                    $OrderStatus = '等待退款';
                }elseif($_v->RightsStatus == 5){
                    $OrderStatus = '已退款';
                }elseif($_v->RightsStatus == 6){
                    $OrderStatus = '已退款退货';
                }elseif($_v->RightsStatus == 7){
                    $OrderStatus = '已拒绝';
                }
            }else{
                if($_v->OrderStatus == 1 && $_v->PayStatus == 0){//未支付
                    $OrderStatus = '待支付';
                    $IsPay = 1;//是否显示支付
                    $IsCancel = 1;//是否显示取消订单
                }
                if($_v->OrderStatus == 1 && $_v->PayStatus == 1 && $_v->DeliveryStatus == 0){//已支付未发货   可以退款
                    $OrderStatus = '已支付,待发货';
                    $isTui = 1;
                }
                if($_v->OrderStatus == 1 && $_v->PayStatus == 1 && $_v->DeliveryStatus == 1){//已发货
                    $OrderStatus = '已发货,待收货';
                    $IsCinfirmReceipt = 1;//是否显示确认收货
                }
            }

            $dataList[$i]['orderid'] = $_v->id;
            $dataList[$i]['OrderNum'] = $_v->OrderNo;//订单号
            $dataList[$i]['StrOrderStatus'] = $OrderStatus;//订单状态
          $dataList[$i]['payAmount'] = $_v->payAmount;
			$items = json_decode($_v->items);
			foreach($items as $k => $ite){
				$speStr = getSpeStr($ite->goods_no,$ite->ProductId);
				$items[$k]->speStr = $speStr;
			}
            $dataList[$i]['OrderdetailList'] = json_decode(str_replace('"ImageUrl":"','"ImageUrl":"'.$weburl,json_encode($items)));//商品详细内容
            $dataList[$i]['RealTotal'] = $_v->is_vip_pay==1?$_v->vip_pay_money:$_v->payAmount;//实际支付金额
			$dy = json_decode($_v->delivery,true);
			$dataList[$i]['freight']=$dy['Fee']?$dy['Fee']:0.00;//运费
            $dataList[$i]['ShowOrderButton'] = array(
                'IsPay'=>$IsPay,
                'IsCancel'=>$IsCancel,
                'IsTui'=>$isTui,
                'is_refund_money'=>$_v->is_refund_money,
                'IsOrderEvaluate'=>$IsOrderEvaluate,
                'IsShowEvaluate'=>$IsShowEvaluate,
                'IsCinfirmReceipt'=>$IsCinfirmReceipt
            );//显示按钮数组
            $i++;
        }
        /********************数据处理********************/

        //返回数据
        $arr = array(
            'errcode' => 0,
            'errmsg' => 'ok',
            'dataList' => $dataList
        );
    }
}

//商品规格字符串
function getSpeStr($goods_no,$proId){
	$pro = new Model('vshop_product');
    $pro->find($proId);
	$rowtemp = json_decode($pro->rowtemp);
	foreach($rowtemp as $row){
		if($row->goods_no == $goods_no){
			$specArr = $row->spec_array;
			foreach($specArr as $spe){
				$spec = explode("_", $spe);
				$sprop = new Model('vshop_sprop');
				$sprop->find($spec[0]);
				if($sprop->type == 1){
					$speStr=$spec[1];
				}else{
					$tu = json_decode($sprop->value);
					foreach ($tu as $k=>$v){
						if($v == $spec[1]){
							$beizhuKey = $k;
						}
					}
					$beizhuArr = json_decode($sprop->beizhu);
					$speStr=$beizhuArr[$beizhuKey];
				}
				$speString = $speString . ' ' . $speStr;
			}
		}
	}
	return $speString;
}

//加密处理
$HexData = $aes->aes128cbcEncrypt(json_encode($arr));
$data = array('d'=>$HexData);
echo json_encode($data);
exit;

?>