<?php
/**
 * 获取订单+商品信息
 * 用于评价
 */

// API header信息
require_once "apiHead.php";
// 扩展库
require_once "../../vendor/autoload.php";
// 数据库模型
require_once DOXCX_FRAME_PATH . 'fun/EloquentModels/EloquentModels.php';

$params = json_decode(file_get_contents('php://input'), true);
// 需要openid+wid+orderid
$wid = arr_get($params, 'wid');
$openid = arr_get($params, 'openid');
$orderid = arr_get($params, 'orderid');
// 检查参数
if (!($wid && $openid && $orderid)) {
  sendResponse([
    'status' => 'error',
    'msg' => '参数不正确'
  ]);
  exit();
}
//检查订单是否存在
$order = VshopOrder::where('wid', $wid)->where('wxid', $openid)->where('id', $orderid)->first();
if (!$order) {
  sendResponse([
    'status' => 'error',
    'msg' => '订单不存在'
  ]);
  exit();
}
$order=$order->toArray();
$order['address']=json_decode($order['address'],true);
$order['delivery']=json_decode($order['delivery'],true);
$order['items']=json_decode($order['items'],true);
$order['payment']=json_decode($order['payment'],true);
// 发送响应数据
sendResponse($order);
//退出防止接下来的报错
exit();