<?php
/**
 * 提交评价信息
 */

// API header信息
require_once "apiHead.php";
$params = json_decode(file_get_contents('php://input'), true);
// 需要openid+wid+orderid
$wid = arr_get($params, 'wid');
$openid = arr_get($params, 'openid');
$orderid = arr_get($params, 'orderid');
$evaluations = arr_get($params, 'evaluations');
// 检查参数
if (!($wid && $openid && $orderid && $evaluations)) {
  sendResponse([
    'status' => 'error',
    'msg' => '参数不正确'
  ]);
  exit();
}
//处理数据
// 积分
$vipSetting = (new Model('vip_setting'))->find(['wid' => $wid]);
$vipCard = (new Model('vip_card'))->find(['wid' => $wid, 'openid' => $openid]);
$point = 0;
// 1，生成评价记录
foreach ($evaluations as $product_id => $evaluation) {
  $data = [
    'wid' => $wid,
    'openid' => $openid,
    'order_id' => $orderid,
    'product_id' => $product_id,
    'star' => $evaluation['star'],
    'content' => $evaluation['content'],
    'submit_time' => date('Y-m-d H:i:s', time()),
    'is_show' => 1
  ];
  $ev = new Model('vshop_evaluation');
  foreach ($data as $k => $v) {
    $ev->$k = $v;
  }
  $ev->save();
  $point += $vipSetting->evaluate_point;
}
if ($vipCard->id) {
  $vipCard->point += $point;
  $vipCard->total_point += $point;
  $vipCard->save();
  // 模板消息
  $tpl = arr_get(json_decode($vipSetting->tpl_msg, true), 'tplmsg_point_change');
  $tplMsg = sendTplMsg_point_change($wid, $tpl, $openid, $params['formId'], $point, $vipCard->point, $vipCard->total_point);
}
// 2，标记订单为已评价
$order = (new Model('vshop_order'))->find(['id' => $orderid]);
$order->EvaluationStatus = 1;
$order->save();
// 发送响应数据
sendResponse([
  'status' => 'success',
  'msg' => '评价成功',
  'tplMsg' => $tplMsg ? $tplMsg : ''
]);
//退出防止接下来的报错
exit();