<?php
/**
 * 商品列表
 */
header("Content-Type: text/html; charset=UTF-8");
//加载核心文件
require_once(DOXCX_FRAME_PATH.'fun/AES.php');
//get post data, May be due to the different environments
$postStr = file_get_contents("php://input");
$data = json_decode($postStr);//获取数据



//实例化类
$aes = new aes();

if(!$data->data){//加密数据
    $arr = array('errcode'=>1,'errmsg'=>'缺少参数');
}else{

    //AES解密数据
    $json_data = $aes->aes128cbcHexDecrypt($data->data);
    //解析json数据
    $result = json_decode($json_data);

    if(!$result->wid){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：wid');
    }elseif(!$result->pageindex){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：pageindex');
    }elseif(!$result->orderby){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：orderby');
    }elseif(!$result->sort){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：sort');
    }else {

        //商户id
        $wid = $result->wid;

        /********************数据处理********************/
        $pageIndex = $result->pageindex;//当前页
        $pageSize = 10;//每页条数
        $orderby = $result->orderby;//排序类型；1销量搜索；2新品搜索；3价格搜索
        $sort = $result->sort;//1正叙；2倒叙
        $pname = $result->pname;//搜索名称
        $cid = $result->cid;//分类id

        //搜索条件
        $where['wid'] = $wid;
        if(trim($pname)){
            $where['name@~'] = $pname;
        }
        if($cid){
            $where['typ'] = $cid;
        }

        //条数
        $lim = 	$pageSize*($pageIndex-1).','.$pageSize;

        //排序
        if($orderby == 1){//销量
            if($sort == 2){
                $order = 'sale_nums DESC';
            }else{
                $order = 'sale_nums ASC';
            }
        }elseif($orderby == 2){//新品
            if($sort == 2){
                $order = 'id DESC';
            }else{
                $order = 'id ASC';
            }
        }elseif($orderby == 3){//价格
            if($sort == 2){
                $order = 'lowest DESC';
            }else{
                $order = 'lowest ASC';
            }
        }

        $m = new Model('vshop_product');
        $res = $m->field('id,name,pic,lowest,yj')->where($where)->limit($lim)->order($order)->list_all();
        $dataList = array();
        $i = 0;
        foreach($res as $_v){

            $dataList[$i]['id'] = $_v->id;
            $dataList[$i]['ProductPic'] = $_v->pic;
            $dataList[$i]['SalesName'] = $_v->name;
            $dataList[$i]['SalePrice'] = $_v->lowest;
			$dataList[$i]['MarketPrice'] = $_v->yj;
			
            $i++;
        }
        /********************数据处理********************/

        //返回数据
        $arr = array(
            'errcode' => 0,
            'errmsg' => 'ok',
            'dataList' => $dataList
        );
    }
}

//加密处理
$HexData = $aes->aes128cbcEncrypt(json_encode($arr));
$data = array('d'=>$HexData);
echo json_encode($data);
exit;

?>