<?php
/**
 * 订单列表
 */
header("Content-Type: application/json");

$result = getPayloadParams(false);

if (!$result->wid) {
  $arr = array('errcode' => 1, 'errmsg' => '缺少参数：wid');
} else if (!$result->orderid) {
  $arr = array('errcode' => 1, 'errmsg' => '缺少参数：orderid');
} else {

  //商户id
  $wid = $result->wid;

  /********************数据处理********************/
  $openid = $result->openId;
  $orderid = $result->orderid;

  $dataList = array();
  $m = new Model('vshop_order');
  $m->field('id,wid,wxid,OrderNo,items,payAmount,OrderStatus,EvaluationStatus,IsMemberClose,RightsStatus,PayStatus,DeliveryStatus,address,remark,create_time,couponAmount,LogisticsName,LogisticsNum,delivery')->find($orderid);
  if ($m->wid == $wid) {

    //商品详情
    $ProTotalMoney = 0;
    $OrderDetailVOList = array();
    $items = json_decode($m->items);
    $i = 0;
    foreach ($items as $_ite) {
      $OrderDetailVOList[$i] = array(
        'ProductId' => $_ite->ProductId,
        'ProductName' => $_ite->Name,
        'SpecStr' => $_ite->Description,
        'ProductUrl' => '',
        'FactPrice' => $_ite->Price,
        'Path' => $_ite->ImageUrl,
        'Amount' => $_ite->Count
      );
      $ProTotalMoney += $_ite->Price * $_ite->Count;
      $i++;
    }

    $IsPay = 0;//是否显示支付
    $IsCancel = 0;//是否显示取消订单

    $IsOrderEvaluate = 0;//是否显示去评价
    $IsShowEvaluate = 0;//是否显示 查看评价

    $IsCinfirmReceipt = 0;//是否显示确认收货

    //订单状态
    if ($m->OrderStatus == 2) {//完成订单
      if ($m->EvaluationStatus == 0) {//已完成,未评价
        $OrderStatus = '已完成,未评价';
        $IsOrderEvaluate = 1;//是否显示去评价
      } else if ($m->EvaluationStatus == 1) {//已完成,已评价
        $OrderStatus = '已完成,已评价';
        $IsShowEvaluate = 1;//是否显示 查看评价
      } else if ($m->EvaluationStatus == 2) {//部分已评价
        $OrderStatus = '已完成,部分已评价';
        $IsShowEvaluate = 1;//是否显示 查看评价
      } else if ($m->EvaluationStatus == 3) {//已评价 维权超时
        $OrderStatus = '已完成,已评价';
        $IsShowEvaluate = 1;//是否显示 查看评价
      }
    } else if ($m->OrderStatus == 3) {//已关闭订单
      if ($m->IsMemberClose) {//
        $OrderStatus = '订单关闭';
      } else {
        $OrderStatus = '商家已关闭';
      }
    } else if ($m->OrderStatus == 4 || $m->OrderStatus == 5) {//已维权订单
      //退款中 = 0, 退货中 = 1, 已退款 = 2, 商家同意退货 = 3, 维权发货 = 4, 已维权已退款 = 5, 已维权已退货 = 6, 拒绝 = 7
      if ($m->RightsStatus == 0) {
        $OrderStatus = '等待退款';
      } else if ($m->RightsStatus == 1) {
        $OrderStatus = '等待退货';
      } else if ($m->RightsStatus == 2) {
        $OrderStatus = '已退款';
      } else if ($m->RightsStatus == 3) {
        $OrderStatus = '已同意,等待发货';
      } else if ($m->RightsStatus == 4) {
        $OrderStatus = '等待退款';
      } else if ($m->RightsStatus == 5) {
        $OrderStatus = '已退款';
      } else if ($m->RightsStatus == 6) {
        $OrderStatus = '已退款退货';
      } else if ($m->RightsStatus == 7) {
        $OrderStatus = '已拒绝';
      }
    } else {
      if ($m->OrderStatus == 1 && $m->PayStatus == 0) {//未支付
        $OrderStatus = '待支付';
        $IsPay = 1;//是否显示支付
        $IsCancel = 1;//是否显示取消订单
      }
      if ($m->OrderStatus == 1 && $m->PayStatus == 1 && $m->DeliveryStatus == 0) {//已支付未发货   可以退款
        $OrderStatus = '已支付,待发货';
      }
      if ($m->OrderStatus == 1 && $m->PayStatus == 1 && $m->DeliveryStatus == 1) {//已发货
        $OrderStatus = '已发货,待收货';
        $IsCinfirmReceipt = 1;//是否显示确认收货
      }
    }

    //订单显示状态
    $ShowOrderButton = array(
      'IsPay' => $IsPay,
      'IsCancel' => $IsCancel,
      'IsOrderEvaluate' => $IsOrderEvaluate,
      'IsShowEvaluate' => $IsShowEvaluate,
      'IsCinfirmReceipt' => $IsCinfirmReceipt
    );

    //收货地址
    $address = json_decode($m->address);
    //运费
    $delivery = json_decode($m->delivery);

    //订单数据
    $dataList = array(
      'OrderStatus' => $OrderStatus,//订单状态
      'OrderNum' => $m->OrderNo,//订单编号
      'ProTotalMoney' => $ProTotalMoney,//商品总额
      'RealTotal' => $m->payAmount,//实际金额
      'OrderTypeDiscount' => 0,//优惠金额
      'CouponDiscount' => $m->couponAmount,//优惠券金额
      'Address' => $address->FullAddress,//地址
      'Tel' => $address->phone,//电话
      'Consignee' => $address->receiver,//收件人行吗
      'PayTypeStr' => '微信支付',//支付类型
      'OrderDetailVOList' => $OrderDetailVOList,//商品列表
      'PayStatus' => $m->PayStatus == 1 ? '已支付' : '未支付',//支付状态
      'Remark' => $m->remark,//备注
      'CreateTime' => $m->create_time,//下单时间
      'ShowOrderButton' => $ShowOrderButton,//是否显示按钮
      'LogisticCode' => $m->LogisticsNum,//物流单号
      'LogisticName' => $m->LogisticsName,//物流名称
      'OrderId' => $m->id,
      'Freight' => $delivery->Fee//运费
    );

    //返回数据
    $arr = array(
      'errcode' => 0,
      'errmsg' => 'ok',
      'dataList' => $dataList
    );
  } else {
    $arr = array('errcode' => 1, 'errmsg' => '订单不存在');
  }
  /********************数据处理********************/
}

//加密处理
echo json_encode($arr);
exit;
?>