<?php
require_once "common.php";
// 处理用户黑名单情况
if ($user->is_black) sendError('您没有权限发布消息');
// 判断
if (count($req['img']) > 3) sendError('图片最多上传3张');
if (trim($req['content']) == '') sendError('内容不能为空');
if (trim($req['address']) == "") sendError('请选择地址');
if (!$req['cate_id']) sendError('分类信息错误，请重新选择分类');
$total_price = 0;
// 查询分类信息
$cate = (new Model('tc_cate'))->find(['wid' => $wid, 'id' => $req['cate_id'], 'is_del' => 0]);
if (!$cate->id) sendError('分类信息错误，请返回重新选择分类');
// 敏感词过滤
$no_words_list = trim($cate->no_words == '') ? [] : explode(',', $cate->no_words);
foreach ($no_words_list as $wd) {
  if (stristr($req['content'], trim($wd)) != false) sendError('您的内容包含敏感词，请修改后发布');
}
// 查询设置信息
$setting = get_tc_setting($wid);
$resp = [];
$msg = new Model('tc_msg');
$order_no = getRandomOrderNo();
$msg->order_no = $order_no;


// 处理置顶情况
if ($req['is_top'] == 1) {
  // 查询置顶所需的金额
  $flag = false;
  foreach ($setting['top_setting'] as $top_setting) {
    if ($top_setting['top_time'] == $req['top_time']) {
      $flag = true;
      $top_money = $top_setting['top_money'];
      break;
    }
  }
  if (!$flag) sendError('置顶参数错误，请重新选择');
  // 设置置顶所需的支付金额等信息
  $total_price += $top_money;
  $msg->is_top = 1;
  $msg->top_time = intval($req['top_time']);
  $msg->top_price = $top_money;
  if ($top_money > 0) {
    // 在支付回调设置 置顶起止时间
  } else {
    // 如果置顶不要钱，直接设置开始时间和结束时间
    $msg->top_stime = date('Y-m-d H:i:s');
    $msg->top_etime = date('Y-m-d H:i:s', time() + intval($req['top_time']) * 86400);
  }
} else {
  $msg->top_price = 0;
}
//file_put_contents(DOXCX_FRAME_PATH.'/log/info/'.date('Y_m_d',time()).'.log', date('H:i:s',time()).': '.$total_price."\n",FILE_APPEND);

// 分类下发布是否需要支付
if ($cate->price > 0) { // 如果需要支付
  // 检查是否有免费发布次数
  if ($user->free_num > 0) {
    $msg->is_free = 1;
    $msg->cate_price = 0;
    // 准备 扣除一次免费发布机会
    $flag_discount_free_num = true;
  } else {
    $msg->is_free = 0;
    $msg->cate_price = $cate->price;
    $total_price += $cate->price;
  }
} else {
  $msg->is_free = 0;
  $msg->cate_price = 0;
}
//file_put_contents(DOXCX_FRAME_PATH.'/log/info/'.date('Y_m_d',time()).'.log', date('H:i:s',time()).': '.$total_price."\n",FILE_APPEND);
// 判断是否需要支付
if ($total_price > 0) {
  // 调起支付，得到支付参数
  /*
  $pay_params = wechat_prepay($wid, $openid, $total_price, Conf::$http_path_api . '/Payment/Wxpay/tcNotify.html', $order_no, '同城信息发布', json_encode(['wid' => $wid]));
  if (!$pay_params) sendError('调起支付失败，请稍后重试');
  */
  //统一下单
	$money = $total_price;
	$OrderNo = $order_no;
	$name_str = '同城信息发布';
	/**$resultTradeCreate=ali_prepay($wid, $openid, $money, Conf::$http_path_api."Payment/Zfbpay/tcNotify-".$wid.".html", $OrderNo, $name_str);
	$dataList['pay_params']['alipay_trade_create_response']=(array)$resultTradeCreate->alipay_trade_create_response;*/
	$dataList = tt_prepay($wid, $openid, $money, Conf::$http_path_api."Payment/Ttpay/tcNotify-".$wid.".html", $OrderNo, $name_str);

	//file_put_contents(DOXCX_FRAME_PATH.'/log/info/'.date('Y_m_d',time()).'.log', date('H:i:s',time()).': '.$dataList."\n",FILE_APPEND);
  $msg->is_pay = 0;

} else {
  $msg->is_pay = 1;
}

$msg->total_price = $total_price;
$msg->wid = $wid;
$msg->openid = $openid;
$msg->cate_id = $req['cate_id'];
$msg->content = $req['content'];
$msg->img = json_encode($req['img']);
$msg->lat = $req['lat'];
$msg->lng = $req['lng'];
$msg->address = $req['address'];
$msg->ctime = date('Y-m-d H:i:s');

if ($flag_discount_free_num) {
  // 扣除一次免费发布次数
  $user->free_num -= 1;
  $user->save();
}
$msg->save();

$arr = array(
    'status'=>'success',
    'errmsg'=>'ok',
    'data'=>$dataList
);
echo json_encode($arr);