<?php
/**
 * 我的优惠券列表
*/
header("Content-Type: text/html; charset=UTF-8");
//加载核心文件
require_once(DOXCX_FRAME_PATH.'fun/AES.php');
//get post data, May be due to the different environments
$postStr = file_get_contents("php://input");
$data = json_decode($postStr);//获取数据

//实例化类
$aes = new aes();

if(!$data->data){//加密数据
    $arr = array('errcode'=>1,'errmsg'=>'缺少参数');
}else{

    //AES解密数据
    $json_data = $aes->aes128cbcHexDecrypt($data->data);
    //解析json数据
    $result = json_decode($json_data);

    if(!$result->wid){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：wid');
    }elseif (!$result->openId){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：openId');
    }elseif (!$result->PageIndex){
        $arr = array('errcode'=>1,'errmsg'=>'缺少参数：PageIndex');
    }else{

        //商户id
        $wid = $result->wid;

        /********************数据处理********************/
        $openid = $result->openId;
        $pageIndex = $result->PageIndex;
        $pageSize = 10;
        $Status = $result->Status;

        //搜索条件
        $where['wid'] = $wid;
        $where['wxid'] = $openid;
        if($Status == 0){//未使用
            $where['isuse'] = 0;
            $where['daytime@>'] = date('Y-m-d H:i:s');//有效期大于当前时间
        }elseif($Status == 1){//已使用
            $where['isuse'] = 1;
        }elseif($Status == 2){//已过期
            $where['isuse'] = 0;
            $where['daytime@<'] = date('Y-m-d H:i:s');//有效期小于当前时间
        }

        //条数
        $lim = 	$pageSize*($pageIndex-1).','.$pageSize;

        //排序
        $order = 'id DESC';

        //获取订单列表
        $m = new Model('vshop_mycouponlist');
        $res = $m->where($where)->limit($lim)->order($order)->list_all();
        $MyCoupons = array();
        $i = 0;
        foreach($res as $_v){
            if($_v->type == 1){
                $DiscountMoney = $_v->money;
                $MoneyLimitDesc = $_v->all?'全店通用':'部分商品可用';
            }else{
                $DiscountMoney = $_v->dmoney;
                $MoneyLimitDesc = '满'.$_v->xemoney.'元可用';
            }
            $MyCoupons[$i]['id'] = $_v->id;//id
            $MyCoupons[$i]['all'] = $_v->all;//
            $MyCoupons[$i]['Name'] = $_v->name;//名称
            $MyCoupons[$i]['DiscountMoney'] = $DiscountMoney;//金额
            $MyCoupons[$i]['MoneyLimitDesc'] = $MoneyLimitDesc;//说明
            $MyCoupons[$i]['StrValidateStart'] = date('Y-m-d',strtotime($_v->ctime));//开始时间
            $MyCoupons[$i]['StrValidateEnd'] = date('Y-m-d',strtotime($_v->daytime));//结束时间
            $MyCoupons[$i]['CouponUserDesc'] = $_v->ms;//使用规则
            $i++;
        }

        //未使用数
        $m1 = new Model('vshop_mycouponlist');
        $UnUseTotal = $m1->field('id')->where(array('wid'=>$wid,'wxid'=>$openid,'isuse'=>0,'daytime@>'=>date('Y-m-d H:i:s')))->count();

        //已使用数
        $m2 = new Model('vshop_mycouponlist');
        $UsedTotal = $m2->field('id')->where(array('wid'=>$wid,'wxid'=>$openid,'isuse'=>1))->count();

        //过期数
        $m3 = new Model('vshop_mycouponlist');
        $OutTimeTotal = $m3->field('id')->where(array('wid'=>$wid,'wxid'=>$openid,'isuse'=>0,'daytime@<'=>date('Y-m-d H:i:s')))->count();

        $dataList = array(
            'UnUseTotal'=>$UnUseTotal,//未使用数
            'UsedTotal'=>$UsedTotal,//已使用数
            'OutTimeTotal'=>$OutTimeTotal,//过期数
            'MyCoupons'=>$MyCoupons
        );
        /********************数据处理********************/

        //返回数据
        $arr = array(
            'errcode' => 0,
            'errmsg' => 'ok',
            'dataList' => $dataList
        );
    }
}

//加密处理
$HexData = $aes->aes128cbcEncrypt(json_encode($arr));
$data = array('d'=>$HexData);
echo json_encode($data);
exit;

?>