<?php
Page::$need_view = false;
header('Content-Type:application/json');
$req = getPayloadParams();
if (!(arr_get($req, 'openid') && arr_get($req, 'wid'))) {
    sendResponse(['status' => 'error', 'msg' => '参数错误'], true);
}

$vip = (new Model('vip_card'))->find(['wid' => $req['wid'], 'openid' => $req['openid']]);
$setting = (new Model('vip_setting'))->find(['wid' => $req['wid']]);
if ($vip->id) {
    if ($req['type'] == 'normal') {
        // ------------------------普通商品--------------------------
        $order = (new Model('vshop_order'))->find(['id' => $req['orderid'], 'wid' => $req['wid'], 'wxid' => $req['openid']]);
        if (!$order->id) {
            sendResponse(['status' => 'error', 'msg' => '订单不存在'], true);
        } else {
            $total_money = $order->payAmount;
        }
        // 减少库存
        $items = json_decode($order->items);


        // 检查一遍库存
        $pros = [];
        foreach ($items as $k => $_ite) {

            $pro = (new Model('vshop_product'))->find($_ite->ProductId);

            if ($pro->id) {
                $pros[$k] = $pro;
                $store_nums = intval($pro->store_nums) - intval($_ite->Count);
                if ($store_nums <= 0) {
                    sendError('商品库存不足');
                }
                $sale_nums = intval($pro->sale_nums) + intval($_ite->Count);//增加销量
                $rowtemp = json_decode($pro->rowtemp, true);

                foreach ($rowtemp as $_k => $_v) {
                    if ($_v['goods_no'] == $_ite->goods_no) {
                        $num = intval($_v['store_nums']) - intval($_ite->Count);
                        if ($num <= 0) {//rowtemp
                            sendError('商品库存不足');
                        }
                    }
                }
            } else {
                sendError('商品不存在');
            }
        }

        /*foreach ($items as $k => $_ite) {
          $pro = $pros[$k];
          $store_nums = intval($pro->store_nums) - intval($_ite->Count);
          if ($store_nums <= 0) {
            $store_nums = 0;
          }
          $sale_nums = intval($pro->sale_nums) + intval($_ite->Count);//增加销量
          $rowtemp = json_decode($pro->rowtemp, true);
          foreach ($rowtemp as $_k => $_v) {
            if ($_v['goods_no'] == $_ite->goods_no) {
              $num = intval($_v['store_nums']) - intval($_ite->Count);
              $rowtemp[$_k]['store_nums'] = strval($num);
            }
          }
          $pro->update(['id' => $pro->id], ['store_nums' => $store_nums, 'sale_nums' => $sale_nums, 'rowtemp' => $rowtemp]);
        }*/
        // 计算折扣
        $level = get_vip_level($setting->vip_level, $vip->total_point);
        $vip_discount = $total_money * $level['discount'] / 100;
        // 计算积分抵扣
        if ($setting->point_to_money_open) {  // 开启了积分抵扣
            $all2money = $vip->point / $setting->point_to_money;  // 所有积分可以抵扣多少元
            if ($all2money >= $total_money - $vip_discount) {
                $point_discount = $total_money - $vip_discount;
            } else {
                $point_discount = $all2money;
            }
            $consume_point = $point_discount * $setting->point_to_money;
        } else {
            $point_discount = 0;
        }
        $new_count = $total_money - $vip_discount - $point_discount;
        if ($req['pay'] == 0) {
            $vipInfo = $vip->get_model_array();
            $vipInfo['isset_passwd'] = $vipInfo['passwd'] !== null ? 1 : 0;
            unset($vipInfo['passwd']);
            sendResponse(['status' => 'success', 'dataList' => [
                'old_count' => $total_money,
                'vip_discount' => $vip_discount,
                'point_discount' => $point_discount,
                'new_count' => $new_count,
            ], 'vipInfo' => $vipInfo, 'vipSetting' => $setting->get_model_array(), 'isVip' => 1], true);
        } else {
            // 进行余额支付
            // 密码验证
            if ($vip->passwd != arr_get($req, 'passwd')) {
                sendResponse(['status' => 'error', 'msg' => '密码错误'], true);
            }
            // 支付
            if ($vip->balance < $new_count) {
                sendResponse(['status' => 'error', 'msg' => '余额不足'], true);
            }
            $vip->balance = $vip->balance - $new_count;
            $vip->point = $vip->point - $consume_point;
            $vip->save();
            // 订单标记为已支付
            $order->PayStatus = 1;//已支付
            $order->is_vip_pay = 1;//使用了vip支付
            $order->vip_discount = $vip_discount;//vip折扣的金额
            $order->point_discount = $point_discount;//积分抵扣金额
            $order->consume_point = $consume_point;//消耗的积分
            $order->vip_pay_money = $new_count;//vip支付金额
            $rs=$order->save();

            if ($rs->id && $rs->sid) {
                //佣金
                getTypes($rs);
            }

            /**减少库存**/
            foreach ($items as $k => $_ite) {
                $pro = $pros[$k];
                $store_nums = intval($pro->store_nums) - intval($_ite->Count);
                if ($store_nums <= 0) {
                    $store_nums = 0;
                }
                $sale_nums = intval($pro->sale_nums) + intval($_ite->Count);//增加销量
                /**$rowtemp = json_decode($pro->rowtemp, true);
                foreach ($rowtemp as $_k => $_v) {
                    if ($_v['goods_no'] == $_ite->goods_no) {
                        $num = intval($_v['store_nums']) - intval($_ite->Count);
                        $rowtemp[$_k]['store_nums'] = strval($num);
                    }
                }*/
				$rowtemp = getRowtemp($_ite->ProductId, $_ite->goods_no, $_ite->Count);//减少属性里面库存
                $pro->update(['id' => $pro->id], ['store_nums' => $store_nums, 'sale_nums' => $sale_nums, 'rowtemp' => $rowtemp]);
            }

            // 打印小票
            try {
                print_shop_order($order->id);
            } catch (Exception $e) {
            }
            // 返积分
            $fullNum = intval($new_count / $setting->consume_count);//满足几次返积分
            $returnPoint = $setting->consume_point * $fullNum;//满足x次返积分*返积分数
            $vip->point = $vip->point + $returnPoint;
            $vip->total_point = $vip->total_point + $returnPoint;
            $vip->total_consume = $vip->total_consume + $new_count;
            $vip->save();
            //支付成功发送短信
          	try{
        		  $cfg=(new Model('vshop_order_task'))->find(['wid'=>$req['wid']]);
        		  $pub=(new Model('pubs'))->find(['id'=>$req['wid']]);
        		  if($cfg->id && $cfg->is_sms_notify==1){
          		  unified_send_sms($pub->uid, $cfg->sms_notify_phone, '【有用户下单啦，快去看看吧】'.'订单号：'.$order->OrderNo.'；订单金额：'.$new_count,'template_shop_ok',["orderNo" =>$order->OrderNo,"money"=>$new_count]);
         			 }
       		   }catch (Exception $e){}
            //支付成功模板消息
            $tpl = arr_get(json_decode($setting->tpl_msg, true), 'tplmsg_pay');
            $tplMsg = sendTplMsg_vip_pay_success($req['wid'], $tpl, $req['openid'], $order->OrderNo, $total_money, $new_count, $vip_discount, $point_discount, $vip->balance, $returnPoint, $vip->point);
            sendResponse(['status' => 'success', 'msg' => '支付成功，付款￥' . $new_count . '元，获得积分' . $returnPoint, 'tplMsg' => $tplMsg], true);
        }
        // ------------------------拼团-----------------------------
    } else
        if ($req['type'] == 'group') {
            $order = (new Model('vshop_product_groupbuy_order'))->find(['id' => $req['orderid'], 'wid' => $req['wid']]);
            if (!$order->id) {
                sendResponse(['status' => 'error', 'msg' => '订单不存在'], true);
            } else {
                $total_money = $order->total_price;
            }
            // 计算折扣
            $level = get_vip_level($setting->vip_level, $vip->total_point);
            $vip_discount = $total_money * $level['discount'] / 100;
            // 计算积分抵扣
            if ($setting->point_to_money_open) {  // 开启了积分抵扣
                $all2money = $vip->point / $setting->point_to_money;  // 所有积分可以抵扣多少元
                if ($all2money >= $total_money - $vip_discount) {
                    $point_discount = $total_money - $vip_discount;
                } else {
                    $point_discount = $all2money;
                }
                $consume_point = $point_discount * $setting->point_to_money;
            } else {
                $point_discount = 0;
            }
            $new_count = $total_money - $vip_discount - $point_discount;
            if ($req['pay'] == 0) {
                $vipInfo = $vip->get_model_array();
                $vipInfo['isset_passwd'] = $vipInfo['passwd'] !== null ? 1 : 0;
                unset($vipInfo['passwd']);
                sendResponse(['status' => 'success', 'dataList' => [
                    'old_count' => $total_money,
                    'vip_discount' => $vip_discount,
                    'point_discount' => $point_discount,
                    'new_count' => $new_count,
                ], 'vipInfo' => $vipInfo, 'vipSetting' => $setting->get_model_array(), 'isVip' => 1], true);
            } else {
                // 进行余额支付
                // 密码验证
                if ($vip->passwd != arr_get($req, 'passwd')) {
                    sendResponse(['status' => 'error', 'msg' => '密码错误'], true);
                }
                // 支付
                if ($vip->balance < $new_count) {
                    sendResponse(['status' => 'error', 'msg' => '余额不足'], true);
                }
                $vip->balance = $vip->balance - $new_count;
                $vip->point = $vip->point - $consume_point;
                $vip->save();
                // 更新订单
                if ($order->is_group) {
                    $order->group_id = $order->pre_group_id;
                }
                $order->is_pay = 1;
                $order->pay_time = time();
                $order->is_vip_pay = 1;//使用了vip支付
                $order->vip_discount = $vip_discount;//vip折扣的金额
                $order->point_discount = $point_discount;//积分抵扣金额
                $order->consume_point = $consume_point;//消耗的积分
                $order->vip_pay_money = $new_count;//vip支付金额
                $order->save();
                //找到团，更新人数
                if ($order->is_group) {
                    $group = (new Model('vshop_product_groupbuy_group'))->where(['id' => $order->group_id])->find();
                    $group->curr_num = $group->curr_num + 1;
                    $group->save();
                }
                // 返积分
                $fullNum = intval($new_count / $setting->consume_count);//满足几次返积分
                $returnPoint = $setting->consume_point * $fullNum;//满足x次返积分*返积分数
                $vip->point = $vip->point + $returnPoint;
                $vip->total_point = $vip->total_point + $returnPoint;
                $vip->total_consume = $vip->total_consume + $new_count;
                $vip->save();
                $tpl = arr_get(json_decode($setting->tpl_msg, true), 'tplmsg_pay');
                $tplMsg = sendTplMsg_vip_pay_success($req['wid'], $tpl, $req['openid'], $order->OrderNo, $total_money, $new_count, $vip_discount, $point_discount, $vip->balance, $returnPoint, $vip->point);
                sendResponse(['status' => 'success', 'msg' => '支付成功，付款￥' . $new_count . '元，获得积分' . $returnPoint, 'tplMsg' => $tplMsg], true);
            }
            // ---------------------秒杀---------------------------------
        } else
            if ($req['type'] == 'seckill') {
                //商品秒杀
                $order = (new Model('vshop_product_seckill_order'))->find(['id' => $req['orderid'], 'wid' => $req['wid']]);
                if (!$order->id) {
                    sendResponse(['status' => 'error', 'msg' => '订单不存在'], true);
                } else {
                    $total_money = $order->total_price;
                }
                // 计算折扣
                $level = get_vip_level($setting->vip_level, $vip->total_point);
                $vip_discount = $total_money * $level['discount'] / 100;
                // 计算积分抵扣
                if ($setting->point_to_money_open) {  // 开启了积分抵扣
                    $all2money = $vip->point / $setting->point_to_money;  // 所有积分可以抵扣多少元
                    if ($all2money >= $total_money - $vip_discount) {
                        $point_discount = $total_money - $vip_discount;
                    } else {
                        $point_discount = $all2money;
                    }
                    $consume_point = $point_discount * $setting->point_to_money;
                } else {
                    $point_discount = 0;
                }
                $new_count = $total_money - $vip_discount - $point_discount;
                if ($req['pay'] == 0) {
                    $vipInfo = $vip->get_model_array();
                    $vipInfo['isset_passwd'] = $vipInfo['passwd'] !== null ? 1 : 0;
                    unset($vipInfo['passwd']);
                    sendResponse(['status' => 'success', 'dataList' => [
                        'old_count' => $total_money,
                        'vip_discount' => $vip_discount,
                        'point_discount' => $point_discount,
                        'new_count' => $new_count,
                    ], 'vipInfo' => $vipInfo, 'vipSetting' => $setting->get_model_array(), 'isVip' => 1], true);
                } else {
                    // 进行余额支付
                    // 密码验证
                    if ($vip->passwd != arr_get($req, 'passwd')) {
                        sendResponse(['status' => 'error', 'msg' => '密码错误'], true);
                    }
                    // 支付
                    if ($vip->balance < $new_count) {
                        sendResponse(['status' => 'error', 'msg' => '余额不足'], true);
                    }
                    $vip->balance = $vip->balance - $new_count;
                    $vip->point = $vip->point - $consume_point;
                    $vip->save();
                    // 更新订单
                    $order->is_pay = 1;
                    $order->pay_time = time();
                    $order->is_vip_pay = 1;//使用了vip支付
                    $order->vip_discount = $vip_discount;//vip折扣的金额
                    $order->point_discount = $point_discount;//积分抵扣金额
                    $order->consume_point = $consume_point;//消耗的积分
                    $order->vip_pay_money = $new_count;//vip支付金额
                    $order->save();
                    // 返积分
                    $fullNum = intval($new_count / $setting->consume_count);//满足几次返积分
                    $returnPoint = $setting->consume_point * $fullNum;//满足x次返积分*返积分数
                    $vip->point = $vip->point + $returnPoint;
                    $vip->total_point = $vip->total_point + $returnPoint;
                    $vip->total_consume = $vip->total_consume + $new_count;
                    $vip->save();
                    $tpl = arr_get(json_decode($setting->tpl_msg, true), 'tplmsg_pay');
                    $tplMsg = sendTplMsg_vip_pay_success($req['wid'], $tpl, $req['openid'], $order->OrderNo, $total_money, $new_count, $vip_discount, $point_discount, $vip->balance, $returnPoint, $vip->point);
                    sendResponse(['status' => 'success', 'msg' => '支付成功，付款￥' . $new_count . '元，获得积分' . $returnPoint, 'tplMsg' => $tplMsg], true);
                }
            }else if($req['type'] == 'zhct'){
                $shops = (new Model('zhct_setting'))->find(['wid' => $req['wid']]);
                $order = (new Model('zhct_order'))->where(['id' => $req['orderid']])->find();
                if (!$order->id) {
                    sendResponse(['status' => 'error', 'msg' => '订单不存在'], true);
                } else {
                    $total_money = $order->total_price;
                }
                // 计算折扣
                $level = get_vip_level($setting->vip_level, $vip->total_point);
                $vip_discount = $total_money * $level['discount'] / 100;
                // 计算积分抵扣
                if ($setting->point_to_money_open) {  // 开启了积分抵扣
                    $all2money = $vip->point / $setting->point_to_money;  // 所有积分可以抵扣多少元
                    if ($all2money >= $total_money - $vip_discount) {
                        $point_discount = $total_money - $vip_discount;
                    } else {
                        $point_discount = $all2money;
                    }
                    $consume_point = $point_discount * $setting->point_to_money;
                } else {
                    $point_discount = 0;
                }
                $new_count = $total_money - $vip_discount - $point_discount;
                if ($req['pay'] == 0) {
                    $vipInfo = $vip->get_model_array();
                    $vipInfo['isset_passwd'] = $vipInfo['passwd']!==null ? 1 : 0;
                    unset($vipInfo['passwd']);
                    sendResponse(['status' => 'success', 'dataList' => [
                        'old_count' => $total_money,
                        'vip_discount' => $vip_discount,
                        'point_discount' => $point_discount,
                        'new_count' => $new_count,
                    ], 'vipInfo' => $vipInfo, 'vipSetting' => $setting->get_model_array(), 'isVip' => 1], true);
                } else {
                    // 进行余额支付
                    // 密码验证
                    if ($vip->passwd != arr_get($req, 'passwd')) {
                        sendResponse(['status' => 'error', 'msg' => '密码错误'], true);
                    }
                    // 支付
                    if ($vip->balance < $new_count) {
                        sendResponse(['status' => 'error', 'msg' => '余额不足'], true);
                    }
                    $vip->balance = $vip->balance - $new_count;
                    $vip->point = $vip->point - $consume_point;
                    $vip->save();
                    // 订单标记为已支付
                    $order->is_pay = 1;//已支付
                    $order->pay_time = date('Y-m-d H:i:s');
                    /**
                    $order->is_vip_pay = 1;//使用了vip支付
                    $order->vip_discount = $vip_discount;//vip折扣的金额
                    $order->point_discount = $point_discount;//积分抵扣金额
                    $order->consume_point = $consume_point;//消耗的积分
                    $order->vip_pay_money = $new_count;//vip支付金额
                     */
                    $order->save();
                    // 返积分
                    $fullNum = intval($new_count / $setting->consume_count);//满足几次返积分
                    $returnPoint = $setting->consume_point * $fullNum;//满足x次返积分*返积分数
                    $vip->point = $vip->point + $returnPoint;
                    $vip->total_point = $vip->total_point + $returnPoint;
                    $vip->total_consume=$vip->total_consume+$new_count;
                    $vip->save();
                    // 发送模板消息
                    if ($shops->template_id) {
                        try {
                            sendTplMsg_zhct_order_pay_success($req['wid'], $shops->template_id, $req['openid'], $order->form_id, $new_count, $order->ctime, $order->pay_time, $order->order_no, $order->type == 0 ? '点餐' : '外卖', $order->remark ? $order->remark : '无');
                        } catch (Exception $e) {
                            diy_log(['智慧餐厅模板消息失败', $e]);
                        }
                    }
                    // 小票打印机
                    try {
                        print_zhct_order($order->id);
                    } catch (Exception $e) {
                        diy_log(['智慧餐厅订单打印失败', $e]);
                    }
                    // 短信通知
                    try {
                        if ($shops->tel) {
                            $pub = (new Model('pubs'))->find(['id' => $req['wid']]);
                            unified_send_sms($pub->uid, $shops->tel, '有用户下单了，快' . ($order->type == 0 ? '上菜' : '配送') . '吧！单号' . $order->order_no,'template_zhct_ok',["type" =>($order->type == 0 ? '上菜' : '配送'),"orderNo"=>$order->order_no]);
                        }
                    } catch (Exception $e) {
                        diy_log(['智慧餐厅短信发送失败', $e]);
                    }
                    if($order->type==0){
                        $table=(new Model('zhct_table'))->find(['wid'=>$req['wid'],'id'=>$order->table_id]);
                        $table->status=3;
                        $table->save();
                    }
                    sendResponse(['status' => 'success', 'msg' => '支付成功，付款￥' . $new_count . '元，获得积分' . $returnPoint], true);
                }
            }
} else {
    sendResponse(['status' => 'error', 'isVip' => 0, 'vipSetting' => $setting->get_model_array()], true);
}

  //重置商品属性
function getRowtemp($id, $goods_no, $Count)
  {
    $arr = [];
    $pro = new Model('vshop_product');
    $pro->field('id,rowtemp')->find($id);
    if ($pro->has_id()) {
      $rowtemp = json_decode($pro->rowtemp);
      $i = 0;
      foreach ($rowtemp as $_v) {
        $arr[$i]['goods_no'] = $_v->goods_no;
        $arr[$i]['spec_array'] = $_v->spec_array;
        if ($_v->store_nums <= 0) {
          $_v->store_nums = 0;
        }
        if ($_v->goods_no == $goods_no) {
          $num = intval($_v->store_nums) - intval($Count);
          if ($num <= 0) {
            $num = 0;
          }
          $arr[$i]['store_nums'] = strval($num);
        } else {
          $arr[$i]['store_nums'] = strval($_v->store_nums);
        }
        $arr[$i]['market_price'] = $_v->market_price;
        $arr[$i]['sell_price'] = $_v->sell_price;
        $arr[$i]['cost_price'] = $_v->cost_price;
        $arr[$i]['weight'] = $_v->weight;
        $i++;
      }
    }
    $arra = json_encode($arr);
    return $arra;
  }

function getTypes($order)
{
    $setting = (new Model('vshop_vagent_setting'))->where(['wid' => $order->wid])->find();
    $me = (new Model('vshop_member'))->where(['wxid' => $order->wxid])->find();//下单的用户
    $pm = (new Model('vshop_member'))->where(['id' => $me->pid])->find();//上级用户
    if ($pm->id) {
        //上级返利
        $level1_add = floor($order->payAmount * $setting->level1) / 100;
        $pm->money = $pm->money + $level1_add;
        $pm->unextract_money = $pm->unextract_money + $level1_add;
        $pm->save();
        $blog1 = new Model('vshop_brokerage');
        $blog1->wid = $order->wid;
        $blog1->wxid = $me->wxid;
        $blog1->orderid = $order->id;
        $blog1->sid = $pm->id;
        $blog1->level = 1;
        $blog1->ctime = date('Y-m-d H:i:s');
        $blog1->money = $level1_add;
        $blog1->status = 1;
        $blog1->type = 2;//收入
        $blog1->save();
        $ppm = (new Model('vshop_member'))->where(['id' => $pm->pid])->find();//上上级用户
        if ($ppm->id) {
            // 上上级返利
            $level2_add = floor($order->payAmount * $setting->level2) / 100;
            $ppm->money = $ppm->money + $level2_add;
            $ppm->unextract_money = $ppm->unextract_money + $level2_add;
            $ppm->save();
            $blog2 = new Model('vshop_brokerage');
            $blog2->wid = $order->wid;
            $blog2->wxid = $me->wxid;
            $blog2->orderid = $order->id;
            $blog2->sid = $ppm->id;
            $blog2->level = 2;
            $blog2->type = 2;//收入
            $blog2->ctime = date('Y-m-d H:i:s');
            $blog2->money = $level2_add;
            $blog2->status = 1;
            $blog2->save();
        }
    }
}
