<?php
function rad($d) {
  return $d * 3.14159 / 180.0;//经纬度转换成三角函数中度分表形式。
}

function geoDistance($lat1, $lng1, $lat2, $lng2) {
  $radLat1 = rad($lat1);
  $radLat2 = rad($lat2);
  $a = $radLat1 - $radLat2;
  $b = rad($lng1) - rad($lng2);
  $s = 2 * asin(sqrt(pow(sin($a / 2), 2) + cos($radLat1) * cos($radLat2) * pow(sin($b / 2), 2)));
  $s = $s * 6378.137;// EARTH_RADIUS;
  $s = round($s * 10000) / 10000; //输出为公里
  return $s;
}

setApi();
$req = getPayloadParams();
$wid = $req['wid'];
$openid = $req['openid'];
$type = $req['type'];
if (!$wid || !$openid) sendError('参数错误');
$setting = (new Model('zhct_setting'))->find(['wid' => $wid]);
$order = new Model('zhct_order');
$order->wid = $wid;
$order->openid = $openid;
$order->ctime = date('Y-m-d H:i:s');
$order->remark = $req['remark'];
$order->form_id = $req['form_id'];
$cart = $req['cart'];
$order->cart = json_encode($cart);
// 计算购物车金额
$total_price = 0;
$cart_price = 0;
$pkg_price = 0;
foreach ($cart as $k => $c) {
  $cart_price += $c['sp']['price'] * $c['num'];
  $pkg_price += $c['prod']['pkg_price'] * $c['num'];
}
$order->cart_price = $cart_price;
$total_price += $cart_price;
if ($type == 0) {
  // 点餐
  $table = (new Model('zhct_table'))->find(['wid' => $wid, 'id' => $req['tableId']]);
  if (!$table->id) sendError('您选择的桌台无效，请重新扫码选择桌台');
  $order->type = 0;
  $order->table_id = $table->id;
} else if ($type == 1) {
  // 外卖
  if (!$req['address']) sendError('请选择收货地址');
  $order->type = 1;
  $order->address = json_encode($req['address']);
  $order->lat = $req['lat'];
  $order->lng = $req['lng'];
  $order->pkg_price = $pkg_price;
  $total_price += $pkg_price;
  $wm_price = $req['wm_price'];//配送费用
  $order->wm_price = $wm_price;
  $total_price += $wm_price;
}
// 检查首单立减
$checkFirst = (new Model('zhct_order'))->find(['wid' => $wid, 'openid' => $openid, 'is_pay' => 1]);
if ($setting->is_first_order_discount == 1 && !$checkFirst->id) {
  $order->is_first = 1;
  $order->first_discount = $setting->first_order_discount;
  $total_price -= $setting->first_order_discount;
}
// 检查满减优惠 找到最大的优惠
$full = (new Model('zhct_youhui'))->where([
  'wid'         => $wid,
  'is_open'     => 1,
  'stime@<='    => time(),
  'etime@>='    => time(),
  'is_del'      => 0,
  'type'        => 1,
  'min_price@<' => $total_price,
])->order('full_discount desc')->find();
if ($full->id) {
  $order->is_full = 1;
  $order->full_id = $full->id;
  $order->full_discount = $full->full_discount;
  $total_price -= $full->full_discount;
}
// 验证优惠券
if ($req['coupon_id'] != 0) {
  $coupon = (new Model('zhct_usercoupon'))->find(['id' => $req['coupon_id'], 'wid' => $wid, 'openid' => $openid, 'etime@>' => time(), 'is_used' => 0]);
  $coupon_arr = $coupon->get_model_array();
  $coupon_arr['coupon'] = json_decode($coupon_arr['coupon'], true);
  if (!$coupon_arr['id'] || $coupon_arr['coupon']['min_price'] > $total_price) sendError('您选择的优惠券无效');
  $order->is_coupon = 1;
  $order->coupon_id = $coupon_arr['id'];
  $order->coupon_discount = $coupon_arr['coupon']['coupon_discount'];
  $total_price -= $coupon_arr['coupon']['coupon_discount'];
  $coupon->is_used = 1;
}

if ($total_price <= 0) {
  // 商品数量判断
  $prodList = [];
  foreach ($cart as $k => $c) {
    $prod = (new Model('zhct_product'))->find(['wid' => $wid, 'id' => $c['prod']['id'], 'is_del' => 0, 'is_show' => 1]);
    if (!$prod->id) sendError('要购买的商品不存在，请重新下单');
    if ($prod->today != date('Y-m-d')) {
      // 更新商品数量
      $prod->num = $prod->day_num;
      $prod->today = date('Y-m-d');
      $prod->save();
    }
    if ($prod->num != -1 && $prod->num < $c['num']) sendError('您要购买的商品数量不足');
    $prodList[] = [
      'prod' => $prod,
      'num'  => $c['num']
    ];
  }
  // 然后减少购买的量
  foreach ($prodList as $item) {
    $p = $item['prod'];
    $n = $item['num'];
    if($p->num!=-1){
      $p->num = ($p->num-$n)<0?0:($p->num-$n);
      $p->save();
    }
  }
  $total_price = 0;
  $order->order_no = getRandomOrderNo();
  $order->total_price = $total_price;
  $order->is_pay = 1;
  $order->pay_time = date('Y-m-d H:i:s');
  if (isset($coupon)) {
    $coupon->save();
  }
  $order->save();
  if($order->type==0){
    $table=(new Model('zhct_table'))->find(['wid'=>$wid,'id'=>$order->table_id]);
    $table->status=3;
    $table->save();
  }
  //  模板消息
  if ($setting->template_id) {
    try {
      sendTplMsg_zhct_order_pay_success($wid, $setting->template_id, $openid, $order->form_id, $order->total_price, $order->ctime, $order->pay_time, $order->order_no, $type == 0 ? '点餐' : '外卖', $order->remark ? $order->remark : '无');
    } catch (Exception $e) {
      diy_log(['智慧餐厅订单模板消息失败', $e]);
    }
  }
  // 小票打印机
  try{
    print_zhct_order($order->id);
  }catch (Exception $e){
    diy_log(['智慧餐厅订单打印消息失败', $e]);
  }
  // 短信通知
  if($setting->tel){
    $pub=(new Model('pubs'))->find(['id'=>$wid]);
    unified_send_sms($pub->uid, $setting->tel, '有用户下单了，快'.($type==0?'上菜':'配送').'吧！单号'.$order->order_no,'template_zhct_ok',["type" =>($type==0?'上菜':'配送'),"orderNo"=>$order->order_no]);
  }
  sendSuccess('下单成功', ['need_pay' => false]);
} else {
  $order->is_pay = 0;
}
$order->total_price = $total_price;
$order_no = getRandomOrderNo();
$order->order_no = $order_no;
$respData = common_prepay($wid, $openid, $total_price, 'zhctNotify', $order_no, '智慧餐厅-' . ($type == 0 ? '点餐' : '外卖'), json_encode(['wid' => $wid]),$req);
if ($setting->template_id) {
   $respData['data']['tpl_ids']=[$setting->template_id];
}
if ($respData['status']=='error') {
  sendError($respData['msg']);
}
// 商品数量判断
$prodList = [];
foreach ($cart as $k => $c) {
  $prod = (new Model('zhct_product'))->find(['wid' => $wid, 'id' => $c['prod']['id'], 'is_del' => 0, 'is_show' => 1]);
  if (!$prod->id) sendError('要购买的商品不存在，请重新下单');
  if ($prod->today != date('Y-m-d')) {
    // 更新商品数量
    $prod->num = $prod->day_num;
    $prod->today = date('Y-m-d');
    $prod->save();
  }
  if ($prod->num != -1 && $prod->num < $c['num']) sendError('您要购买的商品数量不足');
  $prodList[] = [
    'prod' => $prod,
    'num'  => $c['num']
  ];
}
// 然后减少购买的量
foreach ($prodList as $item) {
  $p = $item['prod'];
  $n = $item['num'];
  if($p->num!=-1){
    $p->num = ($p->num-$n)<0?0:($p->num-$n);
    $p->save();
  }
}
if (isset($coupon)) {
  $coupon->save();
}
$order->save();
if($order->type==0){
  $table=(new Model('zhct_table'))->find(['wid'=>$wid,'id'=>$order->table_id]);
  $table->status=2;
  $table->save();
}
sendSuccess('OK', $respData['data']);
