<?php
Page::$need_view = false;
header('Content-Type:application/json');
require_once DOXCX_FRAME_PATH . "/fun/library/pclzip.lib.php";
$version = include(DOXCX_FRAME_PATH . '/pub/version.php');
$ver = $version['ver'];
$projectRoot = $_SERVER['DOCUMENT_ROOT'];
$updatehost = 'http://up8.doxcx.cn/update.php';

$updateInfoUrl = $updatehost . '?a=update&v=' . $ver . '&u=' . $_SERVER['HTTP_HOST'];
$updateInfo = curlGet($updateInfoUrl);//文件名|服务器返回信息
//如果是压缩包文件
diy_log(['now',$root,$version,$updateInfoUrl,$updateInfo]);
if (mb_strstr($updateInfo, 'zip')) {
  //下载
  $fileContentsUrl = $updatehost . '?a=down&f=' . $updateInfo;
  $updateFile = downloadFile(DOXCX_FRAME_PATH . '../', $updateInfo, file_get_contents($fileContentsUrl));
  //解压到项目根目录
  $zipFile = new PclZip($updateFile);
  if ($zipFile->extract(PCLZIP_OPT_PATH, '../../', PCLZIP_OPT_REPLACE_NEWER)) {
  }
  unlink($updateFile);
  //去项目根目录找update.sql文件，执行sql
  $sqlPath = DOXCX_FRAME_PATH . '../' . 'update.sql';
  if (file_exists($sqlPath)) {
    $sqlContent = file_get_contents($sqlPath);
    runSql($sqlContent);
  }
  unlink($sqlPath);
  //返回本次更新已完成的消息
  sendResponse(['status' => 'success', 'msg' => '更新包' . $updateInfo . '安装成功'], true);
}
//如果返回信息不是文件，而是提示语
if (mb_strstr('最新', $updateInfo)) {
  // 已经是最新版，结束更新进程
  sendResponse([
    'status' => 'success',
    'msg' => '已经更新到最新版',
    'end' => 1  //进度条设置到100
  ], true);
} else {
  //未知的错误，提示并结束更新进程
  sendResponse([
    'status' => 'error',
    'msg' => strip_tags($updateInfo),
  ], true);
}

function downloadFile($filePath, $fileName, $data)
{
  $fileFullPath = $filePath . '/' . $fileName;
  if (file_exists($fileFullPath)) {
    try {
      unlink($fileFullPath);
    } catch (Exception $e) {
    }
  }
  $f = fopen($filePath . '/' . $fileName, 'wb');
  fwrite($f, $data);
  fclose($f);
  return $fileFullPath;
}

function runSql($content)
{
  // error_reporting(0);
  //遍历执行sql语句
  $sqlArr=preg_split("/;[\r\n]+/", $content);
  foreach($sqlArr as $v){
    db_query($v);
  }
}
