<?php
function get_agent_openPlat(){
	$admin = get_user_agency();
	if($admin->bd_key){
		return $admin;
	}else{
		$agency = (new Model('user_agency'))->find(['un' => 'admin']);
		return $agency;
	}
}

function rebind() {
  Page::$need_view = false;
  //未绑定或重新绑定
  $admin = get_agent_openPlat();
  /**if ($admin->bd_key) {
    $clientId = $admin->bd_key;
  } else {
    $agency = (new Model('user_agency'))->find(['un' => 'admin']);
    $clientId = $agency->bd_key;
  }*/
  $pre_auth_code = get_pre_auth_code();
  $url = "https://smartprogram.baidu.com/mappconsole/tp/authorization?client_id=" . $admin->bd_key . "&redirect_uri=" . getHost() . "&pre\_auth\_code=" . $pre_auth_code;
  echo "<script>location.href='" . $url . "'</script>";
}

/**
 * Created by PhpStorm.
 * User: Jeffrey
 * Date: 2017/12/11
 * Time: 20:34
 */
function get_component_access_token() {
  $admin = get_agent_openPlat();
  $cat = (new Model('bd_component_access_token'))->find(['client_id' => $admin->bd_client_id]);
  if ($cat->id) {
    if (intval(strtotime($cat->create_time)) + 2160000 > time()) {
      //如果有未过期的ComponentAccessToken
      return $cat->component_access_token;
    }
    //存在却已过期就往下走
  } else {
    //不存在就先实例化一个
    $cat = new Model('bd_component_access_token');
    $cat->client_id = $admin->bd_client_id;
  }
  // 重新请求
  $ticket = (new Model('bd_component_verify_ticket'))->find(['client_id' => $admin->bd_client_id]);
  $body = HttpCurl::get("https://openapi.baidu.com/public/2.0/smartapp/auth/tp/token?client_id=" . $admin->bd_key . "&ticket=" . $ticket->component_verify_ticket, []);
  $resp_arr = json_decode($body, 1);
  if (array_key_exists('access_token', $resp_arr['data'])) {
    //请求component_access_token成功
    $cat->component_access_token = $resp_arr['data']['access_token'];
    $cat->create_time = date('Y-m-d H:i:s', time());
    $cat->save();
    return $cat->component_access_token;
  } else {
    diy_log($resp_arr);
    return false;
    // return 'xxx';
  }
}

function get_pre_auth_code() {
  $component_access_token = get_component_access_token();
  if (!$component_access_token) {
    return false;
  }
  $body = HttpCurl::get("https://openapi.baidu.com/rest/2.0/smartapp/tp/createpreauthcode?access_token=" . $component_access_token, []);
  $resp_arr = json_decode($body, 1);
  if (array_key_exists('pre_auth_code', $resp_arr['data'])) {
    //成功获取
    return $resp_arr['data']['pre_auth_code'];
  } else {
    diy_log($resp_arr);
    //获取失败
    return false;
  }
}

/**
 * 在用户授权之后的回调Url中，根据返回的临时auth_code，获取authorizer_access_token和authorizer_refresh_token并妥善保存
 * 或者直接获取最新的authorizer_access_token
 * authorizer_access_token过期的时候自动刷新一下
 * @param null $auth_code
 * @return bool
 */
function get_authorizer_access_token($auth_code = null) {
  //先查找当前登录的用户
  $wid = Session::get('wid');//当前登录的用户id
  $pub = (new Model('pubs'))->find(['id' => $wid]);
  //参数是否存在
  if (!$auth_code) {
    //直接获取存储的authorizer_access_token
    if (intval(strtotime($pub->bd_token_create_time)) + 3000 < time()) {
      //当前存储的令牌已经失效
      //发起令牌刷新请求
      //获取cat令牌
      $component_access_token = get_component_access_token();
      if (!$component_access_token) {
        return false;
      }
      //发起刷新请求
	  $body = HttpCurl::get("https://openapi.baidu.com/rest/2.0/oauth/token?access_token=" .  $component_access_token . "&refresh_token=" . $pub->bd_authorizer_refresh_token . "&grant_type=app_to_tp_refresh_token", []);
      $resp_arr = json_decode($body, 1);
      if (array_key_exists('access_token', $resp_arr)) {
        //成功获取
        diy_log($resp_arr);
        $pub->bd_authorizer_access_token = $resp_arr['access_token'];
        $pub->bd_authorizer_refresh_token = $resp_arr['refresh_token'];
        $pub->bd_token_create_time = date('Y-m-d H:i:s', time());
        $pub->save();
        return $pub->bd_authorizer_access_token;
      } else {
        diy_log($resp_arr);
        rebind();
        //获取失败
        return false;
      }
    }
    //未失效
    return $pub->bd_authorizer_access_token;
  }
  //第一次授权，回调url中使用
  $component_access_token = get_component_access_token();
  if (!$component_access_token) {
    return false;
  }
  $body = HttpCurl::get("https://openapi.baidu.com/rest/2.0/oauth/token?access_token=" . $component_access_token . "&code=" . $auth_code . "&grant_type=app_to_tp_authorization_code", []);
  $resp_arr = json_decode($body, 1);
  if (array_key_exists('access_token', $resp_arr)) {
    //成功获取
    $pub->bd_authorizer_access_token = $resp_arr['access_token'];//权限令牌
    $pub->bd_authorizer_refresh_token = $resp_arr['refresh_token'];//刷新令牌
    $pub->bd_token_create_time = date('Y-m-d H:i:s', time());//令牌创建时间
    $pub->save();
    return $pub->bd_authorizer_access_token;
  } else {
    diy_log($resp_arr);
    //获取失败
    return false;
  }

}


// 获取or设置用户的域名
function applet_domains($method, $requestdomain = '', $socketdomain = '', $uploaddomain = '', $downloaddomain = '') {
  if (!in_array($method, ['get', 'set'])) {
    diy_log(['设置域名出错,method错误']);
    return false;
  }
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  if ($method == 'get') {
    $data = [
	  "access_token" => $authorizer_access_token,
      "action"       => 'get',
    ];
  } else if ($method == 'set') {
    $data = [
	  "access_token"    => $authorizer_access_token,
      "action"          => 'set',
      "request_domain"  => $requestdomain,
      "socket_domain"   => $socketdomain,
      "download_domain" => $uploaddomain,
      "upload_domain"   => $downloaddomain,
    ];
  }
  $body = HttpCurl::post(
    "https://openapi.baidu.com/rest/2.0/smartapp/app/modifydomain",$data);
  $resp_arr = json_decode($body, 1);
  return $resp_arr;
}

function webview_domains($method, $webviewdomain = '') {
  if (!in_array($method, ['get', 'set'])) {
    diy_log(['设置webview域名出错,method错误']);
    return false;
  }
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  if ($method == 'get') {
    $data = [
	  "access_token" => $authorizer_access_token,
      "action"       => 'get',
    ];
  } else if ($method == 'set') {
    $data = [
	  "access_token"  => $authorizer_access_token,
      "action"        => 'set',
      "web_view_domain" => $webviewdomain,
    ];
  }
  //发起请求
  $body = HttpCurl::post(
    "https://openapi.baidu.com/rest/2.0/smartapp/app/modifywebviewdomain",$data);
  $resp_arr = json_decode($body, 1);
  return $resp_arr;
}

// 为授权的小程序帐号上传小程序代码
function wx_upload_code($template_id,$ver,$remark) {
  $configUrl = 'https://' . $_SERVER['HTTP_HOST'] . '/api/vshop/';
    $addonsUrl = "https://". $_SERVER['HTTP_HOST'] ."/Addons/";
  //查找当前登录的用户
  $wid = Session::get('wid');//当前登录的用户id
  //阿拉丁appkey
  $m = new Model('ald_set');
  $m->find(['wid' => $wid]);
  $appKey = $m->ald_appkey;
  //获取当前用户appid
  $bdpay = (new Model('bd_vshop_weixin_pay'))->find(['wid' => $wid]);
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  //发起请求
  $body = HttpCurl::post(
    "https://openapi.baidu.com/rest/2.0/smartapp/package/upload?access_token=" . $authorizer_access_token,
    [
      "template_id"  => $template_id?$template_id:get_template()['template_id'],
      "ext_json"     => json_encode([
	    'extEnable'=>true,
        'extAppid' => $bdpay->AppId,//授权方的appid
		'directCommit' => false,
        'ext'      => [
          'wid'        => $wid,//授权方在系统中的id(wid)
          'configUrl'  => $configUrl,
          'addonsUrl'=>$addonsUrl,
          'ald_config' => [
            'app_key'     => $appKey,
            'getLocation' => 0,
            'getUserinfo' => 0,
          ],
        ],
        // 'pages'    => $indexPage,
      ]),
      "user_version" => $ver,
      "user_desc"    => $remark,
    ]
  );
  $resp_arr = json_decode($body, 1);
  if ($resp_arr['errno'] == 0) {
    //成功设置
    return true;
  } else {
    //获取失败
    return false;
  }
}

//获取模板库列表最新模板
function get_template(){
	$component_access_token = get_component_access_token();//获取当前后台登陆着的用户的授权令牌
	$resp = HttpCurl::get("https://openapi.baidu.com/rest/2.0/smartapp/template/gettemplatelist?access_token=" . $component_access_token, []);
	$resp_arr = json_decode($resp, 1);
	if($resp_arr['errno'] == 0){
		foreach($resp_arr['data']['list'] as $arr){
			if($arr['create_time'] == max(array_column($resp_arr['data']['list'], 'create_time'))){
				$templateLast=$arr;
			}			
		}
		return $templateLast;
	}else{
		return false;
	}
}

//获取授权小程序预览包详情
function gettrial() {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::get("https://openapi.baidu.com/rest/2.0/smartapp/package/gettrial?access_token=" . $authorizer_access_token, []);
  $resp_arr = json_decode($resp, 1);
  if(array_key_exists('data', $resp_arr)){
	  return $resp_arr['data'];
  }else{
	  return false;
  }

}

// 获取体验小程序的体验二维码
function get_test_qrcode() {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $packageId=gettrial()['package_id'];
  $resp = HttpCurl::get("https://openapi.baidu.com/rest/2.0/smartapp/app/qrcode?access_token=" . $authorizer_access_token . '&package_id=' . $packageId, []);
  return base64_encode($resp);
}

//获取当前用户的小程序基本信息
function get_authorizer_info() {
  //先查找当前登录的用户
  $wid = Session::get('wid');//当前登录的用户id
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::get("https://openapi.baidu.com/rest/2.0/smartapp/app/info?access_token=" . $authorizer_access_token, []);
  $resp_arr = json_decode($resp, 1);
  // diy_log($resp_arr);
  if (array_key_exists('data', $resp_arr)) {
	$bdpay = (new Model('bd_vshop_weixin_pay'))->find(['wid' => $wid]);
    if (!$bdpay->id) {
      $bdpay = (new Model('bd_vshop_weixin_pay'));
      $bdpay->wid = $wid;
    }
    $bdpay->AppId = $resp_arr['data']['app_id'];//授权方appid
    $bdpay->save();
    //成功设置
    return $resp_arr;
  } else {
    //获取失败
    return false;
  }
}


//提交审核
function wx_submit_audit($content,$remark) {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $packageId=gettrial()['package_id'];
  $resp = HttpCurl::post(
    "https://openapi.baidu.com/rest/2.0/smartapp/package/submitaudit?access_token=" . $authorizer_access_token,
    [
	 "content"  => $content,
	 "package_id"  => $packageId,
	 "remark"  => $remark,
	]
  );
  $resp_arr = json_decode($resp, 1);
  $resp_arr['packageId']=$packageId;
  return $resp_arr;
}

/**
 * 发布已通过审核的代码
 */
function set_wx_release() {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  //$packageId=gettrial()['package_id'];
  $wid = Session::get('wid');
  $lastRecord = (new Model('bd_user_upload_code_record'))->order('id desc')->find(['wid' => $wid,'is_audit'=>6]);
  $packageId=$lastRecord->package_id;
  $resp = HttpCurl::post(
    "https://openapi.baidu.com/rest/2.0/smartapp/package/release?access_token=" . $authorizer_access_token,
    [
	 "package_id"  => $packageId,
	]
  );
  $resp_arr = json_decode($resp, 1);
  return $resp_arr;
}

//撤销审核
function undo_code_audit() {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $packageId=gettrial()['package_id'];
   $resp = HttpCurl::post(
    "https://openapi.baidu.com/rest/2.0/smartapp/package/withdraw?access_token=" . $authorizer_access_token,
    [
	 "package_id"  => $packageId,
	]
  );
  $resp_arr = json_decode($resp, 1);
  return $resp_arr;
}

//查询审核状态
function get_audit_status($item_id) {
  $item = (new Model('bd_user_upload_code_record'))->find(['id' => $item_id]);
  if ($item->id && $item->package_id) {
    $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
    $resp = HttpCurl::get("https://openapi.baidu.com/rest/2.0/smartapp/package/getdetail?access_token=".$authorizer_access_token."&package_id=".$item->package_id, []);
    $resp_arr = json_decode($resp, 1);
    if (0 == $resp_arr['errno']) {
      $item->is_audit = $resp_arr['data']['status'];
      $item->msg = $resp_arr['data']['msg'];
      $item->save();
    } else {
        $item->msg = '系统出错';
        $item->save();
    }
  }
}

// 缓存测试二维码
function saveQrcode() {
  $wid = Session::get('wid');
  try {
    try {
      // 创建二维码缓存目录
      mkdir('bdqrcode');
    } catch (Exception $e) {
    }
    //获取体验二维码
    $test_qrcode = base64_decode(get_test_qrcode());
    // 缓存二维码
    file_put_contents('bdqrcode/test_' . $wid . '.png', $test_qrcode);
  } catch (Exception $e) {
    diy_log($e);
    return false;
  }
  return true;
}
