<?php
function get_agent_openPlat(){
	$admin = get_user_agency();
	if($admin->app_id){
		return $admin;
	}else{
		$agency = (new Model('user_agency'))->find(['un' => 'admin']);
		return $agency;
	}
}


function rebind() {
  Page::$need_view = false;
  //未绑定或重新绑定
  $admin = get_agent_openPlat();
  /**if ($admin->app_id) {
    $appid = $admin->app_id;
  } else {
    $agency = (new Model('user_agency'))->find(['un' => 'admin']);
    $appid = $agency->app_id;
  }*/
  $pre_auth_code = get_pre_auth_code();
  $url = "https://mp.weixin.qq.com/cgi-bin/componentloginpage?component_appid=" . $admin->app_id . "&pre_auth_code=" . $pre_auth_code . "&redirect_uri=" . getHost() . "&auth_type=2";
  echo "<script>location.href='" . $url . "'</script>";
}

/**
 * Created by PhpStorm.
 * User: Jeffrey
 * Date: 2017/12/11
 * Time: 20:34
 */
function get_component_access_token() {
  $admin = get_agent_openPlat();
  $cat = (new Model('component_access_token'))->find(['app_id' => $admin->app_id]);
  if ($cat->id) {
    if (intval(strtotime($cat->create_time)) + 7000 > time()) {
      //如果有未过期的ComponentAccessToken
      return $cat->component_access_token;
    }
    //存在却已过期就往下走
  } else {
    //不存在就先实例化一个
    $cat = new Model('component_access_token');
    $cat->app_id = $admin->app_id;
  }
  // 重新请求
  $ticket = (new Model('component_verify_ticket'))->find(['app_id' => $admin->app_id]);
  $body = HttpCurl::post(
    "https://api.weixin.qq.com/cgi-bin/component/api_component_token",
    json_encode([
      "component_appid"         => $admin->app_id,
      "component_appsecret"     => $admin->app_secret,
      "component_verify_ticket" => $ticket->component_verify_ticket,
    ])
  );
  $resp_arr = json_decode($body, 1);
  if (array_key_exists('component_access_token', $resp_arr)) {
    //请求component_access_token成功
    $cat->component_access_token = $resp_arr['component_access_token'];
    $cat->create_time = date('Y-m-d H:i:s', time());
    $cat->save();
    return $cat->component_access_token;
  } else {
    diy_log($resp_arr);
    return false;
    // return 'xxx';
  }
}

function get_pre_auth_code() {
  $component_access_token = get_component_access_token();
  if (!$component_access_token) {
    return false;
  }
  $admin = get_agent_openPlat();
  $body = HttpCurl::post("https://api.weixin.qq.com/cgi-bin/component/api_create_preauthcode?component_access_token=" . $component_access_token,
    json_encode([
      "component_appid" => $admin->app_id,
    ])
  );
  $resp_arr = json_decode($body, 1);
  if (array_key_exists('pre_auth_code', $resp_arr)) {
    //成功获取
    return $resp_arr['pre_auth_code'];
  } else {
    diy_log($resp_arr);
    //获取失败
    return false;
  }
}

/**
 * 在用户授权之后的回调Url中，根据返回的临时auth_code，获取authorizer_access_token和authorizer_refresh_token并妥善保存
 * 或者直接获取最新的authorizer_access_token
 * authorizer_access_token过期的时候自动刷新一下
 * @param null $auth_code
 * @return bool
 */
function get_authorizer_access_token($auth_code = null) {
  //先查找当前登录的用户
  $wid = Session::get('wid');//当前登录的用户id
  $pub = (new Model('pubs'))->find(['id' => $wid]);
  //参数是否存在
  if (!$auth_code) {
    //直接获取存储的authorizer_access_token
    if (intval(strtotime($pub->token_create_time)) + 7000 < time()) {
      //当前存储的令牌已经失效
      //发起令牌刷新请求
      //获取cat令牌
      $component_access_token = get_component_access_token();
      if (!$component_access_token) {
        return false;
      }
      $admin = get_agent_openPlat();
      //发起刷新请求
      diy_log([
        "component_appid"          => $admin->app_id,
        "authorizer_appid"         => $pub->authorizer_appid,
        "authorizer_refresh_token" => $pub->authorizer_refresh_token,
      ]);
      $body = HttpCurl::post(
        "https://api.weixin.qq.com/cgi-bin/component/api_authorizer_token?component_access_token=" . $component_access_token,
        json_encode([
          "component_appid"          => $admin->app_id,
          "authorizer_appid"         => $pub->authorizer_appid,
          "authorizer_refresh_token" => $pub->authorizer_refresh_token,
        ])
      );
      $resp_arr = json_decode($body, 1);
      if (array_key_exists('authorizer_access_token', $resp_arr)) {
        //成功获取
        diy_log($resp_arr);
        $pub->authorizer_access_token = $resp_arr['authorizer_access_token'];
        $pub->authorizer_refresh_token = $resp_arr['authorizer_refresh_token'];
        $pub->token_create_time = date('Y-m-d H:i:s', time());
        $pub->save();
        return $pub->authorizer_access_token;
      } else {
        diy_log($resp_arr);
        rebind();
        //获取失败
        return false;
      }
    }
    //未失效
    return $pub->authorizer_access_token;
  }
  //第一次授权，回调url中使用
  $component_access_token = get_component_access_token();
  if (!$component_access_token) {
    return false;
  }
  $admin = get_agent_openPlat();
  $body = HttpCurl::post(
    "https://api.weixin.qq.com/cgi-bin/component/api_query_auth?component_access_token=" . $component_access_token,
    json_encode([
      "component_appid"    => $admin->app_id,
      "authorization_code" => $auth_code,
    ])
  );
  $resp_arr = json_decode($body, 1);
  if (array_key_exists('authorization_info', $resp_arr)) {
    //成功获取
    diy_log($resp_arr);
    $pub->authorizer_access_token = $resp_arr['authorization_info']['authorizer_access_token'];//权限令牌
    $pub->authorizer_refresh_token = $resp_arr['authorization_info']['authorizer_refresh_token'];//刷新令牌
    $pub->authorizer_appid = $resp_arr['authorization_info']['authorizer_appid'];//授权方appid
    $pub->token_create_time = date('Y-m-d H:i:s', time());//令牌创建时间
    $pub->save();
    $wxpay = (new Model('vshop_weixin_pay'))->find(['wid' => $wid]);
    if (!$wxpay->id) {
      $wxpay = (new Model('vshop_weixin_pay'));
      $wxpay->wid = $wid;
    }
    $wxpay->AppId = $resp_arr['authorization_info']['authorizer_appid'];//授权方appid
    $wxpay->save();
    return $pub->authorizer_access_token;
  } else {
    diy_log($resp_arr);
    //获取失败
    return false;
  }

}


// 获取or设置用户的域名
function applet_domains($method, $requestdomain = [], $wsrequestdomain = [], $uploaddomain = [], $downloaddomain = []) {
  if (!in_array($method, ['get', 'set'])) {
    diy_log(['设置域名出错,method错误']);
    return false;
  }
  if ($method == 'get') {
    $data = [
      "action" => 'get',
    ];
  } else if ($method == 'set') {
    $data = [
      "action"          => 'set',
      "requestdomain"   => $requestdomain,
      "wsrequestdomain" => $wsrequestdomain,
      "uploaddomain"    => $uploaddomain,
      "downloaddomain"  => $downloaddomain,
    ];
  }
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  //发起请求
  $body = HttpCurl::post(
    "https://api.weixin.qq.com/wxa/modify_domain?access_token=" . $authorizer_access_token,
    json_encode($data)
  );
  $resp_arr = json_decode($body, 1);
  diy_log([$method . '域名返回信息', $resp_arr]);
  return $resp_arr;
}

function webview_domains($method, $webviewdomain = []) {
  if (!in_array($method, ['get', 'set'])) {
    diy_log(['设置webview域名出错,method错误']);
    return false;
  }
  if ($method == 'get') {
    $data = [
      "action" => 'get',
    ];
  } else if ($method == 'set') {
    $data = [
      "action"        => 'set',
      "webviewdomain" => $webviewdomain,
    ];
  }
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  //发起请求
  $body = HttpCurl::post(
    "https://api.weixin.qq.com/wxa/setwebviewdomain?access_token=" . $authorizer_access_token,
    json_encode($data)
  );
  $resp_arr = json_decode($body, 1);
  diy_log([$method . 'webview域名返回信息', $resp_arr]);
  return $resp_arr;
}

// 绑定微信用户为小程序体验者
function bind_tester($wechatid) {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  //发起请求
  $body = HttpCurl::post(
    "https://api.weixin.qq.com/wxa/bind_tester?access_token=" . $authorizer_access_token,
    json_encode([
      "wechatid" => $wechatid,
    ])
  );
  $resp_arr = json_decode($body, 1);
  diy_log($resp_arr);
  if ($resp_arr['errcode'] == 0 || $resp_arr['errcode'] == 85004) {
    //成功设置
    return [
      true,
    ];
  } else {
    //获取失败
    $errMap = [
      '-1'    => '系统繁忙',
      '85001' => '微信号不存在或微信号设置为不可搜索',
      '85002' => '小程序绑定的体验者数量达到上限',
      '85003' => '微信号绑定的小程序体验者达到上限',
      '85004' => '微信号已经绑定',
    ];
    return [
      false,
      $errMap[$resp_arr['errcode']],
    ];
  }
}

// 解除绑定小程序的体验者
function unbind_tester($wechatid) {
  $wid = Session::get('wid');
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  //发起请求
  $body = HttpCurl::post(
    "https://api.weixin.qq.com/wxa/unbind_tester?access_token=" . $authorizer_access_token,
    json_encode([
      "wechatid" => $wechatid,
    ])
  );
  $resp_arr = json_decode($body, 1);
  diy_log($resp_arr);
  if ($resp_arr['errcode'] == 0) {
    //成功设置
    return true;
  } else {
    //获取失败
    return false;
  }
}

// 为授权的小程序帐号上传小程序代码
function wx_upload_code($template_id,$ver,$remark) {
  $configUrl = 'https://' . $_SERVER['HTTP_HOST'] . '/api/vshop/';
  $addonsUrl = "https://". $_SERVER['HTTP_HOST'] ."/Addons/";
  //查找当前登录的用户
  $wid = Session::get('wid');//当前登录的用户id
  //阿拉丁appkey
  $m = new Model('ald_set');
  $m->find(['wid' => $wid]);
  $appKey = $m->ald_appkey;
  //首页
  /**$index = new Model('vshop_index');
  $index->find(['wid' => $wid]);
  $indexPage = getIndexPage($index->page);*/
  //小程序appid
  $programList=(new Model('program_list'))->where(array('wid'=>$wid))->list_all_array();
  foreach($programList as $programlist){
	$appidList[]=$programlist['appid'];
  }
  $pub = (new Model('pubs'))->find(['id' => $wid]);
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  //发起请求
  $body = HttpCurl::post(
    "https://api.weixin.qq.com/wxa/commit?access_token=" . $authorizer_access_token,
    json_encode([
      "template_id"  => $template_id?$template_id:get_template()['template_id'],
      "ext_json"     => json_encode([
        'extAppid' => $pub->authorizer_appid,//授权方的appid
        'ext'      => [
          'wid'        => $wid,//授权方在系统中的id(wid)
          'configUrl'  => $configUrl,
          'addonsUrl'=> $addonsUrl,
          'ald_config' => [
            'app_key'     => $appKey,
            'getLocation' => 0,
            'getUserinfo' => 0,
          ],
        ],
        // 'pages'    => $indexPage,
        'navigateToMiniProgramAppIdList' => $appidList, 
      ]),
      "user_version" => $ver,
      "user_desc"    => $remark,
    ],JSON_UNESCAPED_UNICODE)
  );
  $resp_arr = json_decode($body, 1);
  diy_log($resp_arr);
  if ($resp_arr['errcode'] == 0) {
    //成功设置
    return true;
  } else {
    //获取失败
    return false;
  }
}

//获取模板库列表最新模板
function get_template(){
	$component_access_token = get_component_access_token();//获取当前后台登陆着的用户的授权令牌
	$resp = HttpCurl::get("https://api.weixin.qq.com/wxa/gettemplatelist?access_token=" . $component_access_token, []);
	$resp_arr = json_decode($resp, 1);
	if($resp_arr['errcode'] == 0){
		foreach($resp_arr['template_list'] as $arr){
			if($arr['create_time'] == max(array_column($resp_arr['template_list'], 'create_time'))){
				$templateLast=$arr;
			}			
		}
		return $templateLast;
	}else{
		return false;
	}
}

// 获取体验小程序的体验二维码
function get_test_qrcode() {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::get("https://api.weixin.qq.com/wxa/get_qrcode?access_token=" . $authorizer_access_token, []);
  return base64_encode($resp);
}

//获取当前用户的小程序基本信息
function get_authorizer_info() {
  //先查找当前登录的用户
  $wid = Session::get('wid');//当前登录的用户id
  $pub = (new Model('pubs'))->find(['id' => $wid]);
  $admin = get_agent_openPlat();//管理员（管理员配置）
  $component_access_token = get_component_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::post(
    "https://api.weixin.qq.com/cgi-bin/component/api_get_authorizer_info?component_access_token=" . $component_access_token,
    json_encode([
      "component_appid"  => $admin->app_id,
      "authorizer_appid" => $pub->authorizer_appid,
    ])
  );
  $resp_arr = json_decode($resp, 1);
  // diy_log($resp_arr);
  if (array_key_exists('authorizer_info', $resp_arr)) {
    //成功设置
    return $resp_arr;
  } else {
    //获取失败
    return false;
  }
}

//获取可选的类目
function get_wx_category() {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::get("https://api.weixin.qq.com/wxa/get_category?access_token=" . $authorizer_access_token, []);
  $resp_arr = json_decode($resp, 1);
  diy_log($resp_arr);
  if (0 == $resp_arr['errcode']) {
    return $resp_arr['category_list'];
  } else {
    return false;
  }
}

//获取小程序的页面
function get_wx_page() {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::get("https://api.weixin.qq.com/wxa/get_page?access_token=" . $authorizer_access_token, []);
  $resp_arr = json_decode($resp, 1);
  diy_log($resp_arr);
  if (0 == $resp_arr['errcode']) {
    return $resp_arr['page_list'];
  } else {
    return false;
  }
}

//提交审核
function wx_submit_audit($params) {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::post(
    "https://api.weixin.qq.com/wxa/submit_audit?access_token=" . $authorizer_access_token,
    json_encode($params, JSON_UNESCAPED_UNICODE)
  );
  $resp_arr = json_decode($resp, 1);
  diy_log('下面是提交审核之后的返回信息');
  diy_log($resp_arr);
  if (0 == $resp_arr['errcode']) {
    return $resp_arr;
  } else {
    $errMap = [
      '-1'    => '系统繁忙',
      '86000' => '不是由第三方代小程序进行调用',
      '86001' => '不存在第三方的已经提交的代码',
      '85006' => '标签格式错误',
      '85007' => '页面路径错误',
      '85008' => '类目填写错误',
      '85009' => '已经有正在审核的版本',
      '85010' => 'item_list有项目为空',
      '85011' => '标题填写错误',
      '85023' => '审核列表填写的项目数不在1-5以内',
      '85077' => '小程序类目信息失效（类目中含有官方下架的类目，请重新选择类目）',
      '86002' => '小程序还未设置昵称、头像、简介。请先设置完后再重新提交。',
    ];
    $resp_arr['diy_reason'] = $errMap[$resp_arr['errcode']];
    return $resp_arr;
  }
}

//查询最新一次提交的审核结果
function get_wx_auditstatus() {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::get("https://api.weixin.qq.com/wxa/get_latest_auditstatus?access_token=" . $authorizer_access_token, []);
  $resp_arr = json_decode($resp, 1);
  diy_log('下面是查询审核结果的返回信息');
  diy_log($resp_arr);
  if (0 == $resp_arr['errcode']) {
    return $resp_arr;
  } else {
    $errMap = [
      '-1'    => '系统繁忙',
      '86000' => '不是由第三方代小程序进行调用',
      '86001' => '不存在第三方的已经提交的代码',
      '85012' => '无效的审核id',
    ];
    $resp_arr['diy_reason'] = $errMap[$resp_arr['errcode']];
    return $resp_arr;
  }
}

/**
 * 发布已通过审核的代码
 */
function set_wx_release() {
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::post("https://api.weixin.qq.com/wxa/release?access_token=" . $authorizer_access_token, '{}');
  $resp_arr = json_decode($resp, 1);
  diy_log('下面是提交发布的返回信息');
  diy_log($resp_arr);
  if (0 == $resp_arr['errcode'] || 85052 == $resp_arr['errcode']) {
    return $resp_arr;
  } else {
    $errMap = [
      '-1'    => '系统繁忙',
      '85019' => '没有审核版本',
      '85020' => '审核状态未满足发布',
    ];
    $resp_arr['diy_reason'] = $errMap[$resp_arr['errcode']] ? $errMap[$resp_arr['errcode']] : '未知的错误，请稍后重试';
    return $resp_arr;
  }
}

// 获取正式二维码
function get_release_qrcode() {
  // $info = get_authorizer_info();
  // $qrcode_url = $info['authorizer_info']['qrcode_url'];
  // $resp = HttpCurl::get($qrcode_url, []);
  $wid = Session::get('wid');//当前登录的用户id
  $resp = HttpCurl::post('https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token=' . WX_getAccessToken($wid), json_encode(['scene' => '123']));
  return base64_encode($resp);
}

function undo_code_audit() {
  $wid = Session::get('wid');//当前登录的用户id
  $pub = (new Model('pubs'))->find(['id' => $wid]);
  $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
  $resp = HttpCurl::get("https://api.weixin.qq.com/wxa/undocodeaudit?access_token=" . $authorizer_access_token, []);
  $resp_arr = json_decode($resp, 1);
  diy_log('下面是撤回审核的返回信息');
  diy_log($resp_arr);
  if (0 == $resp_arr['errcode']) {
    $pub->save();
    return $resp_arr;
  } else {
    $errMap = [
      '-1'    => '系统繁忙',
      '87013' => '撤回次数达到上线（每天一次，每个月10次）',
    ];
    $resp_arr['diy_reason'] = $errMap[$resp_arr['errcode']];
    return $resp_arr;
  }
}

function get_audit_status($item_id) {
  $item = (new Model('user_upload_code_record'))->find(['id' => $item_id]);
  if ($item->id && $item->audit_id) {
    $authorizer_access_token = get_authorizer_access_token();//获取当前后台登陆着的用户的授权令牌
    $resp = HttpCurl::post(
      "https://api.weixin.qq.com/wxa/get_auditstatus?access_token=" . $authorizer_access_token,
      json_encode(['auditid' => $item->audit_id], JSON_UNESCAPED_UNICODE)
    );
    $resp_arr = json_decode($resp, 1);
    diy_log('下面是查询审核状态的返回信息');
    if (0 == $resp_arr['errcode']) {
      $item->is_audit = $resp_arr['status'];
      $item->unpass_reason = arr_get($resp_arr, 'reason');
      $item->save();
    } else {
      $errMap = [
        '-1'    => '系统繁忙',
        '86000' => '不是由第三方代小程序进行调用',
        '86001' => '不存在第三方的已经提交的代码',
        '85012' => '无效的审核id',
      ];
      $resp_arr['diy_reason'] = $errMap[$resp_arr['errcode']];
      if ($resp_arr['errcode'] != -1) {
        $item->is_audit = 1;
        $item->unpass_reason = $resp_arr['diy_reason'];
        $item->save();
      }
    }
    diy_log($resp_arr);
  }
}

// 缓存测试二维码和正式二维码
function saveQrcode() {
  $wid = Session::get('wid');
  try {
    try {
      // 创建二维码缓存目录
      mkdir('qrcode');
    } catch (Exception $e) {
    }
    //获取体验二维码
    $test_qrcode = base64_decode(get_test_qrcode());
    //获取正式二维码
    $release_qrcode = base64_decode(get_release_qrcode());
    // 缓存二维码
    file_put_contents('qrcode/test_' . $wid . '.png', $test_qrcode);
    file_put_contents('qrcode/release_' . $wid . '.png', $release_qrcode);
  } catch (Exception $e) {
    diy_log($e);
    return false;
  }
  return true;
}
