<?php
set_time_limit(0);   //设置运行时间
error_reporting(E_ALL & ~E_NOTICE);  //显示全部错误
define('ROOT_PATH', __DIR__);  //定义根目录
define("CACHE_PATH", ROOT_PATH . '/html_cache');
define('DBCHARSET', 'UTF8');   //设置数据库默认编码
$sql_file="doxcx";
define('PROJECT_NAME', 'DOXCX');
require(ROOT_PATH . '/include/function.php');
$auto_site_url = strtolower('http://' . $_SERVER['HTTP_HOST']  );
$curUrl=rtrim(dirname(GetCurUrl()).'/');
if(strpos($curUrl,'pub')==strlen($curUrl)-strlen('pub')-1){
    $pub_dir=rtrim(DOXCX_FRAME_PATH,'/').DIRECTORY_SEPARATOR.'pub';
    $str_template=<<<STR
    <!doctype html>
    <html lang="en">
    <head>
    <meta charset="UTF-8">
                 <meta name="viewport" content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
                             <meta http-equiv="X-UA-Compatible" content="ie=edge">
                 <title>配置错误</title>
                 <style>
                 pre{
white-space:pre-wrap;
white-space:-moz-pre-wrap;
white-space:-pre-wrap;
white-space:-o-pre-wrap;
word-wrap:break-word;
}
.pre-div{
word-wrap: break-word;white-space : normal
}
</style>
    </head>
    <body>
      <p>请将网站目录配置以下目录下</p>
      <p>{$pub_dir}</p>
      <p>并且启用伪静态，根据软件类型选择配置内容：</p>
      <div class="pre-div">
       <p>Apache:</p>
      <pre>
      <IfModule mod_rewrite.c>
RewriteEngine on
RewriteCond %{REQUEST_FILENAME} !-f
RewriteCond %{REQUEST_FILENAME} !-d 
     
RewriteRule . index.php [L]

#RewriteCond %{HTTP_HOST} ^doxcx.cn [NC]
#RewriteRule ^(.*)$ http://www.doxcx.cn/$1 [R=301,NC,L]

</IfModule>
</pre>
<p>Nginx:</p>
<pre>
location / {  
	try_files \$uri \$uri/ /index.php\$is_args\$query_string;  
} 
</pre>
</div>
     
    </body>
    </html>


STR;
 echo $str_template;die;
}
$tags = array(
    '__ROOT__' => $curUrl.'/install',//
    '__NAME__' => 'DOXCX',//项目名称
    '__SITE_URL__'=>$auto_site_url,
    '__MANAGE_URL__'=>$auto_site_url.'/manage/login.html'
);
if (function_exists('date_default_timezone_set')) {
    date_default_timezone_set('Asia/Shanghai');
}
input($_GET);
input($_POST);
function input(&$data)
{
    foreach ((array)$data as $key => $value) {
        if (is_string($value)) {
            if (!get_magic_quotes_gpc()) {
                $value = htmlentities($value, ENT_NOQUOTES);
                $value = addslashes(trim($value));
            }
        } else {
            $data[$key] = input($value);
        }
    }
}

//判断是否安装过程序

if (is_file(DOXCX_FRAME_PATH . '/conf.php') && $_GET['step'] != 5) {
    @header("Content-type: text/html; charset=UTF-8");
    echo "系统已经安装过了，如果要重新安装，那么请删除 conf.php 文件";
    exit;
}

$html_title = '程序安装向导';
$html_header = <<<EOF
<div class="header">
  <div class="layout">
    <div class="title">
      
      <h2>DOXCX小程序系统</h2>
    </div>
    <div class="version">版本: v4.07</div>
  </div>
</div>
EOF;

$html_footer = <<<EOF
<div class="footer">
  <h5>Powered by <font class="blue">www.doxcx.cn</font><font class="orange"></font></h5>
  <h6>版权所有 2018-2020 &copy; <a href="http://www.doxcx.cn" target="_blank">DOXCX多合一小程序系统</a></h6>
</div>
EOF;

if (!in_array($_GET['step'], array(1, 2, 3, 4, 5))) {
    $_GET['step'] = 0;
}
switch ($_GET['step']) {
    case 1:
        require(ROOT_PATH . '/include/var.php');
        env_check($env_items);
        dirfile_check($dirfile_items);
        function_check($func_items);
        break;
    case 3:
        $install_error = '';
        $install_recover = '';
        $demo_data = file_exists(ROOT_PATH.'/data/utf8_add.sql') ? true : false;
        step3($install_error, $install_recover);
        break;
    case 4:

        break;
    case 5:
        $sitepath = strtolower(substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '/')));
        $sitepath = str_replace('install', "", $sitepath);
        $auto_site_url = strtolower('http://' . $_SERVER['HTTP_HOST'] . $sitepath);
        break;
    default:
        # code...
        break;
}
require show_template(ROOT_PATH . "/step_{$_GET['step']}.php");

// $template->assign('json',$data);

//$tags=array(
//    '__ROOT__'=>ROOT_PATH,
//);
//$html=str_replace('__ROOT__','/install',$html);
//
//echo $html;


function step3(&$install_error, &$install_recover)
{
    global $html_title, $html_header, $html_footer,$sql_file;
    if ($_POST['submitform'] != 'submit') return;
    $db_host = $_POST['db_host'];
    $db_port = $_POST['db_port'];
    $db_user = $_POST['db_user'];
    $db_pwd = $_POST['db_pwd'];
    $db_name = $_POST['db_name'];
    $db_prefix = $_POST['db_prefix'];
    $admin = $_POST['admin'];
    $password = $_POST['password'];
    if (!$db_host || !$db_port || !$db_user || !$db_pwd || !$db_name || !$db_prefix || !$admin || !$password) {
        $install_error = '输入不完整，请检查';
    }
//    if(strpos($db_prefix, '.') !== false) {
//        $install_error .= '数据表前缀为空，或者格式错误，请检查';
//    }

    if (strlen($admin) > 15 || preg_match("/^$|^c:\\con\\con$|　|[,\"\s\t\<\>&]|^游客|^Guest/is", $admin)) {
        $install_error .= '非法用户名，用户名长度不应当超过 15 个英文字符，且不能包含特殊字符，一般是中文，字母或者数字';
    }
    if ($install_error != '') reutrn;
    $mysqli = @ new mysqli($db_host, $db_user, $db_pwd, '', $db_port);
    if ($mysqli->connect_error) {
        $install_error = '数据库连接失败';
        return;
    }

    if ($mysqli->get_server_info() > '5.5') {
        $mysqli->query("CREATE DATABASE IF NOT EXISTS `$db_name` DEFAULT CHARACTER SET " . DBCHARSET);
    } else {
        $install_error = '数据库必须为MySQL5.5版本以上';
        return;
    }
    if ($mysqli->error) {
        $install_error = $mysqli->error;
        return;
    }
    if ($_POST['install_recover'] != 'yes' && ($query = $mysqli->query("SHOW TABLES FROM $db_name"))) {
        while ($row = mysqli_fetch_array($query)) {
            if (preg_match("/^$db_prefix/", $row[0])) {

                $install_error = '数据表已存在，继续安装将会覆盖已有数据'.$_POST['db_pwd'];
                $install_recover = 'yes';
                return;
            }
        }
    }
    ob_end_clean();
    ob_implicit_flush(1);
    header('X-Accel-Buffering: no'); // 输出立即执行

    require show_template(ROOT_PATH . "/step_4.php");
    $sitepath = strtolower(substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '/')));
    $sitepath = str_replace('install', "", $sitepath);
    $auto_site_url = strtolower('http://' . $_SERVER['HTTP_HOST'] . $sitepath);


    $_charset = strtolower(DBCHARSET);
    $mysqli->select_db($db_name);
    $mysqli->set_charset($_charset);
    $sql = filter_sql(file_get_contents(ROOT_PATH."/data/{$sql_file}.sql"));

//    $sqlArr = preg_split("/;[\r\n]*/", $content);
    //判断是否安装测试数据
//    if ($_POST['demo_data'] == '1') {
//        $sql .= file_get_contents(ROOT_PATH."data/{$_charset}_add.sql");
//    }

    $sql = str_replace("\r\n", "\n", $sql);

    runquery($sql, $db_prefix, $mysqli);
    //先安装数据库再执行配置文件写入
    write_config($auto_site_url);
    $mysqli->query("update {$db_prefix}user_agency set `domain`='" . $_SERVER['HTTP_HOST'] . "'  where `un`='admin'");
    showjsmessage('初始化数据 ... 成功 ');

    /**
     * 转码
     */
    $sitename = $_POST['site_name'];
    $username = $_POST['admin'];
    $password = $_POST['password'];
    /**
     * 产生随机的md5_key，来替换系统默认的md5_key值
     */
//    $md5_key = md5(random(4) . substr(md5($_SERVER['SERVER_ADDR'] . $_SERVER['HTTP_USER_AGENT'] . $db_host . $db_user . $db_pwd . $db_name . substr(time(), 0, 6)), 8, 6) . random(10));
    //$mysqli->query("UPDATE {$db_prefix}setting SET value='".$sitename."' WHERE name='site_name'");

    //管理员账号密码

//    $mysqli->query("INSERT INTO {$db_prefix}admin (`admin_id`,`admin_name`,`admin_password`,`admin_login_time`,`admin_login_num`,`admin_is_super`) VALUES ('1','$username','". md5($password) ."', '".time()."' ,'0',1);");

    //测试数据

    //新增一个标识文件，用来屏蔽重新安装
    $fp = @fopen(PUBLIC_PATH . '/install.lock', 'wb+');
    @fclose($fp);
    exit("<script type=\"text/javascript\">document.getElementById('install_process').innerHTML = '安装完成，下一步...';document.getElementById('install_process').href='install.php?step=5&sitename={$sitename}&username={$username}&password={$password}';</script>");
    exit();
}

//execute sql
function runquery($sql, $db_prefix, $mysqli)
{
//  global $lang, $tablepre, $db;
    if (!isset($sql) || empty($sql)) return;

    $sqlArr = preg_split("/;\n/", $sql);
    foreach ($sqlArr as $v) {
        if (empty($v)) continue;
            $query = trim($v);
            if ($query) {
                if (substr($query, 0, 12) == 'CREATE TABLE') {
                    $line = explode('`', $query);
                    $data_name = $line[1];
                    showjsmessage('数据表  ' . $data_name . ' ... 创建成功');
                    $mysqli->query(droptable($data_name));
                    $mysqli->query($query);
                    unset($line, $data_name);
                } else {
                    $mysqli->query($query);
                }
            }
    }

    unset($sql);
}

//抛出JS信息
function showjsmessage($message)
{
    echo '<script type="text/javascript">showmessage(\'' . addslashes($message) . ' \');</script>' . "\r\n";
    flush();
    ob_flush();
}

//写入config文件
function write_config($url)
{
    extract($GLOBALS, EXTR_SKIP);
    $config = ROOT_PATH . '/data/config.php';
    $configfile = @file_get_contents($config);
    $configfile = trim($configfile);
    $configfile = substr($configfile, -2) == '?>' ? substr($configfile, 0, -2) : $configfile;
    $charset = 'UTF-8';
    $db_host = $_POST['db_host'];
    $db_port = $_POST['db_port'];
    $db_user = $_POST['db_user'];
    $db_pwd = $_POST['db_pwd'];
    $db_name = $_POST['db_name'];
    $db_prefix = $_POST['db_prefix'];
    $admin = $_POST['admin'];
    $password = $_POST['password'];
    $db_type = 'mysql';
    $site_name = $_POST['site_name'];
    $replace_arr = [
        '===db_host===' => $db_host,
        '===db_user===' => $db_user,
        '===db_name===' => $db_name,
        '===db_pwd===' => $db_pwd,
        '===db_port===' => $db_port,
        '===site_name===' => $site_name,
        '===host==='=>$_SERVER['HTTP_HOST']


    ];
    foreach ($replace_arr as $key => $v) {
        $configfile = str_replace($key, $v, $configfile);
    }
//    $configfile = str_replace("===url===",          $url, $configfile);
//    $configfile = str_replace("===db_prefix===",    $db_prefix, $configfile);
//    $configfile = str_replace("===db_charset===",   $charset, $configfile);
//    $configfile = str_replace("===db_host===",      $db_host, $configfile);
//    $configfile = str_replace("===db_user===",      $db_user, $configfile);
//    $configfile = str_replace("===db_pwd===",       $db_pwd, $configfile);
//    $configfile = str_replace("===db_name===",      $db_name, $configfile);
//    $configfile = str_replace("===db_port===",      $db_port, $configfile);

    file_put_contents(DOXCX_FRAME_PATH . '/conf.php', $configfile);
}

/**
 * 渲染输出模版
 * @param $file
 * @param array $tags
 * @return string
 */
function show_template($file, $replace_tag = [])
{
    global $tags;
    if (!$replace_tag) $replace_tag = $tags;
    is_dir(CACHE_PATH) or mkdir(CACHE_PATH, 0751);
    $html = file_get_contents($file);
    foreach ($replace_tag as $key => $value) {
        $html = str_replace($key, $value, $html);
    }
    $com_html = CACHE_PATH . '/' . basename($file);
    file_put_contents($com_html, $html);
    return $com_html;

}
