const wx = require('../../weidogs');
/* converted by appconverter    	      		  
   on Monday, August 27th, 2018, 2:55:02 PM
*/
const app = getApp();

const dzpApi = require('../../api/dzpAPI'),WxParse = require("../../wxParse/wxParse.js");
Page({
    data: {
        animationData: {
            duration: 3000,
            timingFunction: 'linear',
            rotate: 0
        },
        prize: null,
        start: false,
        is_end: -1,
        showFail: false,
        showWin: false,
        frequency: 0,
        num:0
    },
    onLoad() {
        this.loadInfo();
    },
    loadInfo() {
        let t = this;
        var that = this;
        let apiObj = dzpApi.getDzpInfo;
        apiObj.data.openid = app.globalData.UserInfo.WeiXinOpenId;
        // apiObj.data.openid = '2018091061302898';
        apiObj.success = function (resp) {
            let respData = resp.data;
            console.log('ddddd',resp.data.data);
            if (respData.status == 'error') {
            my.alert({
                title: '提示',
                content: respData.msg,
                success: () => {
                    my.navigateBack();
                },
            });
                return false;
            }
            let data = respData.data;
            t.setData(data), WxParse.wxParse("pinfo", "html", resp.data.data.dzpSetting.rule, t);
            if(respData.data.frequency != null || respData.data.frequency != ''){
                    var frequency = respData.data.frequency
            }else{
                    var frequency = 0
            }
            that.setData({
                frequency : frequency
            })
        };
        wx.request(apiObj);
    },
    onShow() {

    },
    animation: function () {
        let t = this;
        let ani = {
            animationData: {
                duration: 0,
                timingFunction: 'linear',
                rotate: 0
            },
            start: false
        };
        let prize = t.data.prize;
        if (prize.is_empty == 1) {
            ani.showFail = true;
        } else {
            ani.showWin = true;
        }
        this.setData(ani);
    },
    onStartTap: function () {
        // if (this.data.start)
        //     return;
        if(this.data.frequency== 0){
            my.showToast({
                type: 'fail',
                content: '您的抽奖机会已经用完了',
                 duration: 1500,
                })
                return ;
        }
        let t = this;
        if (t.data.frequency == 0) {
            if (t.data.is_vip == 1) {
                my.confirm({
                    title: '提示',
                    content: `继续抽奖将会消耗${ t.data.dzpSetting.point_lottery_consume }积分`,
                    success(result) {
                        if (result.confirm) {
                            t.requestLottery();
                        }
                    }
                });
            } else {
                my.confirm({
                    title: '提示',
                    content: `您的抽奖机会已经用完了`,
                    showCancel: 0
                });
            }
        } else {
            t.requestLottery();
        }
    },
    requestLottery() {
        if(this.data.frequency== 0){
            my.showToast({
                type: 'fail',
                content: '您的抽奖机会已经用完了',
                 duration: 1500,
                })
                return ;
        }
        let t = this;
        let apiObj = dzpApi.lottery;
        apiObj.data.openid = app.globalData.UserInfo.WeiXinOpenId;
        //  apiObj.data.openid = '2018091061302898';
        apiObj.complete = function () {
            my.hideLoading();
        };
        apiObj.success = function (resp) {
            let respData = resp.data;
            console.log(respData);
            if (respData.status != 'success') {
                my.confirm({
                    title: '提示',
                    content: respData.msg,
                });
            // my.alert({
            //     title: '提示',
            //     content: respData.msg,
            //     success: () => {
            //         my.navigateBack();
            //     },
            // });
                return false;
            }
            let prize = respData.data;
            console.log(prize);
            t.setData({ prize: prize });
            let prizeList = t.data.prizeList;
            let idx = 0;
            for (let i = 0; i < prizeList.length; ++i) {
                if (prizeList[i].id == prize.id) {
                    idx = i;
                    break;
                }
            }
            let rotate = -(idx * 60 + 360 * 10);
            t.startSpin(rotate);
            t.loadInfo();
        };
        wx.showLoading({ title: '加载中' });
        wx.request(apiObj);
    },
    startSpin(rotate) {
        var that = this;
        this.data.num++;
        console.log('vndffhh',++this.data.num)
        if(this.data.frequency== 0){
            my.showToast({
                type: 'fail',
                content: '您的抽奖机会已经用完了',
                 duration: 1500,
                })
                return ;
        }
        this.setData({
            animationData: {
                duration: 3000,
                timingFunction: 'ease-out',
                rotate: rotate
            },
            start: true
        });
            setTimeout(function() {
                that.animation();
            }, 3000);
    },
    onSetValueTap: function (e) {
        let dataset = e.currentTarget.dataset;
        let name = dataset.name;
        let value = dataset.value;
        let o = {};
        o[name] = value;
        this.setData(o);
    },
    onNavigateTap: function (e) {
        const dataset = e.detail.target ? e.detail.target.dataset : e.currentTarget.dataset;
        const url = dataset.url;
        my.navigateTo({ url: url });
    },
    onShareAppMessage(e) {
        let t = this;
        return {
            title: '幸运大转盘',
            path: '/pages/index/index',
            success: function (res) {
                let apiObj = dzpApi.share;
                apiObj.data.openid = app.globalData.UserInfo.WeiXinOpenId;
                apiObj.success = function (resp) {
                    console.log('vnvdh',resp)
                    t.loadInfo();
                };
                wx.request(apiObj);
            },
            fail: function (res) {
            }
        };
    }
});