const wx = require('../weidogs');
/* converted by appconverter    	      		  
   on Monday, August 27th, 2018, 2:55:02 PM
*/
let app = getApp();
let tcApi = require('../api/tcApi');
let myTools = require('../utils/myTools');
module.exports = {
    loadSetting(setTitle = false) {
        let t = this;
        let api = tcApi.getSetting;
        wx.showLoading({
            title: 'Loading',
            mask: 1
        });
        wx.request({
            url: api.url,
            method: api.method,
            data: {
                wid: api.data.wid,
                openid: app.globalData.UserInfo.WeiXinOpenId
            },
            success(resp) {
                let r = resp.data, rd = r.data;
                if (r.status == 'success') {
            // var daynum = parseInt(rd.top_setting[0].top_time);
            //     let numList = [];
            //     for (let i = 1; i <= parseInt(daynum); ++i) {
            //         numList.push(i+'');
            //     }
                    t.setData({ 
                        setting: rd,
                        // numList : numList
                         });
                    if (setTitle && rd.title) {
                        my.setNavigationBar({ title: rd.title });
                    }
                } else {
                    my.confirm({
                        title: '提示',
                        content: r.msg
                    });
                }
            },
            complete() {
                my.hideLoading();
            }
        });
    },
    loadCateList(group = false) {
        let t = this;
        let api = tcApi.getCateList;
        wx.showLoading({
            title: 'Loading',
            mask: 1
        });
        wx.request({
            url: api.url,
            method: api.method,
            data: {
                wid: api.data.wid,
                openid: app.globalData.UserInfo.WeiXinOpenId,
                group: group
            },
            success(resp) {
                let r = resp.data, rd = r.data;
                if (r.status == 'success') {
                    t.setData({ cateList: rd });
                } else {
                    my.confirm({
                        title: '提示',
                        content: r.msg
                    });
                }
            },
            complete() {
                my.hideLoading();
            }
        });
    },
    loadCate(cid) {
        let t = this;
        let api = tcApi.getCate;
        wx.showLoading({
            title: 'Loading',
            mask: 1
        });
        wx.request({
            url: api.url,
            method: api.method,
            data: {
                wid: api.data.wid,
                openid: app.globalData.UserInfo.WeiXinOpenId,
                cid: cid
            },
            success(resp) {
                let r = resp.data, rd = r.data;
                if (r.status == 'success') {
                    rd.price = myTools.toMoney(rd.price);
                    t.setData({ cate: rd });
                } else {
                    my.confirm({
                        title: '提示',
                        content: r.msg
                    });
                }
            },
            complete() {
                my.hideLoading();
            }
        });
    },
    onCallTap(e) {
        let t = this, ds = e.currentTarget.dataset;
        let tel = ds.tel;
        my.makePhoneCall({ number: tel });
    },
    onGoodTap(e) {
        let t = this, ds = e.currentTarget.dataset;
        let idx = ds.index, id = ds.id;
        let api = tcApi.setUp;
        wx.request({
            url: api.url,
            method: api.method,
            data: {
                wid: api.data.wid,
                openid: app.globalData.UserInfo.WeiXinOpenId,
                msg_id: id
            },
            success(resp) {
                let r = resp.data, rd = r.data;
                if (r.status == 'success') {
                    let msgList = t.data.msgList;
                    if (msgList) {
                        msgList[idx].is_up = 1;
                        msgList[idx].up_num += 1;
                        t.setData({ msgList: msgList });
                    } else {
                        let _msg = t.data.msg;
                        _msg.is_up = _msg.is_up == 1 ? 0 : 1;
                        _msg.is_up = _msg.up_num += 1;
                        t.setData({ msg: _msg });
                    }
                } else {
                    wx.showToast({
                        title: r.msg,
                        mask: 1
                    });
                }
            },
            fail() {
                wx.showToast({
                    title: '网络异常',
                    mask: 1
                });
            }
        });
    },
    onShowCommentTap(e) {
        let t = this, ds = e.currentTarget.dataset;
        let idx = ds.index;
        t.setData({
            show_comment: true,
            comment_msg_idx: idx,
            comment_msg_id: ds.id,
            comment_content: ''
        });
    },
    onHideCommentTap(e) {
        let t = this, ds = e.currentTarget.dataset;
        t.setData({
            show_comment: false,
            comment_msg_idx: null,
            comment_msg_id: null,
            comment_content: null
        });
    },
    onCommentSubmit(e) {
        let t = this;
        console.log(e);
        let comment_content = e.detail.value.content;
        let api = tcApi.setComment;
        wx.request({
            url: api.url,
            method: api.method,
            data: {
                wid: api.data.wid,
                openid: app.globalData.UserInfo.WeiXinOpenId,
                msg_id: t.data.comment_msg_id,
                content: comment_content
            },
            success(resp) {
                let r = resp.data, rd = r.data;
                console.log(r);
                let msgList = t.data.msgList;
                if (msgList) {
                    msgList[t.data.comment_msg_idx].comment_num += 1;
                    msgList[t.data.comment_msg_idx].comment.push(rd);
                    t.setData({
                        msgList: msgList,
                        show_comment: false
                    });
                } else {
                    let _msg = t.data.msg;
                    _msg.comment_num += 1;
                    _msg.comment.push(rd);
                    t.setData({
                        msg: _msg,
                        show_comment: false
                    });
                }
            },
            fail() {
                wx.showToast({
                    title: '网络错误',
                    mask: 1
                });
            }
        });
    },
    onPayTap(e) {
        let t = this, ds = e.currentTarget.dataset;
        console.log(ds);
        let id = ds.id;
        let api = tcApi.requestPay;
        console.log(api);
        wx.request({
            url: api.url,
            method: api.method,
            data: {
                wid: api.data.wid,
                openid: app.globalData.UserInfo.WeiXinOpenId,
                msg_id: id
            },
            success(resp) {
                console.log(resp)
                let r = resp.data, payObj = r.data;
                if (r.status != 'success') {
                    wx.showToast({
                        title: r.msg,
                        'mask': 1
                    });
                    return false;
                }
                if(resp.data.data.alipay_trade_create_response.code == '10000'){
                                my.tradePay({
                                    tradeNO: resp.data.data.alipay_trade_create_response.trade_no, //完整的支付参数拼接成的字符串，从服务端获取
                                    success: function (n) {
                                    switch(n.resultCode){
                                        case '9000' :
                                            my.showToast({
                                                type: 'success',
                                                content: '订单支付成功',
                                            });
                                        break;
                                        case '4000':
                                            my.showToast({
                                            type: 'fail',
                                            content: '订单支付失败',
                                            });
                                        break;
                                        case '6001':
                                            my.showToast({
                                            type: 'fail',
                                            content: '您取消支付',
                                            });                    
                                        break;
                                        case '6002' :
                                            my.showToast({
                                            type: 'fail',
                                            content: '网络连接出错',
                                            });
                                        break;                    
                                    }
                                    },
                                    fail: function (n) {
                                        my.showToast({
                                        type: 'fail',
                                        content: '订单支付失败',
                                        });                 
                                    }
                                });
                            }else{
                                my.showToast({
                                    type:'fail',
                                    content:resp.data.data.alipay_trade_create_response.sub_msg
                                })
                            }
            
            },
            fail() {
                wx.showToast({
                    title: '网络错误',
                    'mask': 1
                });
            }
        });
    },
    bindPreviewImg(e) {
        let t = this, ds = e.currentTarget.dataset;
        let url = ds.url;
        my.previewImage({ urls: [url] });
    },
    bindFav(e) {
        let t = this, ds = e.currentTarget.dataset;
        console.log(ds);
        let id = ds.id, idx = ds.index;
        let api = tcApi.setFav;
        wx.request({
            url: api.url,
            method: api.method,
            data: {
                wid: api.data.wid,
                openid: app.globalData.UserInfo.WeiXinOpenId,
                msg_id: id
            },
            success(resp) {
                let r = resp.data, rd = r.data;
                if (r.status != 'success') {
                    my.confirm({
                        title: '提示',
                        content: r.msg,
                        showCancel: 0
                    });
                    return false;
                }
                if (t.data.msgList) {
                    let _msgList = t.data.msgList;
                    console.log(_msgList, idx);
                    _msgList[idx].is_fav = _msgList[idx].is_fav == 1 ? 0 : 1;
                    t.setData({ msgList: _msgList });
                } else if (t.data.msg) {
                    let _msg = t.data.msg;
                    _msg.is_fav = _msg.is_fav == 1 ? 0 : 1;
                    t.setData({ msg: _msg });
                }
            },
            fail() {
                my.confirm({
                    title: '错误',
                    content: '网络错误',
                    showCancel: 0
                });
            }
        });
    },
    bindRedirectToDetail(e) {
        let t = this, ds = e.currentTarget.dataset;
        let id = ds.id;
        let url = '/pages/tc_detail/tc_detail?id=' + id;
        console.log(url);
        my.navigateTo({ url: url });
    },
    loadUser() {
        let t = this, ts = t.data;
        let api = tcApi.getUser;
        wx.request({
            url: api.url,
            data: {
                wid: api.data.wid,
                openid: app.globalData.UserInfo.WeiXinOpenId
            },
            method: api.method,
            success(resp) {
                let r = resp.data, rd = r.data;
                console.log('usrkkk',resp)
                if (r.status == 'success') {
                    t.setData({ user: rd });
                } else {
                    wx.showToast({
                        title: r.msg,
                        mask: 1
                    });
                }
            },
            fail() {
                wx.showToast({
                    title: '网络异常',
                    mask: 1
                });
            }
        });
    }
};