const wx = require('../weidogs');
/* converted by appconverter    	      		  
   on Monday, August 27th, 2018, 2:55:02 PM
*/
function getDefaultOpts(e) {
    var t = {
        omitExtraWLInCodeBlocks: {
            defaultValue: !1,
            describe: 'Omit the default extra whiteline added to code blocks',
            type: 'boolean'
        },
        noHeaderId: {
            defaultValue: !1,
            describe: 'Turn on/off generated header id',
            type: 'boolean'
        },
        prefixHeaderId: {
            defaultValue: !1,
            describe: 'Specify a prefix to generated header ids',
            type: 'string'
        },
        headerLevelStart: {
            defaultValue: !1,
            describe: 'The header blocks level start',
            type: 'integer'
        },
        parseImgDimensions: {
            defaultValue: !1,
            describe: 'Turn on/off image dimension parsing',
            type: 'boolean'
        },
        simplifiedAutoLink: {
            defaultValue: !1,
            describe: 'Turn on/off GFM autolink style',
            type: 'boolean'
        },
        literalMidWordUnderscores: {
            defaultValue: !1,
            describe: 'Parse midword underscores as literal underscores',
            type: 'boolean'
        },
        strikethrough: {
            defaultValue: !1,
            describe: 'Turn on/off strikethrough support',
            type: 'boolean'
        },
        tables: {
            defaultValue: !1,
            describe: 'Turn on/off tables support',
            type: 'boolean'
        },
        tablesHeaderId: {
            defaultValue: !1,
            describe: 'Add an id to table headers',
            type: 'boolean'
        },
        ghCodeBlocks: {
            defaultValue: !0,
            describe: 'Turn on/off GFM fenced code blocks support',
            type: 'boolean'
        },
        tasklists: {
            defaultValue: !1,
            describe: 'Turn on/off GFM tasklist support',
            type: 'boolean'
        },
        smoothLivePreview: {
            defaultValue: !1,
            describe: 'Prevents weird effects in live previews due to incomplete input',
            type: 'boolean'
        },
        smartIndentationFix: {
            defaultValue: !1,
            description: 'Tries to smartly fix identation in es6 strings',
            type: 'boolean'
        }
    };
    if (e === !1)
        return JSON.parse(JSON.stringify(t));
    var n = {};
    for (var r in t)
        t.hasOwnProperty(r) && (n[r] = t[r].defaultValue);
    return n;
}
function validate(e, t) {
    var n = t ? 'Error in ' + t + ' extension->' : 'Error in unnamed extension', r = {
            valid: !0,
            error: ''
        };
    showdown.helper.isArray(e) || (e = [e]);
    for (var i = 0; i < e.length; ++i) {
        var s = n + ' sub-extension ' + i + ': ', o = e[i];
        if (typeof o != 'object')
            return r.valid = !1, r.error = s + 'must be an object, but ' + typeof o + ' given', r;
        if (!showdown.helper.isString(o.type))
            return r.valid = !1, r.error = s + 'property "type" must be a string, but ' + typeof o.type + ' given', r;
        var u = o.type = o.type.toLowerCase();
        u === 'language' && (u = o.type = 'lang'), u === 'html' && (u = o.type = 'output');
        if (u !== 'lang' && u !== 'output' && u !== 'listener')
            return r.valid = !1, r.error = s + 'type ' + u + ' is not recognized. Valid values: "lang/language", "output/html" or "listener"', r;
        if (u === 'listener') {
            if (showdown.helper.isUndefined(o.listeners))
                return r.valid = !1, r.error = s + '. Extensions of type "listener" must have a property called "listeners"', r;
        } else if (showdown.helper.isUndefined(o.filter) && showdown.helper.isUndefined(o.regex))
            return r.valid = !1, r.error = s + u + ' extensions must define either a "regex" property or a "filter" method', r;
        if (o.listeners) {
            if (typeof o.listeners != 'object')
                return r.valid = !1, r.error = s + '"listeners" property must be an object but ' + typeof o.listeners + ' given', r;
            for (var a in o.listeners)
                if (o.listeners.hasOwnProperty(a) && typeof o.listeners[a] != 'function')
                    return r.valid = !1, r.error = s + '"listeners" property must be an hash of [event name]: [callback]. listeners.' + a + ' must be a function but ' + typeof o.listeners[a] + ' given', r;
        }
        if (o.filter) {
            if (typeof o.filter != 'function')
                return r.valid = !1, r.error = s + '"filter" must be a function, but ' + typeof o.filter + ' given', r;
        } else if (o.regex) {
            showdown.helper.isString(o.regex) && (o.regex = new RegExp(o.regex, 'g'));
            if (!o.regex instanceof RegExp)
                return r.valid = !1, r.error = s + '"regex" property must either be a string or a RegExp object, but ' + typeof o.regex + ' given', r;
            if (showdown.helper.isUndefined(o.replace))
                return r.valid = !1, r.error = s + '"regex" extensions must implement a replace string or function', r;
        }
    }
    return r;
}
function escapeCharactersCallback(e, t) {
    var n = t.charCodeAt(0);
    return '~E' + n + 'E';
}
var showdown = {}, parsers = {}, extensions = {}, globalOptions = getDefaultOpts(!0), flavor = {
        github: {
            omitExtraWLInCodeBlocks: !0,
            prefixHeaderId: 'user-content-',
            simplifiedAutoLink: !0,
            literalMidWordUnderscores: !0,
            strikethrough: !0,
            tables: !0,
            tablesHeaderId: !0,
            ghCodeBlocks: !0,
            tasklists: !0
        },
        vanilla: getDefaultOpts(!0)
    };
showdown.helper = {}, showdown.extensions = {}, showdown.setOption = function (e, t) {
    return globalOptions[e] = t, this;
}, showdown.getOption = function (e) {
    return globalOptions[e];
}, showdown.getOptions = function () {
    return globalOptions;
}, showdown.resetOptions = function () {
    globalOptions = getDefaultOpts(!0);
}, showdown.setFlavor = function (e) {
    if (flavor.hasOwnProperty(e)) {
        var t = flavor[e];
        for (var n in t)
            t.hasOwnProperty(n) && (globalOptions[n] = t[n]);
    }
}, showdown.getDefaultOptions = function (e) {
    return getDefaultOpts(e);
}, showdown.subParser = function (e, t) {
    if (showdown.helper.isString(e)) {
        if (typeof t == 'undefined') {
            if (parsers.hasOwnProperty(e))
                return parsers[e];
            throw Error('SubParser named ' + e + ' not registered!');
        }
        parsers[e] = t;
    }
}, showdown.extension = function (e, t) {
    if (!showdown.helper.isString(e))
        throw Error('Extension \'name\' must be a string');
    e = showdown.helper.stdExtName(e);
    if (showdown.helper.isUndefined(t)) {
        if (!extensions.hasOwnProperty(e))
            throw Error('Extension named ' + e + ' is not registered!');
        return extensions[e];
    }
    typeof t == 'function' && (t = t()), showdown.helper.isArray(t) || (t = [t]);
    var n = validate(t, e);
    if (!n.valid)
        throw Error(n.error);
    extensions[e] = t;
}, showdown.getAllExtensions = function () {
    return extensions;
}, showdown.removeExtension = function (e) {
    delete extensions[e];
}, showdown.resetExtensions = function () {
    extensions = {};
}, showdown.validateExtension = function (e) {
    var t = validate(e, null);
    return t.valid ? !0 : (console.warn(t.error), !1);
}, showdown.hasOwnProperty('helper') || (showdown.helper = {}), showdown.helper.isString = function (t) {
    return typeof t == 'string' || t instanceof String;
}, showdown.helper.isFunction = function (t) {
    var n = {};
    return t && n.toString.call(t) === '[object Function]';
}, showdown.helper.forEach = function (t, n) {
    if (typeof t.forEach == 'function')
        t.forEach(n);
    else
        for (var r = 0; r < t.length; r++)
            n(t[r], r, t);
}, showdown.helper.isArray = function (t) {
    return t.constructor === Array;
}, showdown.helper.isUndefined = function (t) {
    return typeof t == 'undefined';
}, showdown.helper.stdExtName = function (e) {
    return e.replace(/[_-]||\s/g, '').toLowerCase();
}, showdown.helper.escapeCharactersCallback = escapeCharactersCallback, showdown.helper.escapeCharacters = function (t, n, r) {
    var i = '([' + n.replace(/([\[\]\\])/g, '\\$1') + '])';
    r && (i = '\\\\' + i);
    var s = new RegExp(i, 'g');
    return t = t.replace(s, escapeCharactersCallback), t;
};
var rgxFindMatchPos = function (e, t, n, r) {
    var i = r || '', s = i.indexOf('g') > -1, o = new RegExp(t + '|' + n, 'g' + i.replace(/g/g, '')), u = new RegExp(t, i.replace(/g/g, '')), a = [], f, l, c, h, p;
    do {
        f = 0;
        while (c = o.exec(e))
            if (u.test(c[0]))
                f++ || (l = o.lastIndex, h = l - c[0].length);
            else if (f && !--f) {
                p = c.index + c[0].length;
                var d = {
                    left: {
                        start: h,
                        end: l
                    },
                    match: {
                        start: l,
                        end: c.index
                    },
                    right: {
                        start: c.index,
                        end: p
                    },
                    wholeMatch: {
                        start: h,
                        end: p
                    }
                };
                a.push(d);
                if (!s)
                    return a;
            }
    } while (f && (o.lastIndex = l));
    return a;
};
showdown.helper.matchRecursiveRegExp = function (e, t, n, r) {
    var i = rgxFindMatchPos(e, t, n, r), s = [];
    for (var o = 0; o < i.length; ++o)
        s.push([
            e.slice(i[o].wholeMatch.start, i[o].wholeMatch.end),
            e.slice(i[o].match.start, i[o].match.end),
            e.slice(i[o].left.start, i[o].left.end),
            e.slice(i[o].right.start, i[o].right.end)
        ]);
    return s;
}, showdown.helper.replaceRecursiveRegExp = function (e, t, n, r, i) {
    if (!showdown.helper.isFunction(t)) {
        var s = t;
        t = function () {
            return s;
        };
    }
    var o = rgxFindMatchPos(e, n, r, i), u = e, a = o.length;
    if (a > 0) {
        var f = [];
        o[0].wholeMatch.start !== 0 && f.push(e.slice(0, o[0].wholeMatch.start));
        for (var l = 0; l < a; ++l)
            f.push(t(e.slice(o[l].wholeMatch.start, o[l].wholeMatch.end), e.slice(o[l].match.start, o[l].match.end), e.slice(o[l].left.start, o[l].left.end), e.slice(o[l].right.start, o[l].right.end))), l < a - 1 && f.push(e.slice(o[l].wholeMatch.end, o[l + 1].wholeMatch.start));
        o[a - 1].wholeMatch.end < e.length && f.push(e.slice(o[a - 1].wholeMatch.end)), u = f.join('');
    }
    return u;
}, showdown.helper.isUndefined(console) && (console = {
    warn: function (e) {
        alert(e);
    },
    log: function (e) {
        alert(e);
    },
    error: function (e) {
        throw e;
    }
}), showdown.Converter = function (e) {
    function s() {
        e = e || {};
        for (var n in globalOptions)
            globalOptions.hasOwnProperty(n) && (t[n] = globalOptions[n]);
        if (typeof e != 'object')
            throw Error('Converter expects the passed parameter to be an object, but ' + typeof e + ' was passed instead.');
        for (var r in e)
            e.hasOwnProperty(r) && (t[r] = e[r]);
        t.extensions && showdown.helper.forEach(t.extensions, o);
    }
    function o(e, t) {
        t = t || null;
        if (showdown.helper.isString(e)) {
            e = showdown.helper.stdExtName(e), t = e;
            if (showdown.extensions[e]) {
                console.warn('DEPRECATION WARNING: ' + e + ' is an old extension that uses a deprecated loading method.' + 'Please inform the developer that the extension should be updated!'), u(showdown.extensions[e], e);
                return;
            }
            if (!!showdown.helper.isUndefined(extensions[e]))
                throw Error('Extension "' + e + '" could not be loaded. It was either not found or is not a valid extension.');
            e = extensions[e];
        }
        typeof e == 'function' && (e = e()), showdown.helper.isArray(e) || (e = [e]);
        var s = validate(e, t);
        if (!s.valid)
            throw Error(s.error);
        for (var o = 0; o < e.length; ++o) {
            switch (e[o].type) {
            case 'lang':
                n.push(e[o]);
                break;
            case 'output':
                r.push(e[o]);
            }
            if (e[o].hasOwnProperty(i))
                for (var f in e[o].listeners)
                    e[o].listeners.hasOwnProperty(f) && a(f, e[o].listeners[f]);
        }
    }
    function u(e, t) {
        typeof e == 'function' && (e = e(new showdown.Converter())), showdown.helper.isArray(e) || (e = [e]);
        var i = validate(e, t);
        if (!i.valid)
            throw Error(i.error);
        for (var s = 0; s < e.length; ++s)
            switch (e[s].type) {
            case 'lang':
                n.push(e[s]);
                break;
            case 'output':
                r.push(e[s]);
                break;
            default:
                throw Error('Extension loader error: Type unrecognized!!!');
            }
    }
    function a(e, t) {
        if (!showdown.helper.isString(e))
            throw Error('Invalid argument in converter.listen() method: name must be a string, but ' + typeof e + ' given');
        if (typeof t != 'function')
            throw Error('Invalid argument in converter.listen() method: callback must be a function, but ' + typeof t + ' given');
        i.hasOwnProperty(e) || (i[e] = []), i[e].push(t);
    }
    function f(e) {
        var t = e.match(/^\s*/)[0].length, n = new RegExp('^\\s{0,' + t + '}', 'gm');
        return e.replace(n, '');
    }
    var t = {}, n = [], r = [], i = {};
    s(), this._dispatch = function (t, n, r, s) {
        if (i.hasOwnProperty(t))
            for (var o = 0; o < i[t].length; ++o) {
                var u = i[t][o](t, n, this, r, s);
                u && typeof u != 'undefined' && (n = u);
            }
        return n;
    }, this.listen = function (e, t) {
        return a(e, t), this;
    }, this.makeHtml = function (e) {
        if (!e)
            return e;
        var i = {
            gHtmlBlocks: [],
            gHtmlMdBlocks: [],
            gHtmlSpans: [],
            gUrls: {},
            gTitles: {},
            gDimensions: {},
            gListLevel: 0,
            hashLinkCounts: {},
            langExtensions: n,
            outputModifiers: r,
            converter: this,
            ghCodeBlocks: []
        };
        return e = e.replace(/~/g, '~T'), e = e.replace(/\$/g, '~D'), e = e.replace(/\r\n/g, '\n'), e = e.replace(/\r/g, '\n'), t.smartIndentationFix && (e = f(e)), e = e, e = showdown.subParser('detab')(e, t, i), e = showdown.subParser('stripBlankLines')(e, t, i), showdown.helper.forEach(n, function (n) {
            e = showdown.subParser('runExtension')(n, e, t, i);
        }), e = showdown.subParser('hashPreCodeTags')(e, t, i), e = showdown.subParser('githubCodeBlocks')(e, t, i), e = showdown.subParser('hashHTMLBlocks')(e, t, i), e = showdown.subParser('hashHTMLSpans')(e, t, i), e = showdown.subParser('stripLinkDefinitions')(e, t, i), e = showdown.subParser('blockGamut')(e, t, i), e = showdown.subParser('unhashHTMLSpans')(e, t, i), e = showdown.subParser('unescapeSpecialChars')(e, t, i), e = e.replace(/~D/g, '$$'), e = e.replace(/~T/g, '~'), showdown.helper.forEach(r, function (n) {
            e = showdown.subParser('runExtension')(n, e, t, i);
        }), e;
    }, this.setOption = function (e, n) {
        t[e] = n;
    }, this.getOption = function (e) {
        return t[e];
    }, this.getOptions = function () {
        return t;
    }, this.addExtension = function (e, t) {
        t = t || null, o(e, t);
    }, this.useExtension = function (e) {
        o(e);
    }, this.setFlavor = function (e) {
        if (flavor.hasOwnProperty(e)) {
            var n = flavor[e];
            for (var r in n)
                n.hasOwnProperty(r) && (t[r] = n[r]);
        }
    }, this.removeExtension = function (e) {
        showdown.helper.isArray(e) || (e = [e]);
        for (var t = 0; t < e.length; ++t) {
            var i = e[t];
            for (var s = 0; s < n.length; ++s)
                n[s] === i && n[s].splice(s, 1);
            for (var o = 0; o < r.length; ++s)
                r[o] === i && r[o].splice(s, 1);
        }
    }, this.getAllExtensions = function () {
        return {
            language: n,
            output: r
        };
    };
}, showdown.subParser('anchors', function (e, t, n) {
    e = n.converter._dispatch('anchors.before', e, t, n);
    var r = function (e, t, r, i, s, o, u, a) {
        showdown.helper.isUndefined(a) && (a = ''), e = t;
        var f = r, l = i.toLowerCase(), c = s, h = a;
        if (!c) {
            l || (l = f.toLowerCase().replace(/ ?\n/g, ' ')), c = '#' + l;
            if (!showdown.helper.isUndefined(n.gUrls[l]))
                c = n.gUrls[l], showdown.helper.isUndefined(n.gTitles[l]) || (h = n.gTitles[l]);
            else {
                if (!(e.search(/\(\s*\)$/m) > -1))
                    return e;
                c = '';
            }
        }
        c = showdown.helper.escapeCharacters(c, '*_', !1);
        var p = '<a href="' + c + '"';
        return h !== '' && h !== null && (h = h.replace(/"/g, '&quot;'), h = showdown.helper.escapeCharacters(h, '*_', !1), p += ' title="' + h + '"'), p += '>' + f + '</a>', p;
    };
    return e = e.replace(/(\[((?:\[[^\]]*]|[^\[\]])*)][ ]?(?:\n[ ]*)?\[(.*?)])()()()()/g, r), e = e.replace(/(\[((?:\[[^\]]*]|[^\[\]])*)]\([ \t]*()<?(.*?(?:\(.*?\).*?)?)>?[ \t]*((['"])(.*?)\6[ \t]*)?\))/g, r), e = e.replace(/(\[([^\[\]]+)])()()()()()/g, r), e = n.converter._dispatch('anchors.after', e, t, n), e;
}), showdown.subParser('autoLinks', function (e, t, n) {
    function u(e, t) {
        var n = t;
        return /^www\./i.test(t) && (t = t.replace(/^www\./i, 'http://www.')), '<a href="' + t + '">' + n + '</a>';
    }
    function a(e, t) {
        var n = showdown.subParser('unescapeSpecialChars')(t);
        return showdown.subParser('encodeEmailAddress')(n);
    }
    e = n.converter._dispatch('autoLinks.before', e, t, n);
    var r = /\b(((https?|ftp|dict):\/\/|www\.)[^'">\s]+\.[^'">\s]+)(?=\s|$)(?!["<>])/gi, i = /<(((https?|ftp|dict):\/\/|www\.)[^'">\s]+)>/gi, s = /(?:^|[ \n\t])([A-Za-z0-9!#$%&'*+-\/=?^_`\{|}~\.]+@[-a-z0-9]+(\.[-a-z0-9]+)*\.[a-z]+)(?:$|[ \n\t])/gi, o = /<(?:mailto:)?([-.\w]+@[-a-z0-9]+(\.[-a-z0-9]+)*\.[a-z]+)>/gi;
    return e = e.replace(i, u), e = e.replace(o, a), t.simplifiedAutoLink && (e = e.replace(r, u), e = e.replace(s, a)), e = n.converter._dispatch('autoLinks.after', e, t, n), e;
}), showdown.subParser('blockGamut', function (e, t, n) {
    e = n.converter._dispatch('blockGamut.before', e, t, n), e = showdown.subParser('blockQuotes')(e, t, n), e = showdown.subParser('headers')(e, t, n);
    var r = showdown.subParser('hashBlock')('<hr />', t, n);
    return e = e.replace(/^[ ]{0,2}([ ]?\*[ ]?){3,}[ \t]*$/gm, r), e = e.replace(/^[ ]{0,2}([ ]?\-[ ]?){3,}[ \t]*$/gm, r), e = e.replace(/^[ ]{0,2}([ ]?_[ ]?){3,}[ \t]*$/gm, r), e = showdown.subParser('lists')(e, t, n), e = showdown.subParser('codeBlocks')(e, t, n), e = showdown.subParser('tables')(e, t, n), e = showdown.subParser('hashHTMLBlocks')(e, t, n), e = showdown.subParser('paragraphs')(e, t, n), e = n.converter._dispatch('blockGamut.after', e, t, n), e;
}), showdown.subParser('blockQuotes', function (e, t, n) {
    return e = n.converter._dispatch('blockQuotes.before', e, t, n), e = e.replace(/((^[ \t]{0,3}>[ \t]?.+\n(.+\n)*\n*)+)/gm, function (e, r) {
        var i = r;
        return i = i.replace(/^[ \t]*>[ \t]?/gm, '~0'), i = i.replace(/~0/g, ''), i = i.replace(/^[ \t]+$/gm, ''), i = showdown.subParser('githubCodeBlocks')(i, t, n), i = showdown.subParser('blockGamut')(i, t, n), i = i.replace(/(^|\n)/g, '$1  '), i = i.replace(/(\s*<pre>[^\r]+?<\/pre>)/gm, function (e, t) {
            var n = t;
            return n = n.replace(/^  /gm, '~0'), n = n.replace(/~0/g, ''), n;
        }), showdown.subParser('hashBlock')('<blockquote>\n' + i + '\n</blockquote>', t, n);
    }), e = n.converter._dispatch('blockQuotes.after', e, t, n), e;
}), showdown.subParser('codeBlocks', function (e, t, n) {
    e = n.converter._dispatch('codeBlocks.before', e, t, n), e += '~0';
    var r = /(?:\n\n|^)((?:(?:[ ]{4}|\t).*\n+)+)(\n*[ ]{0,3}[^ \t\n]|(?=~0))/g;
    return e = e.replace(r, function (e, r, i) {
        var s = r, o = i, u = '\n';
        return s = showdown.subParser('outdent')(s), s = showdown.subParser('encodeCode')(s), s = showdown.subParser('detab')(s), s = s.replace(/^\n+/g, ''), s = s.replace(/\n+$/g, ''), t.omitExtraWLInCodeBlocks && (u = ''), s = '<pre><code>' + s + u + '</code></pre>', showdown.subParser('hashBlock')(s, t, n) + o;
    }), e = e.replace(/~0/, ''), e = n.converter._dispatch('codeBlocks.after', e, t, n), e;
}), showdown.subParser('codeSpans', function (e, t, n) {
    return e = n.converter._dispatch('codeSpans.before', e, t, n), typeof e == 'undefined' && (e = ''), e = e.replace(/(^|[^\\])(`+)([^\r]*?[^`])\2(?!`)/gm, function (e, t, n, r) {
        var i = r;
        return i = i.replace(/^([ \t]*)/g, ''), i = i.replace(/[ \t]*$/g, ''), i = showdown.subParser('encodeCode')(i), t + '<code>' + i + '</code>';
    }), e = n.converter._dispatch('codeSpans.after', e, t, n), e;
}), showdown.subParser('detab', function (e) {
    return e = e.replace(/\t(?=\t)/g, '    '), e = e.replace(/\t/g, '~A~B'), e = e.replace(/~B(.+?)~A/g, function (e, t) {
        var n = t, r = 4 - n.length % 4;
        for (var i = 0; i < r; i++)
            n += ' ';
        return n;
    }), e = e.replace(/~A/g, '    '), e = e.replace(/~B/g, ''), e;
}), showdown.subParser('encodeAmpsAndAngles', function (e) {
    return e = e.replace(/&(?!#?[xX]?(?:[0-9a-fA-F]+|\w+);)/g, '&amp;'), e = e.replace(/<(?![a-z\/?\$!])/gi, '&lt;'), e;
}), showdown.subParser('encodeBackslashEscapes', function (e) {
    return e = e.replace(/\\(\\)/g, showdown.helper.escapeCharactersCallback), e = e.replace(/\\([`*_{}\[\]()>#+-.!])/g, showdown.helper.escapeCharactersCallback), e;
}), showdown.subParser('encodeCode', function (e) {
    return e = e.replace(/&/g, '&amp;'), e = e.replace(/</g, '&lt;'), e = e.replace(/>/g, '&gt;'), e = showdown.helper.escapeCharacters(e, '*_{}[]\\', !1), e;
}), showdown.subParser('encodeEmailAddress', function (e) {
    var t = [
        function (e) {
            return '&#' + e.charCodeAt(0) + ';';
        },
        function (e) {
            return '&#x' + e.charCodeAt(0).toString(16) + ';';
        },
        function (e) {
            return e;
        }
    ];
    return e = 'mailto:' + e, e = e.replace(/./g, function (e) {
        if (e === '@')
            e = t[Math.floor(Math.random() * 2)](e);
        else if (e !== ':') {
            var n = Math.random();
            e = n > 0.9 ? t[2](e) : n > 0.45 ? t[1](e) : t[0](e);
        }
        return e;
    }), e = '<a href="' + e + '">' + e + '</a>', e = e.replace(/">.+:/g, '">'), e;
}), showdown.subParser('escapeSpecialCharsWithinTagAttributes', function (e) {
    var t = /(<[a-z\/!$]("[^"]*"|'[^']*'|[^'">])*>|<!(--.*?--\s*)+>)/gi;
    return e = e.replace(t, function (e) {
        var t = e.replace(/(.)<\/?code>(?=.)/g, '$1`');
        return t = showdown.helper.escapeCharacters(t, '\\`*_', !1), t;
    }), e;
}), showdown.subParser('githubCodeBlocks', function (e, t, n) {
    return t.ghCodeBlocks ? (e = n.converter._dispatch('githubCodeBlocks.before', e, t, n), e += '~0', e = e.replace(/(?:^|\n)```(.*)\n([\s\S]*?)\n```/g, function (e, r, i) {
        var s = t.omitExtraWLInCodeBlocks ? '' : '\n';
        return i = showdown.subParser('encodeCode')(i), i = showdown.subParser('detab')(i), i = i.replace(/^\n+/g, ''), i = i.replace(/\n+$/g, ''), i = '<pre><code' + (r ? ' class="' + r + ' language-' + r + '"' : '') + '>' + i + s + '</code></pre>', i = showdown.subParser('hashBlock')(i, t, n), '\n\n~G' + (n.ghCodeBlocks.push({
            text: e,
            codeblock: i
        }) - 1) + 'G\n\n';
    }), e = e.replace(/~0/, ''), n.converter._dispatch('githubCodeBlocks.after', e, t, n)) : e;
}), showdown.subParser('hashBlock', function (e, t, n) {
    return e = e.replace(/(^\n+|\n+$)/g, ''), '\n\n~K' + (n.gHtmlBlocks.push(e) - 1) + 'K\n\n';
}), showdown.subParser('hashElement', function (e, t, n) {
    return function (e, t) {
        var r = t;
        return r = r.replace(/\n\n/g, '\n'), r = r.replace(/^\n/, ''), r = r.replace(/\n+$/g, ''), r = '\n\n~K' + (n.gHtmlBlocks.push(r) - 1) + 'K\n\n', r;
    };
}), showdown.subParser('hashHTMLBlocks', function (e, t, n) {
    var r = [
            'pre',
            'div',
            'h1',
            'h2',
            'h3',
            'h4',
            'h5',
            'h6',
            'blockquote',
            'table',
            'dl',
            'ol',
            'ul',
            'script',
            'noscript',
            'form',
            'fieldset',
            'iframe',
            'math',
            'style',
            'section',
            'header',
            'footer',
            'nav',
            'article',
            'aside',
            'address',
            'audio',
            'canvas',
            'figure',
            'hgroup',
            'output',
            'video',
            'p'
        ], i = function (e, t, r, i) {
            var s = e;
            return r.search(/\bmarkdown\b/) !== -1 && (s = r + n.converter.makeHtml(t) + i), '\n\n~K' + (n.gHtmlBlocks.push(s) - 1) + 'K\n\n';
        };
    for (var s = 0; s < r.length; ++s)
        e = showdown.helper.replaceRecursiveRegExp(e, i, '^(?: |\\t){0,3}<' + r[s] + '\\b[^>]*>', '</' + r[s] + '>', 'gim');
    return e = e.replace(/(\n[ ]{0,3}(<(hr)\b([^<>])*?\/?>)[ \t]*(?=\n{2,}))/g, showdown.subParser('hashElement')(e, t, n)), e = e.replace(/(<!--[\s\S]*?-->)/g, showdown.subParser('hashElement')(e, t, n)), e = e.replace(/(?:\n\n)([ ]{0,3}(?:<([?%])[^\r]*?\2>)[ \t]*(?=\n{2,}))/g, showdown.subParser('hashElement')(e, t, n)), e;
}), showdown.subParser('hashHTMLSpans', function (e, t, n) {
    var r = showdown.helper.matchRecursiveRegExp(e, '<code\\b[^>]*>', '</code>', 'gi');
    for (var i = 0; i < r.length; ++i)
        e = e.replace(r[i][0], '~L' + (n.gHtmlSpans.push(r[i][0]) - 1) + 'L');
    return e;
}), showdown.subParser('unhashHTMLSpans', function (e, t, n) {
    for (var r = 0; r < n.gHtmlSpans.length; ++r)
        e = e.replace('~L' + r + 'L', n.gHtmlSpans[r]);
    return e;
}), showdown.subParser('hashPreCodeTags', function (e, t, n) {
    var r = function (e, t, r, i) {
        var s = r + showdown.subParser('encodeCode')(t) + i;
        return '\n\n~G' + (n.ghCodeBlocks.push({
            text: e,
            codeblock: s
        }) - 1) + 'G\n\n';
    };
    return e = showdown.helper.replaceRecursiveRegExp(e, r, '^(?: |\\t){0,3}<pre\\b[^>]*>\\s*<code\\b[^>]*>', '^(?: |\\t){0,3}</code>\\s*</pre>', 'gim'), e;
}), showdown.subParser('headers', function (e, t, n) {
    function u(e) {
        var t, i = e.replace(/[^\w]/g, '').toLowerCase();
        return n.hashLinkCounts[i] ? t = i + '-' + n.hashLinkCounts[i]++ : (t = i, n.hashLinkCounts[i] = 1), r === !0 && (r = 'section'), showdown.helper.isString(r) ? r + t : t;
    }
    e = n.converter._dispatch('headers.before', e, t, n);
    var r = t.prefixHeaderId, i = isNaN(parseInt(t.headerLevelStart)) ? 1 : parseInt(t.headerLevelStart), s = t.smoothLivePreview ? /^(.+)[ \t]*\n={2,}[ \t]*\n+/gm : /^(.+)[ \t]*\n=+[ \t]*\n+/gm, o = t.smoothLivePreview ? /^(.+)[ \t]*\n-{2,}[ \t]*\n+/gm : /^(.+)[ \t]*\n-+[ \t]*\n+/gm;
    return e = e.replace(s, function (e, r) {
        var s = showdown.subParser('spanGamut')(r, t, n), o = t.noHeaderId ? '' : ' id="' + u(r) + '"', a = i, f = '<h' + a + o + '>' + s + '</h' + a + '>';
        return showdown.subParser('hashBlock')(f, t, n);
    }), e = e.replace(o, function (e, r) {
        var s = showdown.subParser('spanGamut')(r, t, n), o = t.noHeaderId ? '' : ' id="' + u(r) + '"', a = i + 1, f = '<h' + a + o + '>' + s + '</h' + a + '>';
        return showdown.subParser('hashBlock')(f, t, n);
    }), e = e.replace(/^(#{1,6})[ \t]*(.+?)[ \t]*#*\n+/gm, function (e, r, s) {
        var o = showdown.subParser('spanGamut')(s, t, n), a = t.noHeaderId ? '' : ' id="' + u(s) + '"', f = i - 1 + r.length, l = '<h' + f + a + '>' + o + '</h' + f + '>';
        return showdown.subParser('hashBlock')(l, t, n);
    }), e = n.converter._dispatch('headers.after', e, t, n), e;
}), showdown.subParser('images', function (e, t, n) {
    function s(e, t, r, i, s, o, u, a) {
        var f = n.gUrls, l = n.gTitles, c = n.gDimensions;
        r = r.toLowerCase(), a || (a = '');
        if (i === '' || i === null) {
            if (r === '' || r === null)
                r = t.toLowerCase().replace(/ ?\n/g, ' ');
            i = '#' + r;
            if (!!showdown.helper.isUndefined(f[r]))
                return e;
            i = f[r], showdown.helper.isUndefined(l[r]) || (a = l[r]), showdown.helper.isUndefined(c[r]) || (s = c[r].width, o = c[r].height);
        }
        t = t.replace(/"/g, '&quot;'), t = showdown.helper.escapeCharacters(t, '*_', !1), i = showdown.helper.escapeCharacters(i, '*_', !1);
        var h = '<img src="' + i + '" alt="' + t + '"';
        return a && (a = a.replace(/"/g, '&quot;'), a = showdown.helper.escapeCharacters(a, '*_', !1), h += ' title="' + a + '"'), s && o && (s = s === '*' ? 'auto' : s, o = o === '*' ? 'auto' : o, h += ' width="' + s + '"', h += ' height="' + o + '"'), h += ' />', h;
    }
    e = n.converter._dispatch('images.before', e, t, n);
    var r = /!\[(.*?)]\s?\([ \t]*()<?(\S+?)>?(?: =([*\d]+[A-Za-z%]{0,4})x([*\d]+[A-Za-z%]{0,4}))?[ \t]*(?:(['"])(.*?)\6[ \t]*)?\)/g, i = /!\[([^\]]*?)] ?(?:\n *)?\[(.*?)]()()()()()/g;
    return e = e.replace(i, s), e = e.replace(r, s), e = n.converter._dispatch('images.after', e, t, n), e;
}), showdown.subParser('italicsAndBold', function (e, t, n) {
    return e = n.converter._dispatch('italicsAndBold.before', e, t, n), t.literalMidWordUnderscores ? (e = e.replace(/(^|\s|>|\b)__(?=\S)([\s\S]+?)__(?=\b|<|\s|$)/gm, '$1<strong>$2</strong>'), e = e.replace(/(^|\s|>|\b)_(?=\S)([\s\S]+?)_(?=\b|<|\s|$)/gm, '$1<em>$2</em>'), e = e.replace(/(\*\*)(?=\S)([^\r]*?\S[*]*)\1/g, '<strong>$2</strong>'), e = e.replace(/(\*)(?=\S)([^\r]*?\S)\1/g, '<em>$2</em>')) : (e = e.replace(/(\*\*|__)(?=\S)([^\r]*?\S[*_]*)\1/g, '<strong>$2</strong>'), e = e.replace(/(\*|_)(?=\S)([^\r]*?\S)\1/g, '<em>$2</em>')), e = n.converter._dispatch('italicsAndBold.after', e, t, n), e;
}), showdown.subParser('lists', function (e, t, n) {
    function r(e, r) {
        n.gListLevel++, e = e.replace(/\n{2,}$/, '\n'), e += '~0';
        var i = /(\n)?(^[ \t]*)([*+-]|\d+[.])[ \t]+((\[(x|X| )?])?[ \t]*[^\r]+?(\n{1,2}))(?=\n*(~0|\2([*+-]|\d+[.])[ \t]+))/gm, s = /\n[ \t]*\n(?!~0)/.test(e);
        return e = e.replace(i, function (e, r, i, o, u, a, f) {
            f = f && f.trim() !== '';
            var l = showdown.subParser('outdent')(u, t, n), c = '';
            return a && t.tasklists && (c = ' class="task-list-item" style="list-style-type: none;"', l = l.replace(/^[ \t]*\[(x|X| )?]/m, function () {
                var e = '<input type="checkbox" disabled style="margin: 0px 0.35em 0.25em -1.6em; vertical-align: middle;"';
                return f && (e += ' checked'), e += '>', e;
            })), r || l.search(/\n{2,}/) > -1 ? (l = showdown.subParser('githubCodeBlocks')(l, t, n), l = showdown.subParser('blockGamut')(l, t, n)) : (l = showdown.subParser('lists')(l, t, n), l = l.replace(/\n$/, ''), s ? l = showdown.subParser('paragraphs')(l, t, n) : l = showdown.subParser('spanGamut')(l, t, n)), l = '\n<li' + c + '>' + l + '</li>\n', l;
        }), e = e.replace(/~0/g, ''), n.gListLevel--, r && (e = e.replace(/\s+$/, '')), e;
    }
    function i(e, t, n) {
        var i = t === 'ul' ? /^ {0,2}\d+\.[ \t]/gm : /^ {0,2}[*+-][ \t]/gm, s = [], o = '';
        if (e.search(i) !== -1) {
            (function a(e) {
                var s = e.search(i);
                s !== -1 ? (o += '\n\n<' + t + '>' + r(e.slice(0, s), !!n) + '</' + t + '>\n\n', t = t === 'ul' ? 'ol' : 'ul', i = t === 'ul' ? /^ {0,2}\d+\.[ \t]/gm : /^ {0,2}[*+-][ \t]/gm, a(e.slice(s))) : o += '\n\n<' + t + '>' + r(e, !!n) + '</' + t + '>\n\n';
            }(e));
            for (var u = 0; u < s.length; ++u);
        } else
            o = '\n\n<' + t + '>' + r(e, !!n) + '</' + t + '>\n\n';
        return o;
    }
    e = n.converter._dispatch('lists.before', e, t, n), e += '~0';
    var s = /^(([ ]{0,3}([*+-]|\d+[.])[ \t]+)[^\r]+?(~0|\n{2,}(?=\S)(?![ \t]*(?:[*+-]|\d+[.])[ \t]+)))/gm;
    return n.gListLevel ? e = e.replace(s, function (e, t, n) {
        var r = n.search(/[*+-]/g) > -1 ? 'ul' : 'ol';
        return i(t, r, !0);
    }) : (s = /(\n\n|^\n?)(([ ]{0,3}([*+-]|\d+[.])[ \t]+)[^\r]+?(~0|\n{2,}(?=\S)(?![ \t]*(?:[*+-]|\d+[.])[ \t]+)))/gm, e = e.replace(s, function (e, t, n, r) {
        var s = r.search(/[*+-]/g) > -1 ? 'ul' : 'ol';
        return i(n, s);
    })), e = e.replace(/~0/, ''), e = n.converter._dispatch('lists.after', e, t, n), e;
}), showdown.subParser('outdent', function (e) {
    return e = e.replace(/^(\t|[ ]{1,4})/gm, '~0'), e = e.replace(/~0/g, ''), e;
}), showdown.subParser('paragraphs', function (e, t, n) {
    e = n.converter._dispatch('paragraphs.before', e, t, n), e = e.replace(/^\n+/g, ''), e = e.replace(/\n+$/g, '');
    var r = e.split(/\n{2,}/g), i = [], s = r.length;
    for (var o = 0; o < s; o++) {
        var u = r[o];
        u.search(/~(K|G)(\d+)\1/g) >= 0 ? i.push(u) : (u = showdown.subParser('spanGamut')(u, t, n), u = u.replace(/^([ \t]*)/g, '<p>'), u += '</p>', i.push(u));
    }
    s = i.length;
    for (o = 0; o < s; o++) {
        var a = '', f = i[o], l = !1;
        while (f.search(/~(K|G)(\d+)\1/) >= 0) {
            var c = RegExp.$1, h = RegExp.$2;
            c === 'K' ? a = n.gHtmlBlocks[h] : l ? a = showdown.subParser('encodeCode')(n.ghCodeBlocks[h].text) : a = n.ghCodeBlocks[h].codeblock, a = a.replace(/\$/g, '$$$$'), f = f.replace(/(\n\n)?~(K|G)\d+\2(\n\n)?/, a), /^<pre\b[^>]*>\s*<code\b[^>]*>/.test(f) && (l = !0);
        }
        i[o] = f;
    }
    return e = i.join('\n\n'), e = e.replace(/^\n+/g, ''), e = e.replace(/\n+$/g, ''), n.converter._dispatch('paragraphs.after', e, t, n);
}), showdown.subParser('runExtension', function (e, t, n, r) {
    if (e.filter)
        t = e.filter(t, r.converter, n);
    else if (e.regex) {
        var i = e.regex;
        !i instanceof RegExp && (i = new RegExp(i, 'g')), t = t.replace(i, e.replace);
    }
    return t;
}), showdown.subParser('spanGamut', function (e, t, n) {
    return e = n.converter._dispatch('spanGamut.before', e, t, n), e = showdown.subParser('codeSpans')(e, t, n), e = showdown.subParser('escapeSpecialCharsWithinTagAttributes')(e, t, n), e = showdown.subParser('encodeBackslashEscapes')(e, t, n), e = showdown.subParser('images')(e, t, n), e = showdown.subParser('anchors')(e, t, n), e = showdown.subParser('autoLinks')(e, t, n), e = showdown.subParser('encodeAmpsAndAngles')(e, t, n), e = showdown.subParser('italicsAndBold')(e, t, n), e = showdown.subParser('strikethrough')(e, t, n), e = e.replace(/  +\n/g, ' <br />\n'), e = n.converter._dispatch('spanGamut.after', e, t, n), e;
}), showdown.subParser('strikethrough', function (e, t, n) {
    return t.strikethrough && (e = n.converter._dispatch('strikethrough.before', e, t, n), e = e.replace(/(?:~T){2}([\s\S]+?)(?:~T){2}/g, '<del>$1</del>'), e = n.converter._dispatch('strikethrough.after', e, t, n)), e;
}), showdown.subParser('stripBlankLines', function (e) {
    return e.replace(/^[ \t]+$/gm, '');
}), showdown.subParser('stripLinkDefinitions', function (e, t, n) {
    var r = /^ {0,3}\[(.+)]:[ \t]*\n?[ \t]*<?(\S+?)>?(?: =([*\d]+[A-Za-z%]{0,4})x([*\d]+[A-Za-z%]{0,4}))?[ \t]*\n?[ \t]*(?:(\n*)["|'(](.+?)["|')][ \t]*)?(?:\n+|(?=~0))/gm;
    return e += '~0', e = e.replace(r, function (e, r, i, s, o, u, a) {
        return r = r.toLowerCase(), n.gUrls[r] = showdown.subParser('encodeAmpsAndAngles')(i), u ? u + a : (a && (n.gTitles[r] = a.replace(/"|'/g, '&quot;')), t.parseImgDimensions && s && o && (n.gDimensions[r] = {
            width: s,
            height: o
        }), '');
    }), e = e.replace(/~0/, ''), e;
}), showdown.subParser('tables', function (e, t, n) {
    function i(e) {
        return /^:[ \t]*--*$/.test(e) ? ' style="text-align:left;"' : /^--*[ \t]*:[ \t]*$/.test(e) ? ' style="text-align:right;"' : /^:[ \t]*--*[ \t]*:$/.test(e) ? ' style="text-align:center;"' : '';
    }
    function s(e, r) {
        var i = '';
        return e = e.trim(), t.tableHeaderId && (i = ' id="' + e.replace(/ /g, '_').toLowerCase() + '"'), e = showdown.subParser('spanGamut')(e, t, n), '<th' + i + r + '>' + e + '</th>\n';
    }
    function o(e, r) {
        var i = showdown.subParser('spanGamut')(e, t, n);
        return '<td' + r + '>' + i + '</td>\n';
    }
    function u(e, t) {
        var n = '<table>\n<thead>\n<tr>\n', r = e.length;
        for (var i = 0; i < r; ++i)
            n += e[i];
        n += '</tr>\n</thead>\n<tbody>\n';
        for (i = 0; i < t.length; ++i) {
            n += '<tr>\n';
            for (var s = 0; s < r; ++s)
                n += t[i][s];
            n += '</tr>\n';
        }
        return n += '</tbody>\n</table>\n', n;
    }
    if (!t.tables)
        return e;
    var r = /^[ \t]{0,3}\|?.+\|.+\n[ \t]{0,3}\|?[ \t]*:?[ \t]*(?:-|=){2,}[ \t]*:?[ \t]*\|[ \t]*:?[ \t]*(?:-|=){2,}[\s\S]+?(?:\n\n|~0)/gm;
    return e = n.converter._dispatch('tables.before', e, t, n), e = e.replace(r, function (e) {
        var t, n = e.split('\n');
        for (t = 0; t < n.length; ++t)
            /^[ \t]{0,3}\|/.test(n[t]) && (n[t] = n[t].replace(/^[ \t]{0,3}\|/, '')), /\|[ \t]*$/.test(n[t]) && (n[t] = n[t].replace(/\|[ \t]*$/, ''));
        var r = n[0].split('|').map(function (e) {
                return e.trim();
            }), a = n[1].split('|').map(function (e) {
                return e.trim();
            }), f = [], l = [], c = [], h = [];
        n.shift(), n.shift();
        for (t = 0; t < n.length; ++t) {
            if (n[t].trim() === '')
                continue;
            f.push(n[t].split('|').map(function (e) {
                return e.trim();
            }));
        }
        if (r.length < a.length)
            return e;
        for (t = 0; t < a.length; ++t)
            c.push(i(a[t]));
        for (t = 0; t < r.length; ++t)
            showdown.helper.isUndefined(c[t]) && (c[t] = ''), l.push(s(r[t], c[t]));
        for (t = 0; t < f.length; ++t) {
            var p = [];
            for (var d = 0; d < l.length; ++d)
                showdown.helper.isUndefined(f[t][d]), p.push(o(f[t][d], c[d]));
            h.push(p);
        }
        return u(l, h);
    }), e = n.converter._dispatch('tables.after', e, t, n), e;
}), showdown.subParser('unescapeSpecialChars', function (e) {
    return e = e.replace(/~E(\d+)E/g, function (e, t) {
        var n = parseInt(t);
        return String.fromCharCode(n);
    }), e;
}), module.exports = showdown;